
/* This file was generated by Ragel. Your edits will be lost.
 *
 * This is a state machine implementation of String#unpack.
 * See http://github.com/rubinius/rapa.
 *
 * vim: filetype=cpp
 */

#include <sstream>

#include "vm/config.h"

#include "vm.hpp"
#include "object_utils.hpp"
#include "on_stack.hpp"
#include "object_memory.hpp"

#include "builtin/array.hpp"
#include "builtin/byte_array.hpp"
#include "builtin/encoding.hpp"
#include "builtin/exception.hpp"
#include "builtin/fixnum.hpp"
#include "builtin/float.hpp"
#include "builtin/string.hpp"

namespace rubinius {

  namespace unpack {
    void inline increment(native_int& index, native_int n, native_int limit) {
      if(index + n < limit) {
        index += n;
      } else {
        index = limit;
      }
    }

    uint16_t swap_2bytes(uint16_t x) {
      return ((((x)&0xff)<<8) | (((x)>>8)&0xff));
    }

    uint32_t swap_4bytes(uint32_t x) {
      return ((((x)&0xff)<<24)
             |(((x)>>24)&0xff)
             |(((x)&0x0000ff00)<<8)
             |(((x)&0x00ff0000)>>8));
    }

    uint64_t swap_8bytes(uint64_t x) {
      return ((((x)&0x00000000000000ffLL)<<56)
             |(((x)&0xff00000000000000LL)>>56)
             |(((x)&0x000000000000ff00LL)<<40)
             |(((x)&0x00ff000000000000LL)>>40)
             |(((x)&0x0000000000ff0000LL)<<24)
             |(((x)&0x0000ff0000000000LL)>>24)
             |(((x)&0x00000000ff000000LL)<<8)
             |(((x)&0x000000ff00000000LL)>>8));
    }

    float swap_float(const uint8_t* str) {
      uint32_t x;
      float y;

      memcpy(&x, str, sizeof(uint32_t));
      x = swap_4bytes(x);
      memcpy(&y, &x, sizeof(float));

      return y;
    }

    double swap_double(const uint8_t* str) {
      uint64_t x;
      double y;

      memcpy(&x, str, sizeof(uint64_t));
      x = swap_8bytes(x);
      memcpy(&y, &x, sizeof(double));

      return y;
    }

    inline int hex2num(char c) {
      switch (c) {
      case '0': case '1': case '2': case '3': case '4':
      case '5': case '6': case '7': case '8': case '9':
        return c - '0';
      case 'a': case 'b': case 'c':
      case 'd': case 'e': case 'f':
        return c - 'a' + 10;
      case 'A': case 'B': case 'C':
      case 'D': case 'E': case 'F':
        return c - 'A' + 10;
      default:
        return -1;
      }
    }

    String* quotable_printable(STATE, const char*& bytes,
                               const char* bytes_end, native_int remainder)
    {
      if(remainder == 0) {
        return String::create(state, 0, 0);
      }

      String* str = String::create(state, 0, remainder);
      uint8_t *buf = str->byte_address();

      while(bytes < bytes_end) {
        if(*bytes == '=') {
          if(++bytes == bytes_end)
            break;

          if(bytes+1 < bytes_end && bytes[0] == '\r' && bytes[1] == '\n')
            bytes++;

          if(*bytes != '\n') {
            int c1, c2;

            if((c1 = hex2num(*bytes)) == -1)
              break;
            if(++bytes == bytes_end)
              break;
            if((c2 = hex2num(*bytes)) == -1)
              break;
            *buf++ = c1 << 4 | c2;
          }
        } else {
          *buf++ = *bytes;
        }
        bytes++;
      }

      *buf = 0;
      str->num_bytes(state, Fixnum::from(buf - str->byte_address()));

      return str;
    }

    static signed const char b64_xtable[] = {
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63,
      52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1,
      -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
      15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
      -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
      41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
      -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
    };

    String* base64_decode(STATE, const char*& bytes,
                          const char* bytes_end, native_int remainder)
    {
      if(remainder == 0) {
        String* str = String::create(state, 0, 0);

        str->encoding(state, Encoding::ascii8bit_encoding(state));

        return str;
      }

      native_int num_bytes = (bytes_end - bytes) * 3 / 4;
      String* str = String::create(state, 0, num_bytes);
      uint8_t *buf = str->byte_address();

      int a = -1, b = -1, c = 0, d = 0;
      while(bytes < bytes_end) {
        b = c = d = -1;

        while((a = (int)b64_xtable[(int)(*bytes)]) == -1 && bytes < bytes_end)
          bytes++;
        if(bytes >= bytes_end)
          break;
        bytes++;

        while((b = (int)b64_xtable[(int)(*bytes)]) == -1 && bytes < bytes_end)
          bytes++;
        if(bytes >= bytes_end)
          break;
        bytes++;

        while((c = (int)b64_xtable[(int)(*bytes)]) == -1 && bytes < bytes_end) {
          if(*bytes == '=')
            break;
          bytes++;
        }
        if(*bytes == '=' || bytes >= bytes_end)
          break;
        bytes++;

        while((d = (int)b64_xtable[(int)(*bytes)]) == -1 && bytes < bytes_end) {
          if(*bytes == '=')
            break;
          bytes++;
        }
        if(*bytes == '=' || bytes >= bytes_end)
          break;
        bytes++;

        *buf++ = a << 2 | b >> 4;
        *buf++ = b << 4 | c >> 2;
        *buf++ = c << 6 | d;
      }

      if(a != -1 && b != -1) {
        if(c == -1 && *bytes == '=') {
          *buf++ = a << 2 | b >> 4;
        } else if(c != -1 && *bytes == '=') {
          *buf++ = a << 2 | b >> 4;
          *buf++ = b << 4 | c >> 2;
        }
      }

      *buf = 0;
      str->encoding(state, Encoding::ascii8bit_encoding(state));
      str->num_bytes(state, Fixnum::from(buf - str->byte_address()));
      return str;
    }

    String* uu_decode(STATE, const char*& bytes,
                      const char* bytes_end, native_int remainder)
    {
      if(remainder == 0) {
        return String::create(state, 0, 0);
      }

      native_int length = 0, num_bytes = (bytes_end - bytes) * 3 / 4;
      String* str = String::create(state, 0, num_bytes);
      uint8_t *buf = str->byte_address();

      while(bytes < bytes_end && *bytes > ' ' && *bytes < 'a') {
        native_int line = (*bytes++ - ' ') & 0x3f;
        length += line;
        if(length > num_bytes) {
          line -= length - num_bytes;
          length = num_bytes;
        }

        while(line > 0) {
          char values[4];
          int l = line > 3 ? 3 : line;

          for(int i = 0; i < 4; i++) {
            if(bytes < bytes_end && *bytes >= ' ') {
              values[i] = (*bytes++ - ' ') & 0x3f;
            } else {
              values[i] = 0;
            }
          }

          switch(l) {
          case 3:
            buf[2] = values[2] << 6 | values[3];
          case 2:
            buf[1] = values[1] << 4 | values[2] >> 2;
          case 1:
            buf[0] = values[0] << 2 | values[1] >> 4;
          }

          buf += l;
          line -= l;
        }

        if(*bytes == '\r') bytes++;
        if(*bytes == '\n') {
          bytes++;
        } else if(bytes < bytes_end && (bytes+1 == bytes_end || bytes[1] == '\n')) {
          // possible checksum byte
          bytes += 2;
        }
      }

      buf[length] = 0;
      str->num_bytes(state, Fixnum::from(length));
      return str;
    }

    static const uint32_t utf8_limits[] = {
      0x0,        /* 1 */
      0x80,       /* 2 */
      0x800,      /* 3 */
      0x10000,    /* 4 */
      0x200000,   /* 5 */
      0x4000000,  /* 6 */
      0x80000000, /* 7 */
    };

#define MALFORMED_UTF8_ERROR_SIZE 60

    void utf8_decode(STATE, Array* array,
                     const char* bytes, const char* bytes_end,
                     native_int count, native_int& index)
    {
      int length;

      for(; count > 0 && bytes < bytes_end; count--) {
        native_int remainder = bytes_end - bytes;
        uint32_t c = *bytes++ & 0xff, value = c;
        int n = 0;
        length = 1;

        if(value & 0x80) {
          if(!(value & 0x40)) {
            Exception::argument_error(state, "malformed UTF-8 character");
          }

          if(!(value & 0x20)) {
            n = 2;
            value &= 0x1f;
          } else if(!(value & 0x10)) {
            n = 3;
            value &= 0x0f;
          } else if(!(value & 0x08)) {
            n = 4;
            value &= 0x07;
          } else if(!(value & 0x04)) {
            n = 5;
            value &= 0x03;
          } else if(!(value & 0x02)) {
            n = 6;
            value &= 0x01;
          } else {
            Exception::argument_error(state, "malformed UTF-8 character");
          }

          if(n > remainder) {
            char error_msg[MALFORMED_UTF8_ERROR_SIZE];
            snprintf(error_msg, MALFORMED_UTF8_ERROR_SIZE,
                    "malformed UTF-8 character (expected %d bytes, given %d bytes)",
                    n, (int)remainder);
            Exception::argument_error(state, error_msg);
          }

          length = n--;
          if(n != 0) {
            while(n--) {
              c = *bytes++ & 0xff;
              if((c & 0xc0) != 0x80) {
                Exception::argument_error(state, "malformed UTF-8 character");
              } else {
                c &= 0x3f;
                value = value << 6 | c;
              }
            }
          }

          if(value < utf8_limits[length-1]) {
            Exception::argument_error(state, "redundant UTF-8 sequence");
          }
        }

        array->append(state, Integer::from(state, value));
        index += length;
      }
    }

    static const unsigned long ber_mask = 0xfeUL << ((sizeof(unsigned long) - 1) * 8);
    void ber_decode(STATE, Array* array,
                     const char*& bytes, const char* bytes_end,
                     native_int count, native_int& index)
    {
      Fixnum* base = Fixnum::from(128);
      unsigned long value = 0;

      while(count > 0 && bytes < bytes_end) {
        value <<= 7;
        value |= (*bytes & 0x7f);
        if(!(*bytes++ & 0x80)) {
          array->append(state, Integer::from(state, value));
          count--;
          value = 0;
        } else if(value & ber_mask) {
          Integer* result = Integer::from(state, value);

          while(bytes < bytes_end) {
            if(result->fixnum_p()) {
              result = as<Fixnum>(result)->mul(state, base);
            } else {
              result = as<Bignum>(result)->mul(state, base);
            }

            Fixnum* b = Fixnum::from(*bytes & 0x7f);
            if(result->fixnum_p()) {
              result = as<Fixnum>(result)->add(state, b);
            } else {
              result = as<Bignum>(result)->add(state, b);
            }

            if(!(*bytes++ & 0x80)) {
              if(result->fixnum_p()) {
                array->append(state, result);
              } else {
                array->append(state, Bignum::normalize(state, as<Bignum>(result)));
              }
              count--;
              value = 0;
              break;
            }
          }
        }
      }
    }

    String* bit_high(STATE, const char*& bytes, native_int count) {
      String* str = String::create(state, 0, count);
      uint8_t *buf = str->byte_address();
      int bits = 0;

      for(native_int i = 0; i < count; i++) {
        if(i & 7) {
          bits <<= 1;
        } else {
          bits = *bytes++;
        }

        buf[i] = (bits & 128) ? '1' : '0';
      }

      return str;
    }

    String* bit_low(STATE, const char*& bytes, native_int count) {
      String* str = String::create(state, 0, count);
      uint8_t *buf = str->byte_address();
      int bits = 0;

      for(native_int i = 0; i < count; i++) {
        if(i & 7) {
          bits >>= 1;
        } else {
          bits = *bytes++;
        }

        buf[i] = (bits & 1) ? '1' : '0';
      }

      return str;
    }

    static const char hexdigits[] = "0123456789abcdef0123456789ABCDEFx";

    String* hex_high(STATE, const char*& bytes, native_int count) {
      String* str = String::create(state, 0, count);
      uint8_t *buf = str->byte_address();
      int bits = 0;

      for(native_int i = 0; i < count; i++) {
        if(i & 1) {
          bits <<= 4;
        } else {
          bits = *bytes++;
        }

        buf[i] = unpack::hexdigits[(bits >> 4) & 15];
      }

      return str;
    }

    String* hex_low(STATE, const char*& bytes, native_int count) {
      String* str = String::create(state, 0, count);
      uint8_t *buf = str->byte_address();
      int bits = 0;

      for(native_int i = 0; i < count; i++) {
        if(i & 1) {
          bits >>= 4;
        } else {
          bits = *bytes++;
        }

        buf[i] = unpack::hexdigits[bits & 15];
      }

      return str;
    }

    ByteArray* prepare_directives(STATE, String* directives,
                                  const char** p, const char** pe)
    {
      native_int size = directives->byte_size();
      ByteArray* ba = ByteArray::create_pinned(state, size + 1);
      char* b = reinterpret_cast<char*>(ba->raw_bytes());
      char* d = reinterpret_cast<char*>(directives->byte_address());
      int i = 0, j = 0;

      while(i < size) {
        switch(d[i]) {
        case 0:
        case ' ':
        case '\t':
        case '\n':
        case '\v':
        case '\f':
        case '\r':
          i++;
          break;
        case '#':
          while(++i < size && d[i] != '\n')
            ; // ignore
          if(d[i] == '\n') i++;
          break;
        default:
          b[j++] = d[i++];
          break;
        }
      }

      *p = const_cast<const char*>(b);
      *pe = *p + j;

      return ba;
    }

    void outside_of_string(STATE, const char c) {
      std::ostringstream msg;
      msg << c << " outside of string";
      Exception::argument_error(state, msg.str().c_str());
    }

    void non_native_error(STATE, const char c) {
      std::ostringstream msg;
      msg << "'" << c << "' allowed only after types sSiIlL";
      Exception::argument_error(state, msg.str().c_str());
    }
  }

#define unpack_elements(create, bits)                     \
  for(; index < stop; index += width) {                   \
    const uint8_t* bytes = self->byte_address() + index;  \
    array->append(state, create(bits(bytes)));            \
    if(count > 0) count--;                                \
  }

#define UNPACK_ELEMENTS unpack_elements
#define unpack_integer(b)         unpack_elements(new_integer, b)
#define unpack_float_elements(b)  unpack_elements(new_float, b)

#define FIXNUM(b)         (Fixnum::from(b))
#define INTEGER(b)        (Integer::from(state, b))

#define new_integer(b)    (Integer::from(state, b))
#define new_float(b)      (Float::create(state, b))

#define sbyte(p)          (*(int8_t*)(p))
#define ubyte(p)          (*(uint8_t*)(p))

#define s2bytes(p)        (*(int16_t*)(p))
#define u2bytes(p)        (*(uint16_t*)(p))

#define s4bytes(p)        (*(int32_t*)(p))
#define u4bytes(p)        (*(uint32_t*)(p))

#define s8bytes(p)        (*(int64_t*)(p))
#define u8bytes(p)        (*(uint64_t*)(p))

#define float_bits(p)     (*(float*)(p))
#define double_bits(p)    (*(double*)(p))

#ifdef RBX_LITTLE_ENDIAN

# define s2bytes_le(p)            (s2bytes(p))
# define u2bytes_le(p)            (u2bytes(p))
# define s4bytes_le(p)            (s4bytes(p))
# define u4bytes_le(p)            (u4bytes(p))
# define s8bytes_le(p)            (s8bytes(p))
# define u8bytes_le(p)            (u8bytes(p))

# define s2bytes_be(p)            ((int16_t)(unpack::swap_2bytes(u2bytes(p))))
# define u2bytes_be(p)            ((uint16_t)(unpack::swap_2bytes(u2bytes(p))))
# define s4bytes_be(p)            ((int32_t)(unpack::swap_4bytes(u4bytes(p))))
# define u4bytes_be(p)            ((uint32_t)(unpack::swap_4bytes(u4bytes(p))))
# define s8bytes_be(p)            ((int64_t)(unpack::swap_8bytes(u8bytes(p))))
# define u8bytes_be(p)            ((uint64_t)(unpack::swap_8bytes(u8bytes(p))))

# define unpack_double            unpack_double_le
# define unpack_float             unpack_float_le

# define unpack_double_le         unpack_float_elements(double_bits)
# define unpack_float_le          unpack_float_elements(float_bits)

# define unpack_double_be         unpack_float_elements(unpack::swap_double)
# define unpack_float_be          unpack_float_elements(unpack::swap_float)

#else // Big endian

# define s2bytes_le(p)            ((int16_t)(unpack::swap_2bytes(u2bytes(p))))
# define u2bytes_le(p)            ((uint16_t)(unpack::swap_2bytes(u2bytes(p))))
# define s4bytes_le(p)            ((int32_t)(unpack::swap_4bytes(u4bytes(p))))
# define u4bytes_le(p)            ((uint32_t)(unpack::swap_4bytes(u4bytes(p))))
# define s8bytes_le(p)            ((int64_t)(unpack::swap_8bytes(u8bytes(p))))
# define u8bytes_le(p)            ((uint64_t)(unpack::swap_8bytes(u8bytes(p))))

# define s2bytes_be(p)            (s2bytes(p))
# define u2bytes_be(p)            (u2bytes(p))
# define s4bytes_be(p)            (s4bytes(p))
# define u4bytes_be(p)            (u4bytes(p))
# define s8bytes_be(p)            (s8bytes(p))
# define u8bytes_be(p)            (u8bytes(p))

# define unpack_double            unpack_double_be
# define unpack_float             unpack_float_be

# define unpack_double_le         unpack_float_elements(unpack::swap_double)
# define unpack_float_le          unpack_float_elements(unpack::swap_float)

# define unpack_double_be         unpack_float_elements(double_bits)
# define unpack_float_be          unpack_float_elements(float_bits)

#endif

  Array* String::unpack(STATE, String* directives) {
    // Ragel-specific variables
    const char* p;
    const char* pe;
    ByteArray* d = unpack::prepare_directives(state, directives, &p, &pe);
    const char *eof = pe;
    int cs;

    // pack-specific variables
    String* self = this;
    Array* array = Array::create(state, 0);
    OnStack<3> sv(state, self, array, d);
    const char* bytes = 0;
    const char* bytes_end = 0;

    native_int bytes_size = self->byte_size();
    native_int index UNUSED = 0;
    native_int stop = 0;
    native_int width = 0;
    native_int count UNUSED = 0;
    native_int remainder = 0;
    bool rest UNUSED = false;


static const char _actions[] = {
	0, 1, 0, 1, 1, 1, 2, 1, 
	80, 1, 81, 2, 0, 4, 3, 54, 
	57, 0, 3, 54, 57, 81, 3, 55, 
	57, 0, 3, 55, 57, 81, 3, 56, 
	57, 0, 3, 56, 57, 81, 4, 3, 
	54, 57, 0, 4, 3, 54, 57, 81, 
	4, 3, 55, 57, 0, 4, 3, 55, 
	57, 81, 4, 3, 56, 57, 0, 4, 
	3, 56, 57, 81, 4, 54, 57, 0, 
	4, 4, 55, 57, 0, 4, 4, 56, 
	57, 0, 4, 5, 3, 54, 57, 0, 
	4, 5, 3, 55, 57, 0, 4, 5, 
	3, 56, 57, 0, 4, 5, 5, 10, 
	12, 11, 0, 5, 5, 10, 12, 11, 
	81, 5, 5, 10, 13, 11, 0, 5, 
	5, 10, 13, 11, 81, 5, 6, 10, 
	14, 11, 0, 5, 6, 10, 14, 11, 
	81, 5, 6, 10, 15, 11, 0, 5, 
	6, 10, 15, 11, 81, 5, 6, 10, 
	16, 11, 0, 5, 6, 10, 16, 11, 
	81, 5, 6, 10, 17, 11, 0, 5, 
	6, 10, 17, 11, 81, 5, 6, 10, 
	18, 11, 0, 5, 6, 10, 18, 11, 
	81, 5, 6, 10, 19, 11, 0, 5, 
	6, 10, 19, 11, 81, 5, 6, 10, 
	39, 11, 0, 5, 6, 10, 39, 11, 
	81, 5, 6, 10, 41, 11, 0, 5, 
	6, 10, 41, 11, 81, 5, 7, 10, 
	20, 11, 0, 5, 7, 10, 20, 11, 
	81, 5, 7, 10, 21, 11, 0, 5, 
	7, 10, 21, 11, 81, 5, 7, 10, 
	22, 11, 0, 5, 7, 10, 22, 11, 
	81, 5, 7, 10, 23, 11, 0, 5, 
	7, 10, 23, 11, 81, 5, 7, 10, 
	24, 11, 0, 5, 7, 10, 24, 11, 
	81, 5, 7, 10, 25, 11, 0, 5, 
	7, 10, 25, 11, 81, 5, 7, 10, 
	26, 11, 0, 5, 7, 10, 26, 11, 
	81, 5, 7, 10, 28, 11, 0, 5, 
	7, 10, 28, 11, 81, 5, 7, 10, 
	29, 11, 0, 5, 7, 10, 29, 11, 
	81, 5, 7, 10, 32, 11, 0, 5, 
	7, 10, 32, 11, 81, 5, 7, 10, 
	34, 11, 0, 5, 7, 10, 34, 11, 
	81, 5, 7, 10, 35, 11, 0, 5, 
	7, 10, 35, 11, 81, 5, 7, 10, 
	38, 11, 0, 5, 7, 10, 38, 11, 
	81, 5, 7, 10, 40, 11, 0, 5, 
	7, 10, 40, 11, 81, 5, 7, 10, 
	50, 11, 0, 5, 7, 10, 50, 11, 
	81, 5, 7, 10, 51, 11, 0, 5, 
	7, 10, 51, 11, 81, 5, 7, 10, 
	53, 11, 0, 5, 7, 10, 53, 11, 
	81, 5, 8, 10, 42, 11, 0, 5, 
	8, 10, 42, 11, 81, 5, 8, 10, 
	43, 11, 0, 5, 8, 10, 43, 11, 
	81, 5, 8, 10, 44, 11, 0, 5, 
	8, 10, 44, 11, 81, 5, 8, 10, 
	45, 11, 0, 5, 8, 10, 45, 11, 
	81, 5, 8, 10, 46, 11, 0, 5, 
	8, 10, 46, 11, 81, 5, 8, 10, 
	47, 11, 0, 5, 8, 10, 47, 11, 
	81, 5, 8, 10, 48, 11, 0, 5, 
	8, 10, 48, 11, 81, 5, 8, 10, 
	49, 11, 0, 5, 8, 10, 49, 11, 
	81, 5, 8, 10, 52, 11, 0, 5, 
	8, 10, 52, 11, 81, 5, 9, 10, 
	27, 11, 0, 5, 9, 10, 27, 11, 
	81, 5, 9, 10, 30, 11, 0, 5, 
	9, 10, 30, 11, 81, 5, 9, 10, 
	31, 11, 0, 5, 9, 10, 31, 11, 
	81, 5, 9, 10, 33, 11, 0, 5, 
	9, 10, 33, 11, 81, 5, 9, 10, 
	36, 11, 0, 5, 9, 10, 36, 11, 
	81, 5, 9, 10, 37, 11, 0, 5, 
	9, 10, 37, 11, 81, 5, 9, 10, 
	69, 11, 0, 5, 9, 10, 69, 11, 
	81, 6, 3, 5, 10, 12, 11, 0, 
	6, 3, 5, 10, 12, 11, 81, 6, 
	3, 5, 10, 13, 11, 0, 6, 3, 
	5, 10, 13, 11, 81, 6, 3, 6, 
	10, 14, 11, 0, 6, 3, 6, 10, 
	14, 11, 81, 6, 3, 6, 10, 15, 
	11, 0, 6, 3, 6, 10, 15, 11, 
	81, 6, 3, 6, 10, 16, 11, 0, 
	6, 3, 6, 10, 16, 11, 81, 6, 
	3, 6, 10, 17, 11, 0, 6, 3, 
	6, 10, 17, 11, 81, 6, 3, 6, 
	10, 18, 11, 0, 6, 3, 6, 10, 
	18, 11, 81, 6, 3, 6, 10, 19, 
	11, 0, 6, 3, 6, 10, 19, 11, 
	81, 6, 3, 6, 10, 39, 11, 0, 
	6, 3, 6, 10, 39, 11, 81, 6, 
	3, 6, 10, 41, 11, 0, 6, 3, 
	6, 10, 41, 11, 81, 6, 3, 7, 
	10, 20, 11, 0, 6, 3, 7, 10, 
	20, 11, 81, 6, 3, 7, 10, 21, 
	11, 0, 6, 3, 7, 10, 21, 11, 
	81, 6, 3, 7, 10, 22, 11, 0, 
	6, 3, 7, 10, 22, 11, 81, 6, 
	3, 7, 10, 23, 11, 0, 6, 3, 
	7, 10, 23, 11, 81, 6, 3, 7, 
	10, 24, 11, 0, 6, 3, 7, 10, 
	24, 11, 81, 6, 3, 7, 10, 25, 
	11, 0, 6, 3, 7, 10, 25, 11, 
	81, 6, 3, 7, 10, 26, 11, 0, 
	6, 3, 7, 10, 26, 11, 81, 6, 
	3, 7, 10, 28, 11, 0, 6, 3, 
	7, 10, 28, 11, 81, 6, 3, 7, 
	10, 29, 11, 0, 6, 3, 7, 10, 
	29, 11, 81, 6, 3, 7, 10, 32, 
	11, 0, 6, 3, 7, 10, 32, 11, 
	81, 6, 3, 7, 10, 34, 11, 0, 
	6, 3, 7, 10, 34, 11, 81, 6, 
	3, 7, 10, 35, 11, 0, 6, 3, 
	7, 10, 35, 11, 81, 6, 3, 7, 
	10, 38, 11, 0, 6, 3, 7, 10, 
	38, 11, 81, 6, 3, 7, 10, 40, 
	11, 0, 6, 3, 7, 10, 40, 11, 
	81, 6, 3, 7, 10, 50, 11, 0, 
	6, 3, 7, 10, 50, 11, 81, 6, 
	3, 7, 10, 51, 11, 0, 6, 3, 
	7, 10, 51, 11, 81, 6, 3, 7, 
	10, 53, 11, 0, 6, 3, 7, 10, 
	53, 11, 81, 6, 3, 8, 10, 42, 
	11, 0, 6, 3, 8, 10, 42, 11, 
	81, 6, 3, 8, 10, 43, 11, 0, 
	6, 3, 8, 10, 43, 11, 81, 6, 
	3, 8, 10, 44, 11, 0, 6, 3, 
	8, 10, 44, 11, 81, 6, 3, 8, 
	10, 45, 11, 0, 6, 3, 8, 10, 
	45, 11, 81, 6, 3, 8, 10, 46, 
	11, 0, 6, 3, 8, 10, 46, 11, 
	81, 6, 3, 8, 10, 47, 11, 0, 
	6, 3, 8, 10, 47, 11, 81, 6, 
	3, 8, 10, 48, 11, 0, 6, 3, 
	8, 10, 48, 11, 81, 6, 3, 8, 
	10, 49, 11, 0, 6, 3, 8, 10, 
	49, 11, 81, 6, 3, 8, 10, 52, 
	11, 0, 6, 3, 8, 10, 52, 11, 
	81, 6, 3, 9, 10, 27, 11, 0, 
	6, 3, 9, 10, 27, 11, 81, 6, 
	3, 9, 10, 30, 11, 0, 6, 3, 
	9, 10, 30, 11, 81, 6, 3, 9, 
	10, 31, 11, 0, 6, 3, 9, 10, 
	31, 11, 81, 6, 3, 9, 10, 33, 
	11, 0, 6, 3, 9, 10, 33, 11, 
	81, 6, 3, 9, 10, 36, 11, 0, 
	6, 3, 9, 10, 36, 11, 81, 6, 
	3, 9, 10, 37, 11, 0, 6, 3, 
	9, 10, 37, 11, 81, 6, 3, 9, 
	10, 69, 11, 0, 6, 3, 9, 10, 
	69, 11, 81, 6, 5, 10, 12, 11, 
	0, 4, 6, 5, 10, 13, 11, 0, 
	4, 6, 6, 10, 14, 11, 0, 4, 
	6, 6, 10, 15, 11, 0, 4, 6, 
	6, 10, 16, 11, 0, 4, 6, 6, 
	10, 17, 11, 0, 4, 6, 6, 10, 
	18, 11, 0, 4, 6, 6, 10, 19, 
	11, 0, 4, 6, 6, 10, 39, 11, 
	0, 4, 6, 6, 10, 41, 11, 0, 
	4, 6, 7, 10, 20, 11, 0, 4, 
	6, 7, 10, 21, 11, 0, 4, 6, 
	7, 10, 22, 11, 0, 4, 6, 7, 
	10, 23, 11, 0, 4, 6, 7, 10, 
	24, 11, 0, 4, 6, 7, 10, 25, 
	11, 0, 4, 6, 7, 10, 26, 11, 
	0, 4, 6, 7, 10, 28, 11, 0, 
	4, 6, 7, 10, 29, 11, 0, 4, 
	6, 7, 10, 32, 11, 0, 4, 6, 
	7, 10, 34, 11, 0, 4, 6, 7, 
	10, 35, 11, 0, 4, 6, 7, 10, 
	38, 11, 0, 4, 6, 7, 10, 40, 
	11, 0, 4, 6, 7, 10, 50, 11, 
	0, 4, 6, 7, 10, 51, 11, 0, 
	4, 6, 7, 10, 53, 11, 0, 4, 
	6, 8, 10, 42, 11, 0, 4, 6, 
	8, 10, 43, 11, 0, 4, 6, 8, 
	10, 44, 11, 0, 4, 6, 8, 10, 
	45, 11, 0, 4, 6, 8, 10, 46, 
	11, 0, 4, 6, 8, 10, 47, 11, 
	0, 4, 6, 8, 10, 48, 11, 0, 
	4, 6, 8, 10, 49, 11, 0, 4, 
	6, 8, 10, 52, 11, 0, 4, 6, 
	9, 10, 27, 11, 0, 4, 6, 9, 
	10, 30, 11, 0, 4, 6, 9, 10, 
	31, 11, 0, 4, 6, 9, 10, 33, 
	11, 0, 4, 6, 9, 10, 36, 11, 
	0, 4, 6, 9, 10, 37, 11, 0, 
	4, 6, 9, 10, 69, 11, 0, 4, 
	6, 58, 59, 63, 64, 77, 0, 6, 
	58, 59, 63, 64, 77, 81, 6, 58, 
	59, 63, 64, 79, 0, 6, 58, 59, 
	63, 64, 79, 81, 6, 58, 59, 63, 
	75, 70, 0, 6, 58, 59, 63, 75, 
	70, 81, 6, 58, 59, 63, 76, 70, 
	0, 6, 58, 59, 63, 76, 70, 81, 
	6, 58, 59, 63, 78, 70, 0, 6, 
	58, 59, 63, 78, 70, 81, 6, 58, 
	60, 63, 65, 66, 0, 6, 58, 60, 
	63, 65, 66, 81, 6, 58, 60, 63, 
	65, 67, 0, 6, 58, 60, 63, 65, 
	67, 81, 6, 58, 60, 63, 65, 68, 
	0, 6, 58, 60, 63, 65, 68, 81, 
	7, 3, 5, 10, 12, 11, 0, 4, 
	7, 3, 5, 10, 13, 11, 0, 4, 
	7, 3, 6, 10, 14, 11, 0, 4, 
	7, 3, 6, 10, 15, 11, 0, 4, 
	7, 3, 6, 10, 16, 11, 0, 4, 
	7, 3, 6, 10, 17, 11, 0, 4, 
	7, 3, 6, 10, 18, 11, 0, 4, 
	7, 3, 6, 10, 19, 11, 0, 4, 
	7, 3, 6, 10, 39, 11, 0, 4, 
	7, 3, 6, 10, 41, 11, 0, 4, 
	7, 3, 7, 10, 20, 11, 0, 4, 
	7, 3, 7, 10, 21, 11, 0, 4, 
	7, 3, 7, 10, 22, 11, 0, 4, 
	7, 3, 7, 10, 23, 11, 0, 4, 
	7, 3, 7, 10, 24, 11, 0, 4, 
	7, 3, 7, 10, 25, 11, 0, 4, 
	7, 3, 7, 10, 26, 11, 0, 4, 
	7, 3, 7, 10, 28, 11, 0, 4, 
	7, 3, 7, 10, 29, 11, 0, 4, 
	7, 3, 7, 10, 32, 11, 0, 4, 
	7, 3, 7, 10, 34, 11, 0, 4, 
	7, 3, 7, 10, 35, 11, 0, 4, 
	7, 3, 7, 10, 38, 11, 0, 4, 
	7, 3, 7, 10, 40, 11, 0, 4, 
	7, 3, 7, 10, 50, 11, 0, 4, 
	7, 3, 7, 10, 51, 11, 0, 4, 
	7, 3, 7, 10, 53, 11, 0, 4, 
	7, 3, 8, 10, 42, 11, 0, 4, 
	7, 3, 8, 10, 43, 11, 0, 4, 
	7, 3, 8, 10, 44, 11, 0, 4, 
	7, 3, 8, 10, 45, 11, 0, 4, 
	7, 3, 8, 10, 46, 11, 0, 4, 
	7, 3, 8, 10, 47, 11, 0, 4, 
	7, 3, 8, 10, 48, 11, 0, 4, 
	7, 3, 8, 10, 49, 11, 0, 4, 
	7, 3, 8, 10, 52, 11, 0, 4, 
	7, 3, 9, 10, 27, 11, 0, 4, 
	7, 3, 9, 10, 30, 11, 0, 4, 
	7, 3, 9, 10, 31, 11, 0, 4, 
	7, 3, 9, 10, 33, 11, 0, 4, 
	7, 3, 9, 10, 36, 11, 0, 4, 
	7, 3, 9, 10, 37, 11, 0, 4, 
	7, 3, 9, 10, 69, 11, 0, 4, 
	7, 3, 58, 59, 63, 64, 77, 0, 
	7, 3, 58, 59, 63, 64, 77, 81, 
	7, 3, 58, 59, 63, 64, 79, 0, 
	7, 3, 58, 59, 63, 64, 79, 81, 
	7, 3, 58, 59, 63, 75, 70, 0, 
	7, 3, 58, 59, 63, 75, 70, 81, 
	7, 3, 58, 59, 63, 76, 70, 0, 
	7, 3, 58, 59, 63, 76, 70, 81, 
	7, 3, 58, 59, 63, 78, 70, 0, 
	7, 3, 58, 59, 63, 78, 70, 81, 
	7, 3, 58, 60, 63, 65, 66, 0, 
	7, 3, 58, 60, 63, 65, 66, 81, 
	7, 3, 58, 60, 63, 65, 67, 0, 
	7, 3, 58, 60, 63, 65, 67, 81, 
	7, 3, 58, 60, 63, 65, 68, 0, 
	7, 3, 58, 60, 63, 65, 68, 81, 
	7, 58, 59, 63, 64, 77, 0, 4, 
	7, 58, 59, 63, 64, 79, 0, 4, 
	7, 58, 59, 63, 75, 70, 0, 4, 
	7, 58, 59, 63, 76, 70, 0, 4, 
	7, 58, 59, 63, 78, 70, 0, 4, 
	7, 58, 60, 63, 65, 66, 0, 4, 
	7, 58, 60, 63, 65, 67, 0, 4, 
	7, 58, 60, 63, 65, 68, 0, 4, 
	7, 58, 61, 63, 65, 71, 70, 0, 
	7, 58, 61, 63, 65, 71, 70, 81, 
	7, 58, 61, 63, 65, 72, 70, 0, 
	7, 58, 61, 63, 65, 72, 70, 81, 
	7, 58, 62, 63, 65, 73, 70, 0, 
	7, 58, 62, 63, 65, 73, 70, 81, 
	7, 58, 62, 63, 65, 74, 70, 0, 
	7, 58, 62, 63, 65, 74, 70, 81, 
	8, 3, 58, 59, 63, 64, 77, 0, 
	4, 8, 3, 58, 59, 63, 64, 79, 
	0, 4, 8, 3, 58, 59, 63, 75, 
	70, 0, 4, 8, 3, 58, 59, 63, 
	76, 70, 0, 4, 8, 3, 58, 59, 
	63, 78, 70, 0, 4, 8, 3, 58, 
	60, 63, 65, 66, 0, 4, 8, 3, 
	58, 60, 63, 65, 67, 0, 4, 8, 
	3, 58, 60, 63, 65, 68, 0, 4, 
	8, 3, 58, 61, 63, 65, 71, 70, 
	0, 8, 3, 58, 61, 63, 65, 71, 
	70, 81, 8, 3, 58, 61, 63, 65, 
	72, 70, 0, 8, 3, 58, 61, 63, 
	65, 72, 70, 81, 8, 3, 58, 62, 
	63, 65, 73, 70, 0, 8, 3, 58, 
	62, 63, 65, 73, 70, 81, 8, 3, 
	58, 62, 63, 65, 74, 70, 0, 8, 
	3, 58, 62, 63, 65, 74, 70, 81, 
	8, 58, 61, 63, 65, 71, 70, 0, 
	4, 8, 58, 61, 63, 65, 72, 70, 
	0, 4, 8, 58, 62, 63, 65, 73, 
	70, 0, 4, 8, 58, 62, 63, 65, 
	74, 70, 0, 4, 9, 3, 58, 61, 
	63, 65, 71, 70, 0, 4, 9, 3, 
	58, 61, 63, 65, 72, 70, 0, 4, 
	9, 3, 58, 62, 63, 65, 73, 70, 
	0, 4, 9, 3, 58, 62, 63, 65, 
	74, 70, 0, 4
};

static const char _trans_keys[] = {
	0, 0, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 
	33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 
	33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 42, 120, 64, 120, 33, 120, 
	42, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 
	33, 120, 64, 120, 33, 120, 42, 120, 64, 120, 33, 120, 64, 120, 33, 120, 
	64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 
	64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 
	64, 120, 33, 120, 42, 120, 64, 120, 33, 120, 42, 120, 64, 120, 33, 120, 
	64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 42, 120, 64, 120, 
	33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 33, 120, 64, 120, 
	64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 
	48, 120, 42, 120, 64, 120, 48, 120, 42, 120, 64, 120, 48, 120, 33, 120, 
	33, 120, 64, 120, 48, 120, 33, 120, 64, 120, 64, 120, 48, 120, 33, 120, 
	64, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 48, 120, 
	42, 120, 64, 120, 48, 120, 42, 120, 64, 120, 48, 120, 64, 120, 48, 120, 
	33, 120, 64, 120, 48, 120, 33, 120, 64, 120, 48, 120, 48, 120, 42, 120, 
	64, 120, 48, 120, 42, 120, 64, 120, 48, 120, 33, 120, 33, 120, 64, 120, 
	48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 
	48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 
	48, 120, 64, 120, 48, 120, 48, 120, 42, 120, 64, 120, 48, 120, 42, 120, 
	64, 120, 48, 120, 33, 120, 33, 120, 64, 120, 48, 120, 33, 120, 64, 120, 
	64, 120, 48, 120, 33, 120, 64, 120, 64, 120, 48, 120, 64, 120, 48, 120, 
	64, 120, 48, 120, 64, 120, 48, 120, 48, 120, 42, 120, 64, 120, 48, 120, 
	42, 120, 64, 120, 48, 120, 64, 120, 48, 120, 33, 120, 64, 120, 48, 120, 
	33, 120, 64, 120, 48, 120, 48, 120, 42, 120, 64, 120, 48, 120, 42, 120, 
	64, 120, 48, 120, 33, 120, 33, 120, 64, 120, 48, 120, 64, 120, 48, 120, 
	64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 
	64, 120, 48, 120, 64, 120, 48, 120, 64, 120, 48, 120, 0
};

static const char _key_spans[] = {
	0, 57, 88, 57, 88, 57, 88, 57, 
	88, 57, 88, 57, 88, 57, 88, 57, 
	88, 57, 88, 57, 88, 79, 57, 88, 
	79, 57, 88, 57, 88, 57, 88, 57, 
	88, 57, 88, 79, 57, 88, 57, 88, 
	57, 88, 57, 88, 57, 88, 57, 88, 
	57, 88, 57, 88, 57, 88, 57, 88, 
	57, 88, 79, 57, 88, 79, 57, 88, 
	57, 88, 57, 88, 57, 88, 79, 57, 
	88, 57, 88, 57, 88, 57, 88, 57, 
	57, 73, 57, 73, 57, 73, 57, 73, 
	73, 79, 57, 73, 79, 57, 73, 88, 
	88, 57, 73, 88, 57, 57, 73, 88, 
	57, 57, 73, 57, 73, 57, 73, 73, 
	79, 57, 73, 79, 57, 73, 57, 73, 
	88, 57, 73, 88, 57, 73, 73, 79, 
	57, 73, 79, 57, 73, 88, 88, 57, 
	73, 57, 73, 57, 73, 57, 73, 57, 
	73, 57, 73, 57, 73, 57, 73, 57, 
	73, 57, 73, 73, 79, 57, 73, 79, 
	57, 73, 88, 88, 57, 73, 88, 57, 
	57, 73, 88, 57, 57, 73, 57, 73, 
	57, 73, 57, 73, 73, 79, 57, 73, 
	79, 57, 73, 57, 73, 88, 57, 73, 
	88, 57, 73, 73, 79, 57, 73, 79, 
	57, 73, 88, 88, 57, 73, 57, 73, 
	57, 73, 57, 73, 57, 73, 57, 73, 
	57, 73, 57, 73, 57, 73
};

static const short _index_offsets[] = {
	0, 0, 58, 147, 205, 294, 352, 441, 
	499, 588, 646, 735, 793, 882, 940, 1029, 
	1087, 1176, 1234, 1323, 1381, 1470, 1550, 1608, 
	1697, 1777, 1835, 1924, 1982, 2071, 2129, 2218, 
	2276, 2365, 2423, 2512, 2592, 2650, 2739, 2797, 
	2886, 2944, 3033, 3091, 3180, 3238, 3327, 3385, 
	3474, 3532, 3621, 3679, 3768, 3826, 3915, 3973, 
	4062, 4120, 4209, 4289, 4347, 4436, 4516, 4574, 
	4663, 4721, 4810, 4868, 4957, 5015, 5104, 5184, 
	5242, 5331, 5389, 5478, 5536, 5625, 5683, 5772, 
	5830, 5888, 5962, 6020, 6094, 6152, 6226, 6284, 
	6358, 6432, 6512, 6570, 6644, 6724, 6782, 6856, 
	6945, 7034, 7092, 7166, 7255, 7313, 7371, 7445, 
	7534, 7592, 7650, 7724, 7782, 7856, 7914, 7988, 
	8062, 8142, 8200, 8274, 8354, 8412, 8486, 8544, 
	8618, 8707, 8765, 8839, 8928, 8986, 9060, 9134, 
	9214, 9272, 9346, 9426, 9484, 9558, 9647, 9736, 
	9794, 9868, 9926, 10000, 10058, 10132, 10190, 10264, 
	10322, 10396, 10454, 10528, 10586, 10660, 10718, 10792, 
	10850, 10924, 10982, 11056, 11130, 11210, 11268, 11342, 
	11422, 11480, 11554, 11643, 11732, 11790, 11864, 11953, 
	12011, 12069, 12143, 12232, 12290, 12348, 12422, 12480, 
	12554, 12612, 12686, 12744, 12818, 12892, 12972, 13030, 
	13104, 13184, 13242, 13316, 13374, 13448, 13537, 13595, 
	13669, 13758, 13816, 13890, 13964, 14044, 14102, 14176, 
	14256, 14314, 14388, 14477, 14566, 14624, 14698, 14756, 
	14830, 14888, 14962, 15020, 15094, 15152, 15226, 15284, 
	15358, 15416, 15490, 15548, 15622, 15680
};

static const short _indicies[] = {
	0, 2, 3, 4, 5, 6, 7, 
	8, 9, 10, 1, 1, 11, 12, 13, 
	1, 14, 15, 1, 16, 1, 17, 18, 
	1, 19, 1, 20, 1, 1, 1, 1, 
	1, 1, 21, 22, 23, 5, 24, 7, 
	25, 26, 27, 1, 1, 28, 29, 30, 
	1, 14, 31, 1, 32, 1, 33, 34, 
	35, 36, 1, 37, 1, 1, 1, 1, 
	1, 1, 1, 1, 38, 1, 1, 1, 
	1, 1, 39, 39, 39, 39, 39, 39, 
	39, 39, 39, 39, 1, 1, 1, 1, 
	1, 1, 40, 41, 42, 43, 44, 45, 
	46, 47, 48, 49, 1, 1, 50, 51, 
	52, 1, 53, 54, 1, 55, 1, 56, 
	57, 1, 58, 1, 59, 1, 1, 1, 
	1, 37, 1, 60, 61, 62, 44, 63, 
	46, 64, 65, 66, 1, 1, 67, 68, 
	69, 1, 53, 70, 1, 71, 1, 72, 
	73, 74, 75, 1, 40, 41, 42, 43, 
	44, 45, 46, 47, 48, 49, 1, 1, 
	50, 51, 52, 1, 53, 54, 1, 55, 
	1, 56, 57, 1, 58, 1, 59, 1, 
	1, 1, 1, 1, 1, 60, 61, 62, 
	44, 63, 46, 64, 65, 66, 1, 1, 
	67, 68, 69, 1, 53, 70, 1, 71, 
	1, 72, 73, 74, 75, 1, 76, 1, 
	1, 1, 1, 1, 1, 1, 1, 77, 
	1, 1, 1, 1, 1, 78, 78, 78, 
	78, 78, 78, 78, 78, 78, 78, 1, 
	1, 1, 1, 1, 1, 79, 80, 81, 
	82, 83, 84, 85, 86, 87, 88, 1, 
	1, 89, 90, 91, 1, 92, 93, 1, 
	94, 1, 95, 96, 1, 97, 1, 98, 
	1, 1, 1, 1, 76, 1, 99, 100, 
	101, 83, 102, 85, 103, 104, 105, 1, 
	1, 106, 107, 108, 1, 92, 109, 1, 
	110, 1, 111, 112, 113, 114, 1, 79, 
	80, 81, 82, 83, 84, 85, 86, 87, 
	88, 1, 1, 89, 90, 91, 1, 92, 
	93, 1, 94, 1, 95, 96, 1, 97, 
	1, 98, 1, 1, 1, 1, 1, 1, 
	99, 100, 101, 83, 102, 85, 103, 104, 
	105, 1, 1, 106, 107, 108, 1, 92, 
	109, 1, 110, 1, 111, 112, 113, 114, 
	1, 115, 1, 1, 1, 1, 1, 1, 
	1, 1, 116, 1, 1, 1, 1, 1, 
	117, 117, 117, 117, 117, 117, 117, 117, 
	117, 117, 1, 1, 1, 1, 1, 1, 
	118, 119, 120, 121, 122, 123, 124, 125, 
	126, 127, 1, 1, 128, 129, 130, 1, 
	131, 132, 1, 133, 1, 134, 135, 1, 
	136, 1, 137, 1, 1, 1, 1, 115, 
	1, 138, 139, 140, 122, 141, 124, 142, 
	143, 144, 1, 1, 145, 146, 147, 1, 
	131, 148, 1, 149, 1, 150, 151, 152, 
	153, 1, 118, 119, 120, 121, 122, 123, 
	124, 125, 126, 127, 1, 1, 128, 129, 
	130, 1, 131, 132, 1, 133, 1, 134, 
	135, 1, 136, 1, 137, 1, 1, 1, 
	1, 1, 1, 138, 139, 140, 122, 141, 
	124, 142, 143, 144, 1, 1, 145, 146, 
	147, 1, 131, 148, 1, 149, 1, 150, 
	151, 152, 153, 1, 154, 1, 1, 1, 
	1, 1, 1, 1, 1, 155, 1, 1, 
	1, 1, 1, 156, 156, 156, 156, 156, 
	156, 156, 156, 156, 156, 1, 1, 1, 
	1, 1, 1, 157, 158, 159, 160, 161, 
	162, 163, 164, 165, 166, 1, 1, 167, 
	168, 169, 1, 170, 171, 1, 172, 1, 
	173, 174, 1, 175, 1, 176, 1, 1, 
	1, 1, 154, 1, 177, 178, 179, 161, 
	180, 163, 181, 182, 183, 1, 1, 184, 
	185, 186, 1, 170, 187, 1, 188, 1, 
	189, 190, 191, 192, 1, 157, 158, 159, 
	160, 161, 162, 163, 164, 165, 166, 1, 
	1, 167, 168, 169, 1, 170, 171, 1, 
	172, 1, 173, 174, 1, 175, 1, 176, 
	1, 1, 1, 1, 1, 1, 177, 178, 
	179, 161, 180, 163, 181, 182, 183, 1, 
	1, 184, 185, 186, 1, 170, 187, 1, 
	188, 1, 189, 190, 191, 192, 1, 193, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	194, 1, 1, 1, 1, 1, 195, 195, 
	195, 195, 195, 195, 195, 195, 195, 195, 
	1, 1, 1, 1, 1, 1, 196, 197, 
	198, 199, 200, 201, 202, 203, 204, 205, 
	1, 1, 206, 207, 208, 1, 209, 210, 
	1, 211, 1, 212, 213, 1, 214, 1, 
	215, 1, 1, 1, 1, 193, 1, 216, 
	217, 218, 200, 219, 202, 220, 221, 222, 
	1, 1, 223, 224, 225, 1, 209, 226, 
	1, 227, 1, 228, 229, 230, 231, 1, 
	196, 197, 198, 199, 200, 201, 202, 203, 
	204, 205, 1, 1, 206, 207, 208, 1, 
	209, 210, 1, 211, 1, 212, 213, 1, 
	214, 1, 215, 1, 1, 1, 1, 1, 
	1, 216, 217, 218, 200, 219, 202, 220, 
	221, 222, 1, 1, 223, 224, 225, 1, 
	209, 226, 1, 227, 1, 228, 229, 230, 
	231, 1, 232, 1, 1, 1, 1, 1, 
	1, 1, 1, 233, 1, 1, 1, 1, 
	1, 234, 234, 234, 234, 234, 234, 234, 
	234, 234, 234, 1, 1, 1, 1, 1, 
	1, 235, 236, 237, 238, 239, 240, 241, 
	242, 243, 244, 1, 1, 245, 246, 247, 
	1, 248, 249, 1, 250, 1, 251, 252, 
	1, 253, 1, 254, 1, 1, 1, 1, 
	232, 1, 255, 256, 257, 239, 258, 241, 
	259, 260, 261, 1, 1, 262, 263, 264, 
	1, 248, 265, 1, 266, 1, 267, 268, 
	269, 270, 1, 235, 236, 237, 238, 239, 
	240, 241, 242, 243, 244, 1, 1, 245, 
	246, 247, 1, 248, 249, 1, 250, 1, 
	251, 252, 1, 253, 1, 254, 1, 1, 
	1, 1, 1, 1, 255, 256, 257, 239, 
	258, 241, 259, 260, 261, 1, 1, 262, 
	263, 264, 1, 248, 265, 1, 266, 1, 
	267, 268, 269, 270, 1, 271, 1, 1, 
	1, 1, 1, 1, 1, 1, 272, 1, 
	1, 1, 1, 1, 273, 273, 273, 273, 
	273, 273, 273, 273, 273, 273, 1, 1, 
	1, 1, 1, 1, 274, 275, 276, 277, 
	278, 279, 280, 281, 282, 283, 1, 1, 
	284, 285, 286, 1, 287, 288, 1, 289, 
	1, 290, 291, 1, 292, 1, 293, 1, 
	1, 1, 1, 271, 1, 294, 295, 296, 
	278, 297, 280, 298, 299, 300, 1, 1, 
	301, 302, 303, 1, 287, 304, 1, 305, 
	1, 306, 307, 308, 309, 1, 274, 275, 
	276, 277, 278, 279, 280, 281, 282, 283, 
	1, 1, 284, 285, 286, 1, 287, 288, 
	1, 289, 1, 290, 291, 1, 292, 1, 
	293, 1, 1, 1, 1, 1, 1, 294, 
	295, 296, 278, 297, 280, 298, 299, 300, 
	1, 1, 301, 302, 303, 1, 287, 304, 
	1, 305, 1, 306, 307, 308, 309, 1, 
	310, 1, 1, 1, 1, 1, 1, 1, 
	1, 311, 1, 1, 1, 1, 1, 312, 
	312, 312, 312, 312, 312, 312, 312, 312, 
	312, 1, 1, 1, 1, 1, 1, 313, 
	314, 315, 316, 317, 318, 319, 320, 321, 
	322, 1, 1, 323, 324, 325, 1, 326, 
	327, 1, 328, 1, 329, 330, 1, 331, 
	1, 332, 1, 1, 1, 1, 310, 1, 
	333, 334, 335, 317, 336, 319, 337, 338, 
	339, 1, 1, 340, 341, 342, 1, 326, 
	343, 1, 344, 1, 345, 346, 347, 348, 
	1, 313, 314, 315, 316, 317, 318, 319, 
	320, 321, 322, 1, 1, 323, 324, 325, 
	1, 326, 327, 1, 328, 1, 329, 330, 
	1, 331, 1, 332, 1, 1, 1, 1, 
	1, 1, 333, 334, 335, 317, 336, 319, 
	337, 338, 339, 1, 1, 340, 341, 342, 
	1, 326, 343, 1, 344, 1, 345, 346, 
	347, 348, 1, 349, 1, 1, 1, 1, 
	1, 1, 1, 1, 350, 1, 1, 1, 
	1, 1, 351, 351, 351, 351, 351, 351, 
	351, 351, 351, 351, 1, 1, 1, 1, 
	1, 1, 352, 353, 354, 355, 356, 357, 
	358, 359, 360, 361, 1, 1, 362, 363, 
	364, 1, 365, 366, 1, 367, 1, 368, 
	369, 1, 370, 1, 371, 1, 1, 1, 
	1, 349, 1, 372, 373, 374, 356, 375, 
	358, 376, 377, 378, 1, 1, 379, 380, 
	381, 1, 365, 382, 1, 383, 1, 384, 
	385, 386, 387, 1, 352, 353, 354, 355, 
	356, 357, 358, 359, 360, 361, 1, 1, 
	362, 363, 364, 1, 365, 366, 1, 367, 
	1, 368, 369, 1, 370, 1, 371, 1, 
	1, 1, 1, 1, 1, 372, 373, 374, 
	356, 375, 358, 376, 377, 378, 1, 1, 
	379, 380, 381, 1, 365, 382, 1, 383, 
	1, 384, 385, 386, 387, 1, 388, 1, 
	1, 1, 1, 1, 1, 1, 1, 389, 
	1, 1, 1, 1, 1, 390, 390, 390, 
	390, 390, 390, 390, 390, 390, 390, 1, 
	1, 391, 1, 392, 1, 393, 394, 395, 
	396, 397, 398, 399, 400, 401, 402, 1, 
	1, 403, 404, 405, 1, 406, 407, 1, 
	408, 1, 409, 410, 1, 411, 1, 412, 
	1, 1, 1, 1, 388, 1, 413, 414, 
	415, 397, 416, 399, 417, 418, 419, 1, 
	1, 420, 421, 422, 1, 406, 423, 1, 
	424, 1, 425, 426, 427, 428, 1, 389, 
	1, 1, 1, 1, 1, 390, 390, 390, 
	390, 390, 390, 390, 390, 390, 390, 1, 
	1, 429, 1, 430, 1, 393, 394, 395, 
	396, 397, 398, 399, 400, 401, 402, 1, 
	1, 403, 404, 405, 1, 406, 407, 1, 
	408, 1, 409, 410, 1, 411, 1, 412, 
	1, 1, 1, 1, 1, 1, 413, 414, 
	415, 397, 416, 399, 417, 418, 419, 1, 
	1, 420, 421, 422, 1, 406, 423, 1, 
	424, 1, 425, 426, 427, 428, 1, 431, 
	432, 433, 434, 435, 436, 437, 438, 439, 
	440, 1, 1, 441, 442, 443, 1, 444, 
	445, 1, 446, 1, 447, 448, 1, 449, 
	1, 450, 1, 1, 1, 1, 1, 1, 
	451, 452, 453, 435, 454, 437, 455, 456, 
	457, 1, 1, 458, 459, 460, 1, 444, 
	461, 1, 462, 1, 463, 464, 465, 466, 
	1, 467, 1, 1, 1, 1, 1, 1, 
	1, 1, 468, 1, 1, 1, 1, 1, 
	469, 469, 469, 469, 469, 469, 469, 469, 
	469, 469, 1, 1, 470, 1, 471, 1, 
	472, 473, 474, 475, 476, 477, 478, 479, 
	480, 481, 1, 1, 482, 483, 484, 1, 
	485, 486, 1, 487, 1, 488, 489, 1, 
	490, 1, 491, 1, 1, 1, 1, 467, 
	1, 492, 493, 494, 476, 495, 478, 496, 
	497, 498, 1, 1, 499, 500, 501, 1, 
	485, 502, 1, 503, 1, 504, 505, 506, 
	507, 1, 508, 1, 1, 1, 1, 1, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 1, 1, 510, 1, 511, 1, 
	512, 513, 514, 515, 516, 517, 518, 519, 
	520, 521, 1, 1, 522, 523, 524, 1, 
	525, 526, 1, 527, 1, 528, 529, 1, 
	530, 1, 531, 1, 1, 1, 1, 1, 
	1, 532, 533, 534, 516, 535, 518, 536, 
	537, 538, 1, 1, 539, 540, 541, 1, 
	525, 542, 1, 543, 1, 544, 545, 546, 
	547, 1, 548, 549, 550, 551, 552, 553, 
	554, 555, 556, 557, 1, 1, 558, 559, 
	560, 1, 561, 562, 1, 563, 1, 564, 
	565, 1, 566, 1, 567, 1, 1, 1, 
	1, 1, 1, 568, 569, 570, 552, 571, 
	554, 572, 573, 574, 1, 1, 575, 576, 
	577, 1, 561, 578, 1, 579, 1, 580, 
	581, 582, 583, 1, 584, 1, 1, 1, 
	1, 1, 1, 1, 1, 585, 1, 1, 
	1, 1, 1, 586, 586, 586, 586, 586, 
	586, 586, 586, 586, 586, 1, 1, 1, 
	1, 1, 1, 587, 588, 589, 590, 591, 
	592, 593, 594, 595, 596, 1, 1, 597, 
	598, 599, 1, 600, 601, 1, 602, 1, 
	603, 604, 1, 605, 1, 606, 1, 1, 
	1, 1, 584, 1, 607, 608, 609, 591, 
	610, 593, 611, 612, 613, 1, 1, 614, 
	615, 616, 1, 600, 617, 1, 618, 1, 
	619, 620, 621, 622, 1, 587, 588, 589, 
	590, 591, 592, 593, 594, 595, 596, 1, 
	1, 597, 598, 599, 1, 600, 601, 1, 
	602, 1, 603, 604, 1, 605, 1, 606, 
	1, 1, 1, 1, 1, 1, 607, 608, 
	609, 591, 610, 593, 611, 612, 613, 1, 
	1, 614, 615, 616, 1, 600, 617, 1, 
	618, 1, 619, 620, 621, 622, 1, 623, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	624, 1, 1, 1, 1, 1, 625, 625, 
	625, 625, 625, 625, 625, 625, 625, 625, 
	1, 1, 1, 1, 1, 1, 626, 627, 
	628, 629, 630, 631, 632, 633, 634, 635, 
	1, 1, 636, 637, 638, 1, 639, 640, 
	1, 641, 1, 642, 643, 1, 644, 1, 
	645, 1, 1, 1, 1, 623, 1, 646, 
	647, 648, 630, 649, 632, 650, 651, 652, 
	1, 1, 653, 654, 655, 1, 639, 656, 
	1, 657, 1, 658, 659, 660, 661, 1, 
	626, 627, 628, 629, 630, 631, 632, 633, 
	634, 635, 1, 1, 636, 637, 638, 1, 
	639, 640, 1, 641, 1, 642, 643, 1, 
	644, 1, 645, 1, 1, 1, 1, 1, 
	1, 646, 647, 648, 630, 649, 632, 650, 
	651, 652, 1, 1, 653, 654, 655, 1, 
	639, 656, 1, 657, 1, 658, 659, 660, 
	661, 1, 662, 1, 1, 1, 1, 1, 
	1, 1, 1, 663, 1, 1, 1, 1, 
	1, 664, 664, 664, 664, 664, 664, 664, 
	664, 664, 664, 1, 1, 1, 1, 1, 
	1, 665, 666, 667, 668, 669, 670, 671, 
	672, 673, 674, 1, 1, 675, 676, 677, 
	1, 678, 679, 1, 680, 1, 681, 682, 
	1, 683, 1, 684, 1, 1, 1, 1, 
	662, 1, 685, 686, 687, 669, 688, 671, 
	689, 690, 691, 1, 1, 692, 693, 694, 
	1, 678, 695, 1, 696, 1, 697, 698, 
	699, 700, 1, 665, 666, 667, 668, 669, 
	670, 671, 672, 673, 674, 1, 1, 675, 
	676, 677, 1, 678, 679, 1, 680, 1, 
	681, 682, 1, 683, 1, 684, 1, 1, 
	1, 1, 1, 1, 685, 686, 687, 669, 
	688, 671, 689, 690, 691, 1, 1, 692, 
	693, 694, 1, 678, 695, 1, 696, 1, 
	697, 698, 699, 700, 1, 701, 1, 1, 
	1, 1, 1, 1, 1, 1, 702, 1, 
	1, 1, 1, 1, 703, 703, 703, 703, 
	703, 703, 703, 703, 703, 703, 1, 1, 
	704, 1, 705, 1, 706, 707, 708, 709, 
	710, 711, 712, 713, 714, 715, 1, 1, 
	716, 717, 718, 1, 719, 720, 1, 721, 
	1, 722, 723, 1, 724, 1, 725, 1, 
	1, 1, 1, 701, 1, 726, 727, 728, 
	710, 729, 712, 730, 731, 732, 1, 1, 
	733, 734, 735, 1, 719, 736, 1, 737, 
	1, 738, 739, 740, 741, 1, 706, 707, 
	708, 709, 710, 711, 712, 713, 714, 715, 
	1, 1, 716, 717, 718, 1, 719, 720, 
	1, 721, 1, 722, 723, 1, 724, 1, 
	725, 1, 1, 1, 1, 1, 1, 726, 
	727, 728, 710, 729, 712, 730, 731, 732, 
	1, 1, 733, 734, 735, 1, 719, 736, 
	1, 737, 1, 738, 739, 740, 741, 1, 
	742, 1, 1, 1, 1, 1, 1, 1, 
	1, 743, 1, 1, 1, 1, 1, 744, 
	744, 744, 744, 744, 744, 744, 744, 744, 
	744, 1, 1, 745, 1, 746, 1, 747, 
	748, 749, 750, 751, 752, 753, 754, 755, 
	756, 1, 1, 757, 758, 759, 1, 760, 
	761, 1, 762, 1, 763, 764, 1, 765, 
	1, 766, 1, 1, 1, 1, 742, 1, 
	767, 768, 769, 751, 770, 753, 771, 772, 
	773, 1, 1, 774, 775, 776, 1, 760, 
	777, 1, 778, 1, 779, 780, 781, 782, 
	1, 743, 1, 1, 1, 1, 1, 744, 
	744, 744, 744, 744, 744, 744, 744, 744, 
	744, 1, 1, 783, 1, 784, 1, 747, 
	748, 749, 750, 751, 752, 753, 754, 755, 
	756, 1, 1, 757, 758, 759, 1, 760, 
	761, 1, 762, 1, 763, 764, 1, 765, 
	1, 766, 1, 1, 1, 1, 1, 1, 
	767, 768, 769, 751, 770, 753, 771, 772, 
	773, 1, 1, 774, 775, 776, 1, 760, 
	777, 1, 778, 1, 779, 780, 781, 782, 
	1, 785, 786, 787, 788, 789, 790, 791, 
	792, 793, 794, 1, 1, 795, 796, 797, 
	1, 798, 799, 1, 800, 1, 801, 802, 
	1, 803, 1, 804, 1, 1, 1, 1, 
	1, 1, 805, 806, 807, 789, 808, 791, 
	809, 810, 811, 1, 1, 812, 813, 814, 
	1, 798, 815, 1, 816, 1, 817, 818, 
	819, 820, 1, 821, 1, 1, 1, 1, 
	1, 1, 1, 1, 822, 1, 1, 1, 
	1, 1, 823, 823, 823, 823, 823, 823, 
	823, 823, 823, 823, 1, 1, 1, 1, 
	1, 1, 824, 825, 826, 827, 828, 829, 
	830, 831, 832, 833, 1, 1, 834, 835, 
	836, 1, 837, 838, 1, 839, 1, 840, 
	841, 1, 842, 1, 843, 1, 1, 1, 
	1, 821, 1, 844, 845, 846, 828, 847, 
	830, 848, 849, 850, 1, 1, 851, 852, 
	853, 1, 837, 854, 1, 855, 1, 856, 
	857, 858, 859, 1, 824, 825, 826, 827, 
	828, 829, 830, 831, 832, 833, 1, 1, 
	834, 835, 836, 1, 837, 838, 1, 839, 
	1, 840, 841, 1, 842, 1, 843, 1, 
	1, 1, 1, 1, 1, 844, 845, 846, 
	828, 847, 830, 848, 849, 850, 1, 1, 
	851, 852, 853, 1, 837, 854, 1, 855, 
	1, 856, 857, 858, 859, 1, 860, 1, 
	1, 1, 1, 1, 1, 1, 1, 861, 
	1, 1, 1, 1, 1, 862, 862, 862, 
	862, 862, 862, 862, 862, 862, 862, 1, 
	1, 1, 1, 1, 1, 863, 864, 865, 
	866, 867, 868, 869, 870, 871, 872, 1, 
	1, 873, 874, 875, 1, 876, 877, 1, 
	878, 1, 879, 880, 1, 881, 1, 882, 
	1, 1, 1, 1, 860, 1, 883, 884, 
	885, 867, 886, 869, 887, 888, 889, 1, 
	1, 890, 891, 892, 1, 876, 893, 1, 
	894, 1, 895, 896, 897, 898, 1, 863, 
	864, 865, 866, 867, 868, 869, 870, 871, 
	872, 1, 1, 873, 874, 875, 1, 876, 
	877, 1, 878, 1, 879, 880, 1, 881, 
	1, 882, 1, 1, 1, 1, 1, 1, 
	883, 884, 885, 867, 886, 869, 887, 888, 
	889, 1, 1, 890, 891, 892, 1, 876, 
	893, 1, 894, 1, 895, 896, 897, 898, 
	1, 899, 1, 1, 1, 1, 1, 1, 
	1, 1, 900, 1, 1, 1, 1, 1, 
	901, 901, 901, 901, 901, 901, 901, 901, 
	901, 901, 1, 1, 1, 1, 1, 1, 
	902, 903, 904, 905, 906, 907, 908, 909, 
	910, 911, 1, 1, 912, 913, 914, 1, 
	915, 916, 1, 917, 1, 918, 919, 1, 
	920, 1, 921, 1, 1, 1, 1, 899, 
	1, 922, 923, 924, 906, 925, 908, 926, 
	927, 928, 1, 1, 929, 930, 931, 1, 
	915, 932, 1, 933, 1, 934, 935, 936, 
	937, 1, 902, 903, 904, 905, 906, 907, 
	908, 909, 910, 911, 1, 1, 912, 913, 
	914, 1, 915, 916, 1, 917, 1, 918, 
	919, 1, 920, 1, 921, 1, 1, 1, 
	1, 1, 1, 922, 923, 924, 906, 925, 
	908, 926, 927, 928, 1, 1, 929, 930, 
	931, 1, 915, 932, 1, 933, 1, 934, 
	935, 936, 937, 1, 938, 1, 1, 1, 
	1, 1, 1, 1, 1, 939, 1, 1, 
	1, 1, 1, 940, 940, 940, 940, 940, 
	940, 940, 940, 940, 940, 1, 1, 1, 
	1, 1, 1, 941, 942, 943, 944, 945, 
	946, 947, 948, 949, 950, 1, 1, 951, 
	952, 953, 1, 954, 955, 1, 956, 1, 
	957, 958, 1, 959, 1, 960, 1, 1, 
	1, 1, 938, 1, 961, 962, 963, 945, 
	964, 947, 965, 966, 967, 1, 1, 968, 
	969, 970, 1, 954, 971, 1, 972, 1, 
	973, 974, 975, 976, 1, 941, 942, 943, 
	944, 945, 946, 947, 948, 949, 950, 1, 
	1, 951, 952, 953, 1, 954, 955, 1, 
	956, 1, 957, 958, 1, 959, 1, 960, 
	1, 1, 1, 1, 1, 1, 961, 962, 
	963, 945, 964, 947, 965, 966, 967, 1, 
	1, 968, 969, 970, 1, 954, 971, 1, 
	972, 1, 973, 974, 975, 976, 1, 977, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	978, 1, 1, 1, 1, 1, 979, 979, 
	979, 979, 979, 979, 979, 979, 979, 979, 
	1, 1, 1, 1, 1, 1, 980, 981, 
	982, 983, 984, 985, 986, 987, 988, 989, 
	1, 1, 990, 991, 992, 1, 993, 994, 
	1, 995, 1, 996, 997, 1, 998, 1, 
	999, 1, 1, 1, 1, 977, 1, 1000, 
	1001, 1002, 984, 1003, 986, 1004, 1005, 1006, 
	1, 1, 1007, 1008, 1009, 1, 993, 1010, 
	1, 1011, 1, 1012, 1013, 1014, 1015, 1, 
	980, 981, 982, 983, 984, 985, 986, 987, 
	988, 989, 1, 1, 990, 991, 992, 1, 
	993, 994, 1, 995, 1, 996, 997, 1, 
	998, 1, 999, 1, 1, 1, 1, 1, 
	1, 1000, 1001, 1002, 984, 1003, 986, 1004, 
	1005, 1006, 1, 1, 1007, 1008, 1009, 1, 
	993, 1010, 1, 1011, 1, 1012, 1013, 1014, 
	1015, 1, 1016, 1, 1, 1, 1, 1, 
	1, 1, 1, 1017, 1, 1, 1, 1, 
	1, 1018, 1018, 1018, 1018, 1018, 1018, 1018, 
	1018, 1018, 1018, 1, 1, 1, 1, 1, 
	1, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 
	1026, 1027, 1028, 1, 1, 1029, 1030, 1031, 
	1, 1032, 1033, 1, 1034, 1, 1035, 1036, 
	1, 1037, 1, 1038, 1, 1, 1, 1, 
	1016, 1, 1039, 1040, 1041, 1023, 1042, 1025, 
	1043, 1044, 1045, 1, 1, 1046, 1047, 1048, 
	1, 1032, 1049, 1, 1050, 1, 1051, 1052, 
	1053, 1054, 1, 1019, 1020, 1021, 1022, 1023, 
	1024, 1025, 1026, 1027, 1028, 1, 1, 1029, 
	1030, 1031, 1, 1032, 1033, 1, 1034, 1, 
	1035, 1036, 1, 1037, 1, 1038, 1, 1, 
	1, 1, 1, 1, 1039, 1040, 1041, 1023, 
	1042, 1025, 1043, 1044, 1045, 1, 1, 1046, 
	1047, 1048, 1, 1032, 1049, 1, 1050, 1, 
	1051, 1052, 1053, 1054, 1, 1055, 1, 1, 
	1, 1, 1, 1, 1, 1, 1056, 1, 
	1, 1, 1, 1, 1057, 1057, 1057, 1057, 
	1057, 1057, 1057, 1057, 1057, 1057, 1, 1, 
	1, 1, 1, 1, 1058, 1059, 1060, 1061, 
	1062, 1063, 1064, 1065, 1066, 1067, 1, 1, 
	1068, 1069, 1070, 1, 1071, 1072, 1, 1073, 
	1, 1074, 1075, 1, 1076, 1, 1077, 1, 
	1, 1, 1, 1055, 1, 1078, 1079, 1080, 
	1062, 1081, 1064, 1082, 1083, 1084, 1, 1, 
	1085, 1086, 1087, 1, 1071, 1088, 1, 1089, 
	1, 1090, 1091, 1092, 1093, 1, 1058, 1059, 
	1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 
	1, 1, 1068, 1069, 1070, 1, 1071, 1072, 
	1, 1073, 1, 1074, 1075, 1, 1076, 1, 
	1077, 1, 1, 1, 1, 1, 1, 1078, 
	1079, 1080, 1062, 1081, 1064, 1082, 1083, 1084, 
	1, 1, 1085, 1086, 1087, 1, 1071, 1088, 
	1, 1089, 1, 1090, 1091, 1092, 1093, 1, 
	1094, 1, 1, 1, 1, 1, 1, 1, 
	1, 1095, 1, 1, 1, 1, 1, 1096, 
	1096, 1096, 1096, 1096, 1096, 1096, 1096, 1096, 
	1096, 1, 1, 1, 1, 1, 1, 1097, 
	1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 
	1106, 1, 1, 1107, 1108, 1109, 1, 1110, 
	1111, 1, 1112, 1, 1113, 1114, 1, 1115, 
	1, 1116, 1, 1, 1, 1, 1094, 1, 
	1117, 1118, 1119, 1101, 1120, 1103, 1121, 1122, 
	1123, 1, 1, 1124, 1125, 1126, 1, 1110, 
	1127, 1, 1128, 1, 1129, 1130, 1131, 1132, 
	1, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 
	1104, 1105, 1106, 1, 1, 1107, 1108, 1109, 
	1, 1110, 1111, 1, 1112, 1, 1113, 1114, 
	1, 1115, 1, 1116, 1, 1, 1, 1, 
	1, 1, 1117, 1118, 1119, 1101, 1120, 1103, 
	1121, 1122, 1123, 1, 1, 1124, 1125, 1126, 
	1, 1110, 1127, 1, 1128, 1, 1129, 1130, 
	1131, 1132, 1, 1133, 1, 1, 1, 1, 
	1, 1, 1, 1, 1134, 1, 1, 1, 
	1, 1, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 1, 1, 1, 1, 
	1, 1, 1136, 1137, 1138, 1139, 1140, 1141, 
	1142, 1143, 1144, 1145, 1, 1, 1146, 1147, 
	1148, 1, 1149, 1150, 1, 1151, 1, 1152, 
	1153, 1, 1154, 1, 1155, 1, 1, 1, 
	1, 1133, 1, 1156, 1157, 1158, 1140, 1159, 
	1142, 1160, 1161, 1162, 1, 1, 1163, 1164, 
	1165, 1, 1149, 1166, 1, 1167, 1, 1168, 
	1169, 1170, 1171, 1, 1136, 1137, 1138, 1139, 
	1140, 1141, 1142, 1143, 1144, 1145, 1, 1, 
	1146, 1147, 1148, 1, 1149, 1150, 1, 1151, 
	1, 1152, 1153, 1, 1154, 1, 1155, 1, 
	1, 1, 1, 1, 1, 1156, 1157, 1158, 
	1140, 1159, 1142, 1160, 1161, 1162, 1, 1, 
	1163, 1164, 1165, 1, 1149, 1166, 1, 1167, 
	1, 1168, 1169, 1170, 1171, 1, 1172, 1, 
	1, 1, 1, 1, 1, 1, 1, 1173, 
	1, 1, 1, 1, 1, 1174, 1174, 1174, 
	1174, 1174, 1174, 1174, 1174, 1174, 1174, 1, 
	1, 1, 1, 1, 1, 1175, 1176, 1177, 
	1178, 1179, 1180, 1181, 1182, 1183, 1184, 1, 
	1, 1185, 1186, 1187, 1, 1188, 1189, 1, 
	1190, 1, 1191, 1192, 1, 1193, 1, 1194, 
	1, 1, 1, 1, 1172, 1, 1195, 1196, 
	1197, 1179, 1198, 1181, 1199, 1200, 1201, 1, 
	1, 1202, 1203, 1204, 1, 1188, 1205, 1, 
	1206, 1, 1207, 1208, 1209, 1210, 1, 1175, 
	1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 
	1184, 1, 1, 1185, 1186, 1187, 1, 1188, 
	1189, 1, 1190, 1, 1191, 1192, 1, 1193, 
	1, 1194, 1, 1, 1, 1, 1, 1, 
	1195, 1196, 1197, 1179, 1198, 1181, 1199, 1200, 
	1201, 1, 1, 1202, 1203, 1204, 1, 1188, 
	1205, 1, 1206, 1, 1207, 1208, 1209, 1210, 
	1, 1211, 1, 1, 1, 1, 1, 1, 
	1, 1, 1212, 1, 1, 1, 1, 1, 
	1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 
	1213, 1213, 1, 1, 1214, 1, 1215, 1, 
	1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 
	1224, 1225, 1, 1, 1226, 1227, 1228, 1, 
	1229, 1230, 1, 1231, 1, 1232, 1233, 1, 
	1234, 1, 1235, 1, 1, 1, 1, 1211, 
	1, 1236, 1237, 1238, 1220, 1239, 1222, 1240, 
	1241, 1242, 1, 1, 1243, 1244, 1245, 1, 
	1229, 1246, 1, 1247, 1, 1248, 1249, 1250, 
	1251, 1, 1212, 1, 1, 1, 1, 1, 
	1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 
	1213, 1213, 1, 1, 1252, 1, 1253, 1, 
	1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 
	1224, 1225, 1, 1, 1226, 1227, 1228, 1, 
	1229, 1230, 1, 1231, 1, 1232, 1233, 1, 
	1234, 1, 1235, 1, 1, 1, 1, 1, 
	1, 1236, 1237, 1238, 1220, 1239, 1222, 1240, 
	1241, 1242, 1, 1, 1243, 1244, 1245, 1, 
	1229, 1246, 1, 1247, 1, 1248, 1249, 1250, 
	1251, 1, 1254, 1255, 1256, 1257, 1258, 1259, 
	1260, 1261, 1262, 1263, 1, 1, 1264, 1265, 
	1266, 1, 1267, 1268, 1, 1269, 1, 1270, 
	1271, 1, 1272, 1, 1273, 1, 1, 1, 
	1, 1, 1, 1274, 1275, 1276, 1258, 1277, 
	1260, 1278, 1279, 1280, 1, 1, 1281, 1282, 
	1283, 1, 1267, 1284, 1, 1285, 1, 1286, 
	1287, 1288, 1289, 1, 1290, 1, 1, 1, 
	1, 1, 1, 1, 1, 1291, 1, 1, 
	1, 1, 1, 1292, 1292, 1292, 1292, 1292, 
	1292, 1292, 1292, 1292, 1292, 1, 1, 1293, 
	1, 1294, 1, 1295, 1296, 1297, 1298, 1299, 
	1300, 1301, 1302, 1303, 1304, 1, 1, 1305, 
	1306, 1307, 1, 1308, 1309, 1, 1310, 1, 
	1311, 1312, 1, 1313, 1, 1314, 1, 1, 
	1, 1, 1290, 1, 1315, 1316, 1317, 1299, 
	1318, 1301, 1319, 1320, 1321, 1, 1, 1322, 
	1323, 1324, 1, 1308, 1325, 1, 1326, 1, 
	1327, 1328, 1329, 1330, 1, 1331, 1, 1, 
	1, 1, 1, 1332, 1332, 1332, 1332, 1332, 
	1332, 1332, 1332, 1332, 1332, 1, 1, 1333, 
	1, 1334, 1, 1335, 1336, 1337, 1338, 1339, 
	1340, 1341, 1342, 1343, 1344, 1, 1, 1345, 
	1346, 1347, 1, 1348, 1349, 1, 1350, 1, 
	1351, 1352, 1, 1353, 1, 1354, 1, 1, 
	1, 1, 1, 1, 1355, 1356, 1357, 1339, 
	1358, 1341, 1359, 1360, 1361, 1, 1, 1362, 
	1363, 1364, 1, 1348, 1365, 1, 1366, 1, 
	1367, 1368, 1369, 1370, 1, 1371, 1372, 1373, 
	1374, 1375, 1376, 1377, 1378, 1379, 1380, 1, 
	1, 1381, 1382, 1383, 1, 1384, 1385, 1, 
	1386, 1, 1387, 1388, 1, 1389, 1, 1390, 
	1, 1, 1, 1, 1, 1, 1391, 1392, 
	1393, 1375, 1394, 1377, 1395, 1396, 1397, 1, 
	1, 1398, 1399, 1400, 1, 1384, 1401, 1, 
	1402, 1, 1403, 1404, 1405, 1406, 1, 1407, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1408, 1, 1, 1, 1, 1, 1409, 1409, 
	1409, 1409, 1409, 1409, 1409, 1409, 1409, 1409, 
	1, 1, 1, 1, 1, 1, 1410, 1411, 
	1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 
	1, 1, 1420, 1421, 1422, 1, 1423, 1424, 
	1, 1425, 1, 1426, 1427, 1, 1428, 1, 
	1429, 1, 1, 1, 1, 1407, 1, 1430, 
	1431, 1432, 1414, 1433, 1416, 1434, 1435, 1436, 
	1, 1, 1437, 1438, 1439, 1, 1423, 1440, 
	1, 1441, 1, 1442, 1443, 1444, 1445, 1, 
	1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 
	1418, 1419, 1, 1, 1420, 1421, 1422, 1, 
	1423, 1424, 1, 1425, 1, 1426, 1427, 1, 
	1428, 1, 1429, 1, 1, 1, 1, 1, 
	1, 1430, 1431, 1432, 1414, 1433, 1416, 1434, 
	1435, 1436, 1, 1, 1437, 1438, 1439, 1, 
	1423, 1440, 1, 1441, 1, 1442, 1443, 1444, 
	1445, 1, 1446, 1, 1, 1, 1, 1, 
	1, 1, 1, 1447, 1, 1, 1, 1, 
	1, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 
	1448, 1448, 1448, 1, 1, 1, 1, 1, 
	1, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 
	1456, 1457, 1458, 1, 1, 1459, 1460, 1461, 
	1, 1462, 1463, 1, 1464, 1, 1465, 1466, 
	1, 1467, 1, 1468, 1, 1, 1, 1, 
	1446, 1, 1469, 1470, 1471, 1453, 1472, 1455, 
	1473, 1474, 1475, 1, 1, 1476, 1477, 1478, 
	1, 1462, 1479, 1, 1480, 1, 1481, 1482, 
	1483, 1484, 1, 1449, 1450, 1451, 1452, 1453, 
	1454, 1455, 1456, 1457, 1458, 1, 1, 1459, 
	1460, 1461, 1, 1462, 1463, 1, 1464, 1, 
	1465, 1466, 1, 1467, 1, 1468, 1, 1, 
	1, 1, 1, 1, 1469, 1470, 1471, 1453, 
	1472, 1455, 1473, 1474, 1475, 1, 1, 1476, 
	1477, 1478, 1, 1462, 1479, 1, 1480, 1, 
	1481, 1482, 1483, 1484, 1, 1485, 1, 1, 
	1, 1, 1, 1, 1, 1, 1486, 1, 
	1, 1, 1, 1, 1487, 1487, 1487, 1487, 
	1487, 1487, 1487, 1487, 1487, 1487, 1, 1, 
	1488, 1, 1489, 1, 1490, 1491, 1492, 1493, 
	1494, 1495, 1496, 1497, 1498, 1499, 1, 1, 
	1500, 1501, 1502, 1, 1503, 1504, 1, 1505, 
	1, 1506, 1507, 1, 1508, 1, 1509, 1, 
	1, 1, 1, 1485, 1, 1510, 1511, 1512, 
	1494, 1513, 1496, 1514, 1515, 1516, 1, 1, 
	1517, 1518, 1519, 1, 1503, 1520, 1, 1521, 
	1, 1522, 1523, 1524, 1525, 1, 1490, 1491, 
	1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 
	1, 1, 1500, 1501, 1502, 1, 1503, 1504, 
	1, 1505, 1, 1506, 1507, 1, 1508, 1, 
	1509, 1, 1, 1, 1, 1, 1, 1510, 
	1511, 1512, 1494, 1513, 1496, 1514, 1515, 1516, 
	1, 1, 1517, 1518, 1519, 1, 1503, 1520, 
	1, 1521, 1, 1522, 1523, 1524, 1525, 1, 
	1526, 1, 1, 1, 1, 1, 1, 1, 
	1, 1527, 1, 1, 1, 1, 1, 1528, 
	1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 
	1528, 1, 1, 1529, 1, 1530, 1, 1531, 
	1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 
	1540, 1, 1, 1541, 1542, 1543, 1, 1544, 
	1545, 1, 1546, 1, 1547, 1548, 1, 1549, 
	1, 1550, 1, 1, 1, 1, 1526, 1, 
	1551, 1552, 1553, 1535, 1554, 1537, 1555, 1556, 
	1557, 1, 1, 1558, 1559, 1560, 1, 1544, 
	1561, 1, 1562, 1, 1563, 1564, 1565, 1566, 
	1, 1527, 1, 1, 1, 1, 1, 1528, 
	1528, 1528, 1528, 1528, 1528, 1528, 1528, 1528, 
	1528, 1, 1, 1567, 1, 1568, 1, 1531, 
	1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 
	1540, 1, 1, 1541, 1542, 1543, 1, 1544, 
	1545, 1, 1546, 1, 1547, 1548, 1, 1549, 
	1, 1550, 1, 1, 1, 1, 1, 1, 
	1551, 1552, 1553, 1535, 1554, 1537, 1555, 1556, 
	1557, 1, 1, 1558, 1559, 1560, 1, 1544, 
	1561, 1, 1562, 1, 1563, 1564, 1565, 1566, 
	1, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 
	1576, 1577, 1578, 1, 1, 1579, 1580, 1581, 
	1, 1582, 1583, 1, 1584, 1, 1585, 1586, 
	1, 1587, 1, 1588, 1, 1, 1, 1, 
	1, 1, 1589, 1590, 1591, 1573, 1592, 1575, 
	1593, 1594, 1595, 1, 1, 1596, 1597, 1598, 
	1, 1582, 1599, 1, 1600, 1, 1601, 1602, 
	1603, 1604, 1, 1605, 1, 1, 1, 1, 
	1, 1, 1, 1, 1606, 1, 1, 1, 
	1, 1, 1607, 1607, 1607, 1607, 1607, 1607, 
	1607, 1607, 1607, 1607, 1, 1, 1, 1, 
	1, 1, 1608, 1609, 1610, 1611, 1612, 1613, 
	1614, 1615, 1616, 1617, 1, 1, 1618, 1619, 
	1620, 1, 1621, 1622, 1, 1623, 1, 1624, 
	1625, 1, 1626, 1, 1627, 1, 1, 1, 
	1, 1605, 1, 1628, 1629, 1630, 1612, 1631, 
	1614, 1632, 1633, 1634, 1, 1, 1635, 1636, 
	1637, 1, 1621, 1638, 1, 1639, 1, 1640, 
	1641, 1642, 1643, 1, 1608, 1609, 1610, 1611, 
	1612, 1613, 1614, 1615, 1616, 1617, 1, 1, 
	1618, 1619, 1620, 1, 1621, 1622, 1, 1623, 
	1, 1624, 1625, 1, 1626, 1, 1627, 1, 
	1, 1, 1, 1, 1, 1628, 1629, 1630, 
	1612, 1631, 1614, 1632, 1633, 1634, 1, 1, 
	1635, 1636, 1637, 1, 1621, 1638, 1, 1639, 
	1, 1640, 1641, 1642, 1643, 1, 1644, 1, 
	1, 1, 1, 1, 1, 1, 1, 1645, 
	1, 1, 1, 1, 1, 1646, 1646, 1646, 
	1646, 1646, 1646, 1646, 1646, 1646, 1646, 1, 
	1, 1, 1, 1, 1, 1647, 1648, 1649, 
	1650, 1651, 1652, 1653, 1654, 1655, 1656, 1, 
	1, 1657, 1658, 1659, 1, 1660, 1661, 1, 
	1662, 1, 1663, 1664, 1, 1665, 1, 1666, 
	1, 1, 1, 1, 1644, 1, 1667, 1668, 
	1669, 1651, 1670, 1653, 1671, 1672, 1673, 1, 
	1, 1674, 1675, 1676, 1, 1660, 1677, 1, 
	1678, 1, 1679, 1680, 1681, 1682, 1, 1647, 
	1648, 1649, 1650, 1651, 1652, 1653, 1654, 1655, 
	1656, 1, 1, 1657, 1658, 1659, 1, 1660, 
	1661, 1, 1662, 1, 1663, 1664, 1, 1665, 
	1, 1666, 1, 1, 1, 1, 1, 1, 
	1667, 1668, 1669, 1651, 1670, 1653, 1671, 1672, 
	1673, 1, 1, 1674, 1675, 1676, 1, 1660, 
	1677, 1, 1678, 1, 1679, 1680, 1681, 1682, 
	1, 1683, 1, 1, 1, 1, 1, 1, 
	1, 1, 1684, 1, 1, 1, 1, 1, 
	1685, 1685, 1685, 1685, 1685, 1685, 1685, 1685, 
	1685, 1685, 1, 1, 1, 1, 1, 1, 
	1686, 1687, 1688, 1689, 1690, 1691, 1692, 1693, 
	1694, 1695, 1, 1, 1696, 1697, 1698, 1, 
	1699, 1700, 1, 1701, 1, 1702, 1703, 1, 
	1704, 1, 1705, 1, 1, 1, 1, 1683, 
	1, 1706, 1707, 1708, 1690, 1709, 1692, 1710, 
	1711, 1712, 1, 1, 1713, 1714, 1715, 1, 
	1699, 1716, 1, 1717, 1, 1718, 1719, 1720, 
	1721, 1, 1686, 1687, 1688, 1689, 1690, 1691, 
	1692, 1693, 1694, 1695, 1, 1, 1696, 1697, 
	1698, 1, 1699, 1700, 1, 1701, 1, 1702, 
	1703, 1, 1704, 1, 1705, 1, 1, 1, 
	1, 1, 1, 1706, 1707, 1708, 1690, 1709, 
	1692, 1710, 1711, 1712, 1, 1, 1713, 1714, 
	1715, 1, 1699, 1716, 1, 1717, 1, 1718, 
	1719, 1720, 1721, 1, 1722, 1, 1, 1, 
	1, 1, 1, 1, 1, 1723, 1, 1, 
	1, 1, 1, 1724, 1724, 1724, 1724, 1724, 
	1724, 1724, 1724, 1724, 1724, 1, 1, 1, 
	1, 1, 1, 1725, 1726, 1727, 1728, 1729, 
	1730, 1731, 1732, 1733, 1734, 1, 1, 1735, 
	1736, 1737, 1, 1738, 1739, 1, 1740, 1, 
	1741, 1742, 1, 1743, 1, 1744, 1, 1, 
	1, 1, 1722, 1, 1745, 1746, 1747, 1729, 
	1748, 1731, 1749, 1750, 1751, 1, 1, 1752, 
	1753, 1754, 1, 1738, 1755, 1, 1756, 1, 
	1757, 1758, 1759, 1760, 1, 1725, 1726, 1727, 
	1728, 1729, 1730, 1731, 1732, 1733, 1734, 1, 
	1, 1735, 1736, 1737, 1, 1738, 1739, 1, 
	1740, 1, 1741, 1742, 1, 1743, 1, 1744, 
	1, 1, 1, 1, 1, 1, 1745, 1746, 
	1747, 1729, 1748, 1731, 1749, 1750, 1751, 1, 
	1, 1752, 1753, 1754, 1, 1738, 1755, 1, 
	1756, 1, 1757, 1758, 1759, 1760, 1, 1761, 
	1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769, 
	1770, 1, 1, 1771, 1772, 1773, 1, 1774, 
	1775, 1, 1776, 1, 1777, 1778, 1, 1779, 
	1, 1780, 1, 1, 1, 1, 1, 1, 
	1781, 1782, 1783, 1765, 1784, 1767, 1785, 1786, 
	1787, 1, 1, 1788, 1789, 1790, 1, 1774, 
	1791, 1, 1792, 1, 1793, 1794, 1795, 1796, 
	1, 1797, 1797, 1797, 1797, 1797, 1797, 1797, 
	1797, 1797, 1797, 1, 1, 1, 1, 1, 
	1, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 
	1732, 1733, 1734, 1, 1, 1735, 1736, 1737, 
	1, 1738, 1739, 1, 1740, 1, 1741, 1742, 
	1, 1743, 1, 1744, 1, 1, 1, 1, 
	1, 1, 1745, 1746, 1747, 1729, 1748, 1731, 
	1749, 1750, 1751, 1, 1, 1752, 1753, 1754, 
	1, 1738, 1755, 1, 1756, 1, 1757, 1758, 
	1759, 1760, 1, 1798, 1799, 1800, 1801, 1802, 
	1803, 1804, 1805, 1806, 1807, 1, 1, 1808, 
	1809, 1810, 1, 1811, 1812, 1, 1813, 1, 
	1814, 1815, 1, 1816, 1, 1817, 1, 1, 
	1, 1, 1, 1, 1818, 1819, 1820, 1802, 
	1821, 1804, 1822, 1823, 1824, 1, 1, 1825, 
	1826, 1827, 1, 1811, 1828, 1, 1829, 1, 
	1830, 1831, 1832, 1833, 1, 1834, 1834, 1834, 
	1834, 1834, 1834, 1834, 1834, 1834, 1834, 1, 
	1, 1, 1, 1, 1, 1686, 1687, 1688, 
	1689, 1690, 1691, 1692, 1693, 1694, 1695, 1, 
	1, 1696, 1697, 1698, 1, 1699, 1700, 1, 
	1701, 1, 1702, 1703, 1, 1704, 1, 1705, 
	1, 1, 1, 1, 1, 1, 1706, 1707, 
	1708, 1690, 1709, 1692, 1710, 1711, 1712, 1, 
	1, 1713, 1714, 1715, 1, 1699, 1716, 1, 
	1717, 1, 1718, 1719, 1720, 1721, 1, 1835, 
	1836, 1837, 1838, 1839, 1840, 1841, 1842, 1843, 
	1844, 1, 1, 1845, 1846, 1847, 1, 1848, 
	1849, 1, 1850, 1, 1851, 1852, 1, 1853, 
	1, 1854, 1, 1, 1, 1, 1, 1, 
	1855, 1856, 1857, 1839, 1858, 1841, 1859, 1860, 
	1861, 1, 1, 1862, 1863, 1864, 1, 1848, 
	1865, 1, 1866, 1, 1867, 1868, 1869, 1870, 
	1, 1871, 1871, 1871, 1871, 1871, 1871, 1871, 
	1871, 1871, 1871, 1, 1, 1, 1, 1, 
	1, 1647, 1648, 1649, 1650, 1651, 1652, 1653, 
	1654, 1655, 1656, 1, 1, 1657, 1658, 1659, 
	1, 1660, 1661, 1, 1662, 1, 1663, 1664, 
	1, 1665, 1, 1666, 1, 1, 1, 1, 
	1, 1, 1667, 1668, 1669, 1651, 1670, 1653, 
	1671, 1672, 1673, 1, 1, 1674, 1675, 1676, 
	1, 1660, 1677, 1, 1678, 1, 1679, 1680, 
	1681, 1682, 1, 1872, 1873, 1874, 1875, 1876, 
	1877, 1878, 1879, 1880, 1881, 1, 1, 1882, 
	1883, 1884, 1, 1885, 1886, 1, 1887, 1, 
	1888, 1889, 1, 1890, 1, 1891, 1, 1, 
	1, 1, 1, 1, 1892, 1893, 1894, 1876, 
	1895, 1878, 1896, 1897, 1898, 1, 1, 1899, 
	1900, 1901, 1, 1885, 1902, 1, 1903, 1, 
	1904, 1905, 1906, 1907, 1, 1908, 1908, 1908, 
	1908, 1908, 1908, 1908, 1908, 1908, 1908, 1, 
	1, 1, 1, 1, 1, 1608, 1609, 1610, 
	1611, 1612, 1613, 1614, 1615, 1616, 1617, 1, 
	1, 1618, 1619, 1620, 1, 1621, 1622, 1, 
	1623, 1, 1624, 1625, 1, 1626, 1, 1627, 
	1, 1, 1, 1, 1, 1, 1628, 1629, 
	1630, 1612, 1631, 1614, 1632, 1633, 1634, 1, 
	1, 1635, 1636, 1637, 1, 1621, 1638, 1, 
	1639, 1, 1640, 1641, 1642, 1643, 1, 1909, 
	1909, 1909, 1909, 1909, 1909, 1909, 1909, 1909, 
	1909, 1, 1, 1, 1, 1, 1, 1531, 
	1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 
	1540, 1, 1, 1541, 1542, 1543, 1, 1544, 
	1545, 1, 1546, 1, 1547, 1548, 1, 1549, 
	1, 1550, 1, 1, 1, 1, 1, 1, 
	1551, 1552, 1553, 1535, 1554, 1537, 1555, 1556, 
	1557, 1, 1, 1558, 1559, 1560, 1, 1544, 
	1561, 1, 1562, 1, 1563, 1564, 1565, 1566, 
	1, 1910, 1, 1, 1, 1, 1, 1911, 
	1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911, 
	1911, 1, 1, 1, 1, 1, 1, 1912, 
	1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920, 
	1921, 1, 1, 1922, 1923, 1924, 1, 1925, 
	1926, 1, 1927, 1, 1928, 1929, 1, 1930, 
	1, 1931, 1, 1, 1, 1, 1, 1, 
	1932, 1933, 1934, 1916, 1935, 1918, 1936, 1937, 
	1938, 1, 1, 1939, 1940, 1941, 1, 1925, 
	1942, 1, 1943, 1, 1944, 1945, 1946, 1947, 
	1, 1948, 1949, 1950, 1951, 1952, 1953, 1954, 
	1955, 1956, 1957, 1, 1, 1958, 1959, 1960, 
	1, 1961, 1962, 1, 1963, 1, 1964, 1965, 
	1, 1966, 1, 1967, 1, 1, 1, 1, 
	1, 1, 1968, 1969, 1970, 1952, 1971, 1954, 
	1972, 1973, 1974, 1, 1, 1975, 1976, 1977, 
	1, 1961, 1978, 1, 1979, 1, 1980, 1981, 
	1982, 1983, 1, 1984, 1984, 1984, 1984, 1984, 
	1984, 1984, 1984, 1984, 1984, 1, 1, 1, 
	1, 1, 1, 1912, 1913, 1914, 1915, 1916, 
	1917, 1918, 1919, 1920, 1921, 1, 1, 1922, 
	1923, 1924, 1, 1925, 1926, 1, 1927, 1, 
	1928, 1929, 1, 1930, 1, 1931, 1, 1, 
	1, 1, 1, 1, 1932, 1933, 1934, 1916, 
	1935, 1918, 1936, 1937, 1938, 1, 1, 1939, 
	1940, 1941, 1, 1925, 1942, 1, 1943, 1, 
	1944, 1945, 1946, 1947, 1, 1985, 1, 1, 
	1, 1, 1, 1986, 1986, 1986, 1986, 1986, 
	1986, 1986, 1986, 1986, 1986, 1, 1, 1, 
	1, 1, 1, 1987, 1988, 1989, 1990, 1991, 
	1992, 1993, 1994, 1995, 1996, 1, 1, 1997, 
	1998, 1999, 1, 2000, 2001, 1, 2002, 1, 
	2003, 2004, 1, 2005, 1, 2006, 1, 1, 
	1, 1, 1, 1, 2007, 2008, 2009, 1991, 
	2010, 1993, 2011, 2012, 2013, 1, 1, 2014, 
	2015, 2016, 1, 2000, 2017, 1, 2018, 1, 
	2019, 2020, 2021, 2022, 1, 2023, 2024, 2025, 
	2026, 2027, 2028, 2029, 2030, 2031, 2032, 1, 
	1, 2033, 2034, 2035, 1, 2036, 2037, 1, 
	2038, 1, 2039, 2040, 1, 2041, 1, 2042, 
	1, 1, 1, 1, 1, 1, 2043, 2044, 
	2045, 2027, 2046, 2029, 2047, 2048, 2049, 1, 
	1, 2050, 2051, 2052, 1, 2036, 2053, 1, 
	2054, 1, 2055, 2056, 2057, 2058, 1, 2059, 
	2059, 2059, 2059, 2059, 2059, 2059, 2059, 2059, 
	2059, 1, 1, 1, 1, 1, 1, 1987, 
	1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 
	1996, 1, 1, 1997, 1998, 1999, 1, 2000, 
	2001, 1, 2002, 1, 2003, 2004, 1, 2005, 
	1, 2006, 1, 1, 1, 1, 1, 1, 
	2007, 2008, 2009, 1991, 2010, 1993, 2011, 2012, 
	2013, 1, 1, 2014, 2015, 2016, 1, 2000, 
	2017, 1, 2018, 1, 2019, 2020, 2021, 2022, 
	1, 1567, 1, 1, 1, 1, 1, 1, 
	1, 1, 1910, 1, 1, 1, 1, 1, 
	1911, 1911, 1911, 1911, 1911, 1911, 1911, 1911, 
	1911, 1911, 1, 1, 1, 1, 1, 1, 
	1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 
	1920, 1921, 1, 1, 1922, 1923, 1924, 1, 
	1925, 1926, 1, 1927, 1, 1928, 1929, 1, 
	1930, 1, 1931, 1, 1, 1, 1, 1567, 
	1, 1932, 1933, 1934, 1916, 1935, 1918, 1936, 
	1937, 1938, 1, 1, 1939, 1940, 1941, 1, 
	1925, 1942, 1, 1943, 1, 1944, 1945, 1946, 
	1947, 1, 1568, 1, 1, 1, 1, 1, 
	1, 1, 1, 1985, 1, 1, 1, 1, 
	1, 1986, 1986, 1986, 1986, 1986, 1986, 1986, 
	1986, 1986, 1986, 1, 1, 1, 1, 1, 
	1, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 
	1994, 1995, 1996, 1, 1, 1997, 1998, 1999, 
	1, 2000, 2001, 1, 2002, 1, 2003, 2004, 
	1, 2005, 1, 2006, 1, 1, 1, 1, 
	1568, 1, 2007, 2008, 2009, 1991, 2010, 1993, 
	2011, 2012, 2013, 1, 1, 2014, 2015, 2016, 
	1, 2000, 2017, 1, 2018, 1, 2019, 2020, 
	2021, 2022, 1, 2060, 2061, 2062, 2063, 2064, 
	2065, 2066, 2067, 2068, 2069, 1, 1, 2070, 
	2071, 2072, 1, 2073, 2074, 1, 2075, 1, 
	2076, 2077, 1, 2078, 1, 2079, 1, 1, 
	1, 1, 1, 1, 2080, 2081, 2082, 2064, 
	2083, 2066, 2084, 2085, 2086, 1, 1, 2087, 
	2088, 2089, 1, 2073, 2090, 1, 2091, 1, 
	2092, 2093, 2094, 2095, 1, 2096, 2096, 2096, 
	2096, 2096, 2096, 2096, 2096, 2096, 2096, 1, 
	1, 1, 1, 1, 1, 1490, 1491, 1492, 
	1493, 1494, 1495, 1496, 1497, 1498, 1499, 1, 
	1, 1500, 1501, 1502, 1, 1503, 1504, 1, 
	1505, 1, 1506, 1507, 1, 1508, 1, 1509, 
	1, 1, 1, 1, 1, 1, 1510, 1511, 
	1512, 1494, 1513, 1496, 1514, 1515, 1516, 1, 
	1, 1517, 1518, 1519, 1, 1503, 1520, 1, 
	1521, 1, 1522, 1523, 1524, 1525, 1, 2097, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	2098, 1, 1, 1, 1, 1, 2099, 2099, 
	2099, 2099, 2099, 2099, 2099, 2099, 2099, 2099, 
	1, 1, 1, 1, 1, 1, 2100, 2101, 
	2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 
	1, 1, 2110, 2111, 2112, 1, 2113, 2114, 
	1, 2115, 1, 2116, 2117, 1, 2118, 1, 
	2119, 1, 1, 1, 1, 2097, 1, 2120, 
	2121, 2122, 2104, 2123, 2106, 2124, 2125, 2126, 
	1, 1, 2127, 2128, 2129, 1, 2113, 2130, 
	1, 2131, 1, 2132, 2133, 2134, 2135, 1, 
	2100, 2101, 2102, 2103, 2104, 2105, 2106, 2107, 
	2108, 2109, 1, 1, 2110, 2111, 2112, 1, 
	2113, 2114, 1, 2115, 1, 2116, 2117, 1, 
	2118, 1, 2119, 1, 1, 1, 1, 1, 
	1, 2120, 2121, 2122, 2104, 2123, 2106, 2124, 
	2125, 2126, 1, 1, 2127, 2128, 2129, 1, 
	2113, 2130, 1, 2131, 1, 2132, 2133, 2134, 
	2135, 1, 2136, 2137, 2138, 2139, 2140, 2141, 
	2142, 2143, 2144, 2145, 1, 1, 2146, 2147, 
	2148, 1, 2149, 2150, 1, 2151, 1, 2152, 
	2153, 1, 2154, 1, 2155, 1, 1, 1, 
	1, 1, 1, 2156, 2157, 2158, 2140, 2159, 
	2142, 2160, 2161, 2162, 1, 1, 2163, 2164, 
	2165, 1, 2149, 2166, 1, 2167, 1, 2168, 
	2169, 2170, 2171, 1, 2172, 2172, 2172, 2172, 
	2172, 2172, 2172, 2172, 2172, 2172, 1, 1, 
	1, 1, 1, 1, 2100, 2101, 2102, 2103, 
	2104, 2105, 2106, 2107, 2108, 2109, 1, 1, 
	2110, 2111, 2112, 1, 2113, 2114, 1, 2115, 
	1, 2116, 2117, 1, 2118, 1, 2119, 1, 
	1, 1, 1, 1, 1, 2120, 2121, 2122, 
	2104, 2123, 2106, 2124, 2125, 2126, 1, 1, 
	2127, 2128, 2129, 1, 2113, 2130, 1, 2131, 
	1, 2132, 2133, 2134, 2135, 1, 2173, 1, 
	1, 1, 1, 1, 1, 1, 1, 2174, 
	1, 1, 1, 1, 1, 2175, 2175, 2175, 
	2175, 2175, 2175, 2175, 2175, 2175, 2175, 1, 
	1, 1, 1, 1, 1, 2176, 2177, 2178, 
	2179, 2180, 2181, 2182, 2183, 2184, 2185, 1, 
	1, 2186, 2187, 2188, 1, 2189, 2190, 1, 
	2191, 1, 2192, 2193, 1, 2194, 1, 2195, 
	1, 1, 1, 1, 2173, 1, 2196, 2197, 
	2198, 2180, 2199, 2182, 2200, 2201, 2202, 1, 
	1, 2203, 2204, 2205, 1, 2189, 2206, 1, 
	2207, 1, 2208, 2209, 2210, 2211, 1, 2176, 
	2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184, 
	2185, 1, 1, 2186, 2187, 2188, 1, 2189, 
	2190, 1, 2191, 1, 2192, 2193, 1, 2194, 
	1, 2195, 1, 1, 1, 1, 1, 1, 
	2196, 2197, 2198, 2180, 2199, 2182, 2200, 2201, 
	2202, 1, 1, 2203, 2204, 2205, 1, 2189, 
	2206, 1, 2207, 1, 2208, 2209, 2210, 2211, 
	1, 2212, 2213, 2214, 2215, 2216, 2217, 2218, 
	2219, 2220, 2221, 1, 1, 2222, 2223, 2224, 
	1, 2225, 2226, 1, 2227, 1, 2228, 2229, 
	1, 2230, 1, 2231, 1, 1, 1, 1, 
	1, 1, 2232, 2233, 2234, 2216, 2235, 2218, 
	2236, 2237, 2238, 1, 1, 2239, 2240, 2241, 
	1, 2225, 2242, 1, 2243, 1, 2244, 2245, 
	2246, 2247, 1, 2248, 2248, 2248, 2248, 2248, 
	2248, 2248, 2248, 2248, 2248, 1, 1, 1, 
	1, 1, 1, 2176, 2177, 2178, 2179, 2180, 
	2181, 2182, 2183, 2184, 2185, 1, 1, 2186, 
	2187, 2188, 1, 2189, 2190, 1, 2191, 1, 
	2192, 2193, 1, 2194, 1, 2195, 1, 1, 
	1, 1, 1, 1, 2196, 2197, 2198, 2180, 
	2199, 2182, 2200, 2201, 2202, 1, 1, 2203, 
	2204, 2205, 1, 2189, 2206, 1, 2207, 1, 
	2208, 2209, 2210, 2211, 1, 2249, 2250, 2251, 
	2252, 2253, 2254, 2255, 2256, 2257, 2258, 1, 
	1, 2259, 2260, 2261, 1, 2262, 2263, 1, 
	2264, 1, 2265, 2266, 1, 2267, 1, 2268, 
	1, 1, 1, 1, 1, 1, 2269, 2270, 
	2271, 2253, 2272, 2255, 2273, 2274, 2275, 1, 
	1, 2276, 2277, 2278, 1, 2262, 2279, 1, 
	2280, 1, 2281, 2282, 2283, 2284, 1, 2285, 
	2285, 2285, 2285, 2285, 2285, 2285, 2285, 2285, 
	2285, 1, 1, 1, 1, 1, 1, 1449, 
	1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 
	1458, 1, 1, 1459, 1460, 1461, 1, 1462, 
	1463, 1, 1464, 1, 1465, 1466, 1, 1467, 
	1, 1468, 1, 1, 1, 1, 1, 1, 
	1469, 1470, 1471, 1453, 1472, 1455, 1473, 1474, 
	1475, 1, 1, 1476, 1477, 1478, 1, 1462, 
	1479, 1, 1480, 1, 1481, 1482, 1483, 1484, 
	1, 2286, 2287, 2288, 2289, 2290, 2291, 2292, 
	2293, 2294, 2295, 1, 1, 2296, 2297, 2298, 
	1, 2299, 2300, 1, 2301, 1, 2302, 2303, 
	1, 2304, 1, 2305, 1, 1, 1, 1, 
	1, 1, 2306, 2307, 2308, 2290, 2309, 2292, 
	2310, 2311, 2312, 1, 1, 2313, 2314, 2315, 
	1, 2299, 2316, 1, 2317, 1, 2318, 2319, 
	2320, 2321, 1, 2322, 2322, 2322, 2322, 2322, 
	2322, 2322, 2322, 2322, 2322, 1, 1, 1, 
	1, 1, 1, 1410, 1411, 1412, 1413, 1414, 
	1415, 1416, 1417, 1418, 1419, 1, 1, 1420, 
	1421, 1422, 1, 1423, 1424, 1, 1425, 1, 
	1426, 1427, 1, 1428, 1, 1429, 1, 1, 
	1, 1, 1, 1, 1430, 1431, 1432, 1414, 
	1433, 1416, 1434, 1435, 1436, 1, 1, 1437, 
	1438, 1439, 1, 1423, 1440, 1, 1441, 1, 
	1442, 1443, 1444, 1445, 1, 2323, 2323, 2323, 
	2323, 2323, 2323, 2323, 2323, 2323, 2323, 1, 
	1, 1, 1, 1, 1, 1335, 1336, 1337, 
	1338, 1339, 1340, 1341, 1342, 1343, 1344, 1, 
	1, 1345, 1346, 1347, 1, 1348, 1349, 1, 
	1350, 1, 1351, 1352, 1, 1353, 1, 1354, 
	1, 1, 1, 1, 1, 1, 1355, 1356, 
	1357, 1339, 1358, 1341, 1359, 1360, 1361, 1, 
	1, 1362, 1363, 1364, 1, 1348, 1365, 1, 
	1366, 1, 1367, 1368, 1369, 1370, 1, 2324, 
	1, 1, 1, 1, 1, 2325, 2325, 2325, 
	2325, 2325, 2325, 2325, 2325, 2325, 2325, 1, 
	1, 1, 1, 1, 1, 2326, 2327, 2328, 
	2329, 2330, 2331, 2332, 2333, 2334, 2335, 1, 
	1, 2336, 2337, 2338, 1, 2339, 2340, 1, 
	2341, 1, 2342, 2343, 1, 2344, 1, 2345, 
	1, 1, 1, 1, 1, 1, 2346, 2347, 
	2348, 2330, 2349, 2332, 2350, 2351, 2352, 1, 
	1, 2353, 2354, 2355, 1, 2339, 2356, 1, 
	2357, 1, 2358, 2359, 2360, 2361, 1, 2362, 
	2363, 2364, 2365, 2366, 2367, 2368, 2369, 2370, 
	2371, 1, 1, 2372, 2373, 2374, 1, 2375, 
	2376, 1, 2377, 1, 2378, 2379, 1, 2380, 
	1, 2381, 1, 1, 1, 1, 1, 1, 
	2382, 2383, 2384, 2366, 2385, 2368, 2386, 2387, 
	2388, 1, 1, 2389, 2390, 2391, 1, 2375, 
	2392, 1, 2393, 1, 2394, 2395, 2396, 2397, 
	1, 2398, 2398, 2398, 2398, 2398, 2398, 2398, 
	2398, 2398, 2398, 1, 1, 1, 1, 1, 
	1, 2326, 2327, 2328, 2329, 2330, 2331, 2332, 
	2333, 2334, 2335, 1, 1, 2336, 2337, 2338, 
	1, 2339, 2340, 1, 2341, 1, 2342, 2343, 
	1, 2344, 1, 2345, 1, 1, 1, 1, 
	1, 1, 2346, 2347, 2348, 2330, 2349, 2332, 
	2350, 2351, 2352, 1, 1, 2353, 2354, 2355, 
	1, 2339, 2356, 1, 2357, 1, 2358, 2359, 
	2360, 2361, 1, 2399, 1, 1, 1, 1, 
	1, 2400, 2400, 2400, 2400, 2400, 2400, 2400, 
	2400, 2400, 2400, 1, 1, 1, 1, 1, 
	1, 2401, 2402, 2403, 2404, 2405, 2406, 2407, 
	2408, 2409, 2410, 1, 1, 2411, 2412, 2413, 
	1, 2414, 2415, 1, 2416, 1, 2417, 2418, 
	1, 2419, 1, 2420, 1, 1, 1, 1, 
	1, 1, 2421, 2422, 2423, 2405, 2424, 2407, 
	2425, 2426, 2427, 1, 1, 2428, 2429, 2430, 
	1, 2414, 2431, 1, 2432, 1, 2433, 2434, 
	2435, 2436, 1, 2437, 2438, 2439, 2440, 2441, 
	2442, 2443, 2444, 2445, 2446, 1, 1, 2447, 
	2448, 2449, 1, 2450, 2451, 1, 2452, 1, 
	2453, 2454, 1, 2455, 1, 2456, 1, 1, 
	1, 1, 1, 1, 2457, 2458, 2459, 2441, 
	2460, 2443, 2461, 2462, 2463, 1, 1, 2464, 
	2465, 2466, 1, 2450, 2467, 1, 2468, 1, 
	2469, 2470, 2471, 2472, 1, 2473, 2473, 2473, 
	2473, 2473, 2473, 2473, 2473, 2473, 2473, 1, 
	1, 1, 1, 1, 1, 2401, 2402, 2403, 
	2404, 2405, 2406, 2407, 2408, 2409, 2410, 1, 
	1, 2411, 2412, 2413, 1, 2414, 2415, 1, 
	2416, 1, 2417, 2418, 1, 2419, 1, 2420, 
	1, 1, 1, 1, 1, 1, 2421, 2422, 
	2423, 2405, 2424, 2407, 2425, 2426, 2427, 1, 
	1, 2428, 2429, 2430, 1, 2414, 2431, 1, 
	2432, 1, 2433, 2434, 2435, 2436, 1, 2474, 
	2475, 2476, 2477, 2478, 2479, 2480, 2481, 2482, 
	2483, 1, 1, 2484, 2485, 2486, 1, 2487, 
	2488, 1, 2489, 1, 2490, 2491, 1, 2492, 
	1, 2493, 1, 1, 1, 1, 1, 1, 
	2494, 2495, 2496, 2478, 2497, 2480, 2498, 2499, 
	2500, 1, 1, 2501, 2502, 2503, 1, 2487, 
	2504, 1, 2505, 1, 2506, 2507, 2508, 2509, 
	1, 2510, 2510, 2510, 2510, 2510, 2510, 2510, 
	2510, 2510, 2510, 1, 1, 1, 1, 1, 
	1, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 
	1302, 1303, 1304, 1, 1, 1305, 1306, 1307, 
	1, 1308, 1309, 1, 1310, 1, 1311, 1312, 
	1, 1313, 1, 1314, 1, 1, 1, 1, 
	1, 1, 1315, 1316, 1317, 1299, 1318, 1301, 
	1319, 1320, 1321, 1, 1, 1322, 1323, 1324, 
	1, 1308, 1325, 1, 1326, 1, 1327, 1328, 
	1329, 1330, 1, 1333, 1, 1, 1, 1, 
	1, 1, 1, 1, 2511, 1, 1, 1, 
	1, 1, 2512, 2512, 2512, 2512, 2512, 2512, 
	2512, 2512, 2512, 2512, 1, 1, 1, 1, 
	1, 1, 2513, 2514, 2515, 2516, 2517, 2518, 
	2519, 2520, 2521, 2522, 1, 1, 2523, 2524, 
	2525, 1, 2526, 2527, 1, 2528, 1, 2529, 
	2530, 1, 2531, 1, 2532, 1, 1, 1, 
	1, 1333, 1, 2533, 2534, 2535, 2517, 2536, 
	2519, 2537, 2538, 2539, 1, 1, 2540, 2541, 
	2542, 1, 2526, 2543, 1, 2544, 1, 2545, 
	2546, 2547, 2548, 1, 2549, 2550, 2551, 2552, 
	2553, 2554, 2555, 2556, 2557, 2558, 1, 1, 
	2559, 2560, 2561, 1, 2562, 2563, 1, 2564, 
	1, 2565, 2566, 1, 2567, 1, 2568, 1, 
	1, 1, 1, 1, 1, 2569, 2570, 2571, 
	2553, 2572, 2555, 2573, 2574, 2575, 1, 1, 
	2576, 2577, 2578, 1, 2562, 2579, 1, 2580, 
	1, 2581, 2582, 2583, 2584, 1, 2585, 2585, 
	2585, 2585, 2585, 2585, 2585, 2585, 2585, 2585, 
	1, 1, 1, 1, 1, 1, 2513, 2514, 
	2515, 2516, 2517, 2518, 2519, 2520, 2521, 2522, 
	1, 1, 2523, 2524, 2525, 1, 2526, 2527, 
	1, 2528, 1, 2529, 2530, 1, 2531, 1, 
	2532, 1, 1, 1, 1, 1, 1, 2533, 
	2534, 2535, 2517, 2536, 2519, 2537, 2538, 2539, 
	1, 1, 2540, 2541, 2542, 1, 2526, 2543, 
	1, 2544, 1, 2545, 2546, 2547, 2548, 1, 
	1334, 1, 1, 1, 1, 1, 1, 1, 
	1, 2586, 1, 1, 1, 1, 1, 2587, 
	2587, 2587, 2587, 2587, 2587, 2587, 2587, 2587, 
	2587, 1, 1, 1, 1, 1, 1, 2588, 
	2589, 2590, 2591, 2592, 2593, 2594, 2595, 2596, 
	2597, 1, 1, 2598, 2599, 2600, 1, 2601, 
	2602, 1, 2603, 1, 2604, 2605, 1, 2606, 
	1, 2607, 1, 1, 1, 1, 1334, 1, 
	2608, 2609, 2610, 2592, 2611, 2594, 2612, 2613, 
	2614, 1, 1, 2615, 2616, 2617, 1, 2601, 
	2618, 1, 2619, 1, 2620, 2621, 2622, 2623, 
	1, 2624, 2625, 2626, 2627, 2628, 2629, 2630, 
	2631, 2632, 2633, 1, 1, 2634, 2635, 2636, 
	1, 2637, 2638, 1, 2639, 1, 2640, 2641, 
	1, 2642, 1, 2643, 1, 1, 1, 1, 
	1, 1, 2644, 2645, 2646, 2628, 2647, 2630, 
	2648, 2649, 2650, 1, 1, 2651, 2652, 2653, 
	1, 2637, 2654, 1, 2655, 1, 2656, 2657, 
	2658, 2659, 1, 2660, 2660, 2660, 2660, 2660, 
	2660, 2660, 2660, 2660, 2660, 1, 1, 1, 
	1, 1, 1, 2588, 2589, 2590, 2591, 2592, 
	2593, 2594, 2595, 2596, 2597, 1, 1, 2598, 
	2599, 2600, 1, 2601, 2602, 1, 2603, 1, 
	2604, 2605, 1, 2606, 1, 2607, 1, 1, 
	1, 1, 1, 1, 2608, 2609, 2610, 2592, 
	2611, 2594, 2612, 2613, 2614, 1, 1, 2615, 
	2616, 2617, 1, 2601, 2618, 1, 2619, 1, 
	2620, 2621, 2622, 2623, 1, 2661, 2661, 2661, 
	2661, 2661, 2661, 2661, 2661, 2661, 2661, 1, 
	1, 1, 1, 1, 1, 1216, 1217, 1218, 
	1219, 1220, 1221, 1222, 1223, 1224, 1225, 1, 
	1, 1226, 1227, 1228, 1, 1229, 1230, 1, 
	1231, 1, 1232, 1233, 1, 1234, 1, 1235, 
	1, 1, 1, 1, 1, 1, 1236, 1237, 
	1238, 1220, 1239, 1222, 1240, 1241, 1242, 1, 
	1, 1243, 1244, 1245, 1, 1229, 1246, 1, 
	1247, 1, 1248, 1249, 1250, 1251, 1, 2662, 
	1, 1, 1, 1, 1, 2663, 2663, 2663, 
	2663, 2663, 2663, 2663, 2663, 2663, 2663, 1, 
	1, 1, 1, 1, 1, 2664, 2665, 2666, 
	2667, 2668, 2669, 2670, 2671, 2672, 2673, 1, 
	1, 2674, 2675, 2676, 1, 2677, 2678, 1, 
	2679, 1, 2680, 2681, 1, 2682, 1, 2683, 
	1, 1, 1, 1, 1, 1, 2684, 2685, 
	2686, 2668, 2687, 2670, 2688, 2689, 2690, 1, 
	1, 2691, 2692, 2693, 1, 2677, 2694, 1, 
	2695, 1, 2696, 2697, 2698, 2699, 1, 2700, 
	2701, 2702, 2703, 2704, 2705, 2706, 2707, 2708, 
	2709, 1, 1, 2710, 2711, 2712, 1, 2713, 
	2714, 1, 2715, 1, 2716, 2717, 1, 2718, 
	1, 2719, 1, 1, 1, 1, 1, 1, 
	2720, 2721, 2722, 2704, 2723, 2706, 2724, 2725, 
	2726, 1, 1, 2727, 2728, 2729, 1, 2713, 
	2730, 1, 2731, 1, 2732, 2733, 2734, 2735, 
	1, 2736, 2736, 2736, 2736, 2736, 2736, 2736, 
	2736, 2736, 2736, 1, 1, 1, 1, 1, 
	1, 2664, 2665, 2666, 2667, 2668, 2669, 2670, 
	2671, 2672, 2673, 1, 1, 2674, 2675, 2676, 
	1, 2677, 2678, 1, 2679, 1, 2680, 2681, 
	1, 2682, 1, 2683, 1, 1, 1, 1, 
	1, 1, 2684, 2685, 2686, 2668, 2687, 2670, 
	2688, 2689, 2690, 1, 1, 2691, 2692, 2693, 
	1, 2677, 2694, 1, 2695, 1, 2696, 2697, 
	2698, 2699, 1, 2737, 1, 1, 1, 1, 
	1, 2738, 2738, 2738, 2738, 2738, 2738, 2738, 
	2738, 2738, 2738, 1, 1, 1, 1, 1, 
	1, 2739, 2740, 2741, 2742, 2743, 2744, 2745, 
	2746, 2747, 2748, 1, 1, 2749, 2750, 2751, 
	1, 2752, 2753, 1, 2754, 1, 2755, 2756, 
	1, 2757, 1, 2758, 1, 1, 1, 1, 
	1, 1, 2759, 2760, 2761, 2743, 2762, 2745, 
	2763, 2764, 2765, 1, 1, 2766, 2767, 2768, 
	1, 2752, 2769, 1, 2770, 1, 2771, 2772, 
	2773, 2774, 1, 2775, 2776, 2777, 2778, 2779, 
	2780, 2781, 2782, 2783, 2784, 1, 1, 2785, 
	2786, 2787, 1, 2788, 2789, 1, 2790, 1, 
	2791, 2792, 1, 2793, 1, 2794, 1, 1, 
	1, 1, 1, 1, 2795, 2796, 2797, 2779, 
	2798, 2781, 2799, 2800, 2801, 1, 1, 2802, 
	2803, 2804, 1, 2788, 2805, 1, 2806, 1, 
	2807, 2808, 2809, 2810, 1, 2811, 2811, 2811, 
	2811, 2811, 2811, 2811, 2811, 2811, 2811, 1, 
	1, 1, 1, 1, 1, 2739, 2740, 2741, 
	2742, 2743, 2744, 2745, 2746, 2747, 2748, 1, 
	1, 2749, 2750, 2751, 1, 2752, 2753, 1, 
	2754, 1, 2755, 2756, 1, 2757, 1, 2758, 
	1, 1, 1, 1, 1, 1, 2759, 2760, 
	2761, 2743, 2762, 2745, 2763, 2764, 2765, 1, 
	1, 2766, 2767, 2768, 1, 2752, 2769, 1, 
	2770, 1, 2771, 2772, 2773, 2774, 1, 1252, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	2662, 1, 1, 1, 1, 1, 2663, 2663, 
	2663, 2663, 2663, 2663, 2663, 2663, 2663, 2663, 
	1, 1, 1, 1, 1, 1, 2664, 2665, 
	2666, 2667, 2668, 2669, 2670, 2671, 2672, 2673, 
	1, 1, 2674, 2675, 2676, 1, 2677, 2678, 
	1, 2679, 1, 2680, 2681, 1, 2682, 1, 
	2683, 1, 1, 1, 1, 1252, 1, 2684, 
	2685, 2686, 2668, 2687, 2670, 2688, 2689, 2690, 
	1, 1, 2691, 2692, 2693, 1, 2677, 2694, 
	1, 2695, 1, 2696, 2697, 2698, 2699, 1, 
	1253, 1, 1, 1, 1, 1, 1, 1, 
	1, 2737, 1, 1, 1, 1, 1, 2738, 
	2738, 2738, 2738, 2738, 2738, 2738, 2738, 2738, 
	2738, 1, 1, 1, 1, 1, 1, 2739, 
	2740, 2741, 2742, 2743, 2744, 2745, 2746, 2747, 
	2748, 1, 1, 2749, 2750, 2751, 1, 2752, 
	2753, 1, 2754, 1, 2755, 2756, 1, 2757, 
	1, 2758, 1, 1, 1, 1, 1253, 1, 
	2759, 2760, 2761, 2743, 2762, 2745, 2763, 2764, 
	2765, 1, 1, 2766, 2767, 2768, 1, 2752, 
	2769, 1, 2770, 1, 2771, 2772, 2773, 2774, 
	1, 2812, 2813, 2814, 2815, 2816, 2817, 2818, 
	2819, 2820, 2821, 1, 1, 2822, 2823, 2824, 
	1, 2825, 2826, 1, 2827, 1, 2828, 2829, 
	1, 2830, 1, 2831, 1, 1, 1, 1, 
	1, 1, 2832, 2833, 2834, 2816, 2835, 2818, 
	2836, 2837, 2838, 1, 1, 2839, 2840, 2841, 
	1, 2825, 2842, 1, 2843, 1, 2844, 2845, 
	2846, 2847, 1, 2848, 2848, 2848, 2848, 2848, 
	2848, 2848, 2848, 2848, 2848, 1, 1, 1, 
	1, 1, 1, 1175, 1176, 1177, 1178, 1179, 
	1180, 1181, 1182, 1183, 1184, 1, 1, 1185, 
	1186, 1187, 1, 1188, 1189, 1, 1190, 1, 
	1191, 1192, 1, 1193, 1, 1194, 1, 1, 
	1, 1, 1, 1, 1195, 1196, 1197, 1179, 
	1198, 1181, 1199, 1200, 1201, 1, 1, 1202, 
	1203, 1204, 1, 1188, 1205, 1, 1206, 1, 
	1207, 1208, 1209, 1210, 1, 2849, 2850, 2851, 
	2852, 2853, 2854, 2855, 2856, 2857, 2858, 1, 
	1, 2859, 2860, 2861, 1, 2862, 2863, 1, 
	2864, 1, 2865, 2866, 1, 2867, 1, 2868, 
	1, 1, 1, 1, 1, 1, 2869, 2870, 
	2871, 2853, 2872, 2855, 2873, 2874, 2875, 1, 
	1, 2876, 2877, 2878, 1, 2862, 2879, 1, 
	2880, 1, 2881, 2882, 2883, 2884, 1, 2885, 
	2885, 2885, 2885, 2885, 2885, 2885, 2885, 2885, 
	2885, 1, 1, 1, 1, 1, 1, 1136, 
	1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 
	1145, 1, 1, 1146, 1147, 1148, 1, 1149, 
	1150, 1, 1151, 1, 1152, 1153, 1, 1154, 
	1, 1155, 1, 1, 1, 1, 1, 1, 
	1156, 1157, 1158, 1140, 1159, 1142, 1160, 1161, 
	1162, 1, 1, 1163, 1164, 1165, 1, 1149, 
	1166, 1, 1167, 1, 1168, 1169, 1170, 1171, 
	1, 2886, 2887, 2888, 2889, 2890, 2891, 2892, 
	2893, 2894, 2895, 1, 1, 2896, 2897, 2898, 
	1, 2899, 2900, 1, 2901, 1, 2902, 2903, 
	1, 2904, 1, 2905, 1, 1, 1, 1, 
	1, 1, 2906, 2907, 2908, 2890, 2909, 2892, 
	2910, 2911, 2912, 1, 1, 2913, 2914, 2915, 
	1, 2899, 2916, 1, 2917, 1, 2918, 2919, 
	2920, 2921, 1, 2922, 2922, 2922, 2922, 2922, 
	2922, 2922, 2922, 2922, 2922, 1, 1, 1, 
	1, 1, 1, 1097, 1098, 1099, 1100, 1101, 
	1102, 1103, 1104, 1105, 1106, 1, 1, 1107, 
	1108, 1109, 1, 1110, 1111, 1, 1112, 1, 
	1113, 1114, 1, 1115, 1, 1116, 1, 1, 
	1, 1, 1, 1, 1117, 1118, 1119, 1101, 
	1120, 1103, 1121, 1122, 1123, 1, 1, 1124, 
	1125, 1126, 1, 1110, 1127, 1, 1128, 1, 
	1129, 1130, 1131, 1132, 1, 2923, 2924, 2925, 
	2926, 2927, 2928, 2929, 2930, 2931, 2932, 1, 
	1, 2933, 2934, 2935, 1, 2936, 2937, 1, 
	2938, 1, 2939, 2940, 1, 2941, 1, 2942, 
	1, 1, 1, 1, 1, 1, 2943, 2944, 
	2945, 2927, 2946, 2929, 2947, 2948, 2949, 1, 
	1, 2950, 2951, 2952, 1, 2936, 2953, 1, 
	2954, 1, 2955, 2956, 2957, 2958, 1, 2959, 
	2959, 2959, 2959, 2959, 2959, 2959, 2959, 2959, 
	2959, 1, 1, 1, 1, 1, 1, 1058, 
	1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 
	1067, 1, 1, 1068, 1069, 1070, 1, 1071, 
	1072, 1, 1073, 1, 1074, 1075, 1, 1076, 
	1, 1077, 1, 1, 1, 1, 1, 1, 
	1078, 1079, 1080, 1062, 1081, 1064, 1082, 1083, 
	1084, 1, 1, 1085, 1086, 1087, 1, 1071, 
	1088, 1, 1089, 1, 1090, 1091, 1092, 1093, 
	1, 2960, 2961, 2962, 2963, 2964, 2965, 2966, 
	2967, 2968, 2969, 1, 1, 2970, 2971, 2972, 
	1, 2973, 2974, 1, 2975, 1, 2976, 2977, 
	1, 2978, 1, 2979, 1, 1, 1, 1, 
	1, 1, 2980, 2981, 2982, 2964, 2983, 2966, 
	2984, 2985, 2986, 1, 1, 2987, 2988, 2989, 
	1, 2973, 2990, 1, 2991, 1, 2992, 2993, 
	2994, 2995, 1, 2996, 2996, 2996, 2996, 2996, 
	2996, 2996, 2996, 2996, 2996, 1, 1, 1, 
	1, 1, 1, 1019, 1020, 1021, 1022, 1023, 
	1024, 1025, 1026, 1027, 1028, 1, 1, 1029, 
	1030, 1031, 1, 1032, 1033, 1, 1034, 1, 
	1035, 1036, 1, 1037, 1, 1038, 1, 1, 
	1, 1, 1, 1, 1039, 1040, 1041, 1023, 
	1042, 1025, 1043, 1044, 1045, 1, 1, 1046, 
	1047, 1048, 1, 1032, 1049, 1, 1050, 1, 
	1051, 1052, 1053, 1054, 1, 2997, 2998, 2999, 
	3000, 3001, 3002, 3003, 3004, 3005, 3006, 1, 
	1, 3007, 3008, 3009, 1, 3010, 3011, 1, 
	3012, 1, 3013, 3014, 1, 3015, 1, 3016, 
	1, 1, 1, 1, 1, 1, 3017, 3018, 
	3019, 3001, 3020, 3003, 3021, 3022, 3023, 1, 
	1, 3024, 3025, 3026, 1, 3010, 3027, 1, 
	3028, 1, 3029, 3030, 3031, 3032, 1, 3033, 
	3033, 3033, 3033, 3033, 3033, 3033, 3033, 3033, 
	3033, 1, 1, 1, 1, 1, 1, 980, 
	981, 982, 983, 984, 985, 986, 987, 988, 
	989, 1, 1, 990, 991, 992, 1, 993, 
	994, 1, 995, 1, 996, 997, 1, 998, 
	1, 999, 1, 1, 1, 1, 1, 1, 
	1000, 1001, 1002, 984, 1003, 986, 1004, 1005, 
	1006, 1, 1, 1007, 1008, 1009, 1, 993, 
	1010, 1, 1011, 1, 1012, 1013, 1014, 1015, 
	1, 3034, 3035, 3036, 3037, 3038, 3039, 3040, 
	3041, 3042, 3043, 1, 1, 3044, 3045, 3046, 
	1, 3047, 3048, 1, 3049, 1, 3050, 3051, 
	1, 3052, 1, 3053, 1, 1, 1, 1, 
	1, 1, 3054, 3055, 3056, 3038, 3057, 3040, 
	3058, 3059, 3060, 1, 1, 3061, 3062, 3063, 
	1, 3047, 3064, 1, 3065, 1, 3066, 3067, 
	3068, 3069, 1, 3070, 3070, 3070, 3070, 3070, 
	3070, 3070, 3070, 3070, 3070, 1, 1, 1, 
	1, 1, 1, 941, 942, 943, 944, 945, 
	946, 947, 948, 949, 950, 1, 1, 951, 
	952, 953, 1, 954, 955, 1, 956, 1, 
	957, 958, 1, 959, 1, 960, 1, 1, 
	1, 1, 1, 1, 961, 962, 963, 945, 
	964, 947, 965, 966, 967, 1, 1, 968, 
	969, 970, 1, 954, 971, 1, 972, 1, 
	973, 974, 975, 976, 1, 3071, 3072, 3073, 
	3074, 3075, 3076, 3077, 3078, 3079, 3080, 1, 
	1, 3081, 3082, 3083, 1, 3084, 3085, 1, 
	3086, 1, 3087, 3088, 1, 3089, 1, 3090, 
	1, 1, 1, 1, 1, 1, 3091, 3092, 
	3093, 3075, 3094, 3077, 3095, 3096, 3097, 1, 
	1, 3098, 3099, 3100, 1, 3084, 3101, 1, 
	3102, 1, 3103, 3104, 3105, 3106, 1, 3107, 
	3107, 3107, 3107, 3107, 3107, 3107, 3107, 3107, 
	3107, 1, 1, 1, 1, 1, 1, 902, 
	903, 904, 905, 906, 907, 908, 909, 910, 
	911, 1, 1, 912, 913, 914, 1, 915, 
	916, 1, 917, 1, 918, 919, 1, 920, 
	1, 921, 1, 1, 1, 1, 1, 1, 
	922, 923, 924, 906, 925, 908, 926, 927, 
	928, 1, 1, 929, 930, 931, 1, 915, 
	932, 1, 933, 1, 934, 935, 936, 937, 
	1, 3108, 3109, 3110, 3111, 3112, 3113, 3114, 
	3115, 3116, 3117, 1, 1, 3118, 3119, 3120, 
	1, 3121, 3122, 1, 3123, 1, 3124, 3125, 
	1, 3126, 1, 3127, 1, 1, 1, 1, 
	1, 1, 3128, 3129, 3130, 3112, 3131, 3114, 
	3132, 3133, 3134, 1, 1, 3135, 3136, 3137, 
	1, 3121, 3138, 1, 3139, 1, 3140, 3141, 
	3142, 3143, 1, 3144, 3144, 3144, 3144, 3144, 
	3144, 3144, 3144, 3144, 3144, 1, 1, 1, 
	1, 1, 1, 863, 864, 865, 866, 867, 
	868, 869, 870, 871, 872, 1, 1, 873, 
	874, 875, 1, 876, 877, 1, 878, 1, 
	879, 880, 1, 881, 1, 882, 1, 1, 
	1, 1, 1, 1, 883, 884, 885, 867, 
	886, 869, 887, 888, 889, 1, 1, 890, 
	891, 892, 1, 876, 893, 1, 894, 1, 
	895, 896, 897, 898, 1, 3145, 3146, 3147, 
	3148, 3149, 3150, 3151, 3152, 3153, 3154, 1, 
	1, 3155, 3156, 3157, 1, 3158, 3159, 1, 
	3160, 1, 3161, 3162, 1, 3163, 1, 3164, 
	1, 1, 1, 1, 1, 1, 3165, 3166, 
	3167, 3149, 3168, 3151, 3169, 3170, 3171, 1, 
	1, 3172, 3173, 3174, 1, 3158, 3175, 1, 
	3176, 1, 3177, 3178, 3179, 3180, 1, 3181, 
	3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 
	3181, 1, 1, 1, 1, 1, 1, 824, 
	825, 826, 827, 828, 829, 830, 831, 832, 
	833, 1, 1, 834, 835, 836, 1, 837, 
	838, 1, 839, 1, 840, 841, 1, 842, 
	1, 843, 1, 1, 1, 1, 1, 1, 
	844, 845, 846, 828, 847, 830, 848, 849, 
	850, 1, 1, 851, 852, 853, 1, 837, 
	854, 1, 855, 1, 856, 857, 858, 859, 
	1, 3182, 3182, 3182, 3182, 3182, 3182, 3182, 
	3182, 3182, 3182, 1, 1, 1, 1, 1, 
	1, 747, 748, 749, 750, 751, 752, 753, 
	754, 755, 756, 1, 1, 757, 758, 759, 
	1, 760, 761, 1, 762, 1, 763, 764, 
	1, 765, 1, 766, 1, 1, 1, 1, 
	1, 1, 767, 768, 769, 751, 770, 753, 
	771, 772, 773, 1, 1, 774, 775, 776, 
	1, 760, 777, 1, 778, 1, 779, 780, 
	781, 782, 1, 3183, 1, 1, 1, 1, 
	1, 3184, 3184, 3184, 3184, 3184, 3184, 3184, 
	3184, 3184, 3184, 1, 1, 1, 1, 1, 
	1, 3185, 3186, 3187, 3188, 3189, 3190, 3191, 
	3192, 3193, 3194, 1, 1, 3195, 3196, 3197, 
	1, 3198, 3199, 1, 3200, 1, 3201, 3202, 
	1, 3203, 1, 3204, 1, 1, 1, 1, 
	1, 1, 3205, 3206, 3207, 3189, 3208, 3191, 
	3209, 3210, 3211, 1, 1, 3212, 3213, 3214, 
	1, 3198, 3215, 1, 3216, 1, 3217, 3218, 
	3219, 3220, 1, 3221, 3222, 3223, 3224, 3225, 
	3226, 3227, 3228, 3229, 3230, 1, 1, 3231, 
	3232, 3233, 1, 3234, 3235, 1, 3236, 1, 
	3237, 3238, 1, 3239, 1, 3240, 1, 1, 
	1, 1, 1, 1, 3241, 3242, 3243, 3225, 
	3244, 3227, 3245, 3246, 3247, 1, 1, 3248, 
	3249, 3250, 1, 3234, 3251, 1, 3252, 1, 
	3253, 3254, 3255, 3256, 1, 3257, 3257, 3257, 
	3257, 3257, 3257, 3257, 3257, 3257, 3257, 1, 
	1, 1, 1, 1, 1, 3185, 3186, 3187, 
	3188, 3189, 3190, 3191, 3192, 3193, 3194, 1, 
	1, 3195, 3196, 3197, 1, 3198, 3199, 1, 
	3200, 1, 3201, 3202, 1, 3203, 1, 3204, 
	1, 1, 1, 1, 1, 1, 3205, 3206, 
	3207, 3189, 3208, 3191, 3209, 3210, 3211, 1, 
	1, 3212, 3213, 3214, 1, 3198, 3215, 1, 
	3216, 1, 3217, 3218, 3219, 3220, 1, 3258, 
	1, 1, 1, 1, 1, 3259, 3259, 3259, 
	3259, 3259, 3259, 3259, 3259, 3259, 3259, 1, 
	1, 1, 1, 1, 1, 3260, 3261, 3262, 
	3263, 3264, 3265, 3266, 3267, 3268, 3269, 1, 
	1, 3270, 3271, 3272, 1, 3273, 3274, 1, 
	3275, 1, 3276, 3277, 1, 3278, 1, 3279, 
	1, 1, 1, 1, 1, 1, 3280, 3281, 
	3282, 3264, 3283, 3266, 3284, 3285, 3286, 1, 
	1, 3287, 3288, 3289, 1, 3273, 3290, 1, 
	3291, 1, 3292, 3293, 3294, 3295, 1, 3296, 
	3297, 3298, 3299, 3300, 3301, 3302, 3303, 3304, 
	3305, 1, 1, 3306, 3307, 3308, 1, 3309, 
	3310, 1, 3311, 1, 3312, 3313, 1, 3314, 
	1, 3315, 1, 1, 1, 1, 1, 1, 
	3316, 3317, 3318, 3300, 3319, 3302, 3320, 3321, 
	3322, 1, 1, 3323, 3324, 3325, 1, 3309, 
	3326, 1, 3327, 1, 3328, 3329, 3330, 3331, 
	1, 3332, 3332, 3332, 3332, 3332, 3332, 3332, 
	3332, 3332, 3332, 1, 1, 1, 1, 1, 
	1, 3260, 3261, 3262, 3263, 3264, 3265, 3266, 
	3267, 3268, 3269, 1, 1, 3270, 3271, 3272, 
	1, 3273, 3274, 1, 3275, 1, 3276, 3277, 
	1, 3278, 1, 3279, 1, 1, 1, 1, 
	1, 1, 3280, 3281, 3282, 3264, 3283, 3266, 
	3284, 3285, 3286, 1, 1, 3287, 3288, 3289, 
	1, 3273, 3290, 1, 3291, 1, 3292, 3293, 
	3294, 3295, 1, 783, 1, 1, 1, 1, 
	1, 1, 1, 1, 3183, 1, 1, 1, 
	1, 1, 3184, 3184, 3184, 3184, 3184, 3184, 
	3184, 3184, 3184, 3184, 1, 1, 1, 1, 
	1, 1, 3185, 3186, 3187, 3188, 3189, 3190, 
	3191, 3192, 3193, 3194, 1, 1, 3195, 3196, 
	3197, 1, 3198, 3199, 1, 3200, 1, 3201, 
	3202, 1, 3203, 1, 3204, 1, 1, 1, 
	1, 783, 1, 3205, 3206, 3207, 3189, 3208, 
	3191, 3209, 3210, 3211, 1, 1, 3212, 3213, 
	3214, 1, 3198, 3215, 1, 3216, 1, 3217, 
	3218, 3219, 3220, 1, 784, 1, 1, 1, 
	1, 1, 1, 1, 1, 3258, 1, 1, 
	1, 1, 1, 3259, 3259, 3259, 3259, 3259, 
	3259, 3259, 3259, 3259, 3259, 1, 1, 1, 
	1, 1, 1, 3260, 3261, 3262, 3263, 3264, 
	3265, 3266, 3267, 3268, 3269, 1, 1, 3270, 
	3271, 3272, 1, 3273, 3274, 1, 3275, 1, 
	3276, 3277, 1, 3278, 1, 3279, 1, 1, 
	1, 1, 784, 1, 3280, 3281, 3282, 3264, 
	3283, 3266, 3284, 3285, 3286, 1, 1, 3287, 
	3288, 3289, 1, 3273, 3290, 1, 3291, 1, 
	3292, 3293, 3294, 3295, 1, 3333, 3334, 3335, 
	3336, 3337, 3338, 3339, 3340, 3341, 3342, 1, 
	1, 3343, 3344, 3345, 1, 3346, 3347, 1, 
	3348, 1, 3349, 3350, 1, 3351, 1, 3352, 
	1, 1, 1, 1, 1, 1, 3353, 3354, 
	3355, 3337, 3356, 3339, 3357, 3358, 3359, 1, 
	1, 3360, 3361, 3362, 1, 3346, 3363, 1, 
	3364, 1, 3365, 3366, 3367, 3368, 1, 3369, 
	3369, 3369, 3369, 3369, 3369, 3369, 3369, 3369, 
	3369, 1, 1, 1, 1, 1, 1, 706, 
	707, 708, 709, 710, 711, 712, 713, 714, 
	715, 1, 1, 716, 717, 718, 1, 719, 
	720, 1, 721, 1, 722, 723, 1, 724, 
	1, 725, 1, 1, 1, 1, 1, 1, 
	726, 727, 728, 710, 729, 712, 730, 731, 
	732, 1, 1, 733, 734, 735, 1, 719, 
	736, 1, 737, 1, 738, 739, 740, 741, 
	1, 3370, 1, 1, 1, 1, 1, 1, 
	1, 1, 3371, 1, 1, 1, 1, 1, 
	3372, 3372, 3372, 3372, 3372, 3372, 3372, 3372, 
	3372, 3372, 1, 1, 1, 1, 1, 1, 
	3373, 3374, 3375, 3376, 3377, 3378, 3379, 3380, 
	3381, 3382, 1, 1, 3383, 3384, 3385, 1, 
	3386, 3387, 1, 3388, 1, 3389, 3390, 1, 
	3391, 1, 3392, 1, 1, 1, 1, 3370, 
	1, 3393, 3394, 3395, 3377, 3396, 3379, 3397, 
	3398, 3399, 1, 1, 3400, 3401, 3402, 1, 
	3386, 3403, 1, 3404, 1, 3405, 3406, 3407, 
	3408, 1, 3373, 3374, 3375, 3376, 3377, 3378, 
	3379, 3380, 3381, 3382, 1, 1, 3383, 3384, 
	3385, 1, 3386, 3387, 1, 3388, 1, 3389, 
	3390, 1, 3391, 1, 3392, 1, 1, 1, 
	1, 1, 1, 3393, 3394, 3395, 3377, 3396, 
	3379, 3397, 3398, 3399, 1, 1, 3400, 3401, 
	3402, 1, 3386, 3403, 1, 3404, 1, 3405, 
	3406, 3407, 3408, 1, 3409, 3410, 3411, 3412, 
	3413, 3414, 3415, 3416, 3417, 3418, 1, 1, 
	3419, 3420, 3421, 1, 3422, 3423, 1, 3424, 
	1, 3425, 3426, 1, 3427, 1, 3428, 1, 
	1, 1, 1, 1, 1, 3429, 3430, 3431, 
	3413, 3432, 3415, 3433, 3434, 3435, 1, 1, 
	3436, 3437, 3438, 1, 3422, 3439, 1, 3440, 
	1, 3441, 3442, 3443, 3444, 1, 3445, 3445, 
	3445, 3445, 3445, 3445, 3445, 3445, 3445, 3445, 
	1, 1, 1, 1, 1, 1, 3373, 3374, 
	3375, 3376, 3377, 3378, 3379, 3380, 3381, 3382, 
	1, 1, 3383, 3384, 3385, 1, 3386, 3387, 
	1, 3388, 1, 3389, 3390, 1, 3391, 1, 
	3392, 1, 1, 1, 1, 1, 1, 3393, 
	3394, 3395, 3377, 3396, 3379, 3397, 3398, 3399, 
	1, 1, 3400, 3401, 3402, 1, 3386, 3403, 
	1, 3404, 1, 3405, 3406, 3407, 3408, 1, 
	3446, 1, 1, 1, 1, 1, 1, 1, 
	1, 3447, 1, 1, 1, 1, 1, 3448, 
	3448, 3448, 3448, 3448, 3448, 3448, 3448, 3448, 
	3448, 1, 1, 1, 1, 1, 1, 3449, 
	3450, 3451, 3452, 3453, 3454, 3455, 3456, 3457, 
	3458, 1, 1, 3459, 3460, 3461, 1, 3462, 
	3463, 1, 3464, 1, 3465, 3466, 1, 3467, 
	1, 3468, 1, 1, 1, 1, 3446, 1, 
	3469, 3470, 3471, 3453, 3472, 3455, 3473, 3474, 
	3475, 1, 1, 3476, 3477, 3478, 1, 3462, 
	3479, 1, 3480, 1, 3481, 3482, 3483, 3484, 
	1, 3449, 3450, 3451, 3452, 3453, 3454, 3455, 
	3456, 3457, 3458, 1, 1, 3459, 3460, 3461, 
	1, 3462, 3463, 1, 3464, 1, 3465, 3466, 
	1, 3467, 1, 3468, 1, 1, 1, 1, 
	1, 1, 3469, 3470, 3471, 3453, 3472, 3455, 
	3473, 3474, 3475, 1, 1, 3476, 3477, 3478, 
	1, 3462, 3479, 1, 3480, 1, 3481, 3482, 
	3483, 3484, 1, 3485, 3486, 3487, 3488, 3489, 
	3490, 3491, 3492, 3493, 3494, 1, 1, 3495, 
	3496, 3497, 1, 3498, 3499, 1, 3500, 1, 
	3501, 3502, 1, 3503, 1, 3504, 1, 1, 
	1, 1, 1, 1, 3505, 3506, 3507, 3489, 
	3508, 3491, 3509, 3510, 3511, 1, 1, 3512, 
	3513, 3514, 1, 3498, 3515, 1, 3516, 1, 
	3517, 3518, 3519, 3520, 1, 3521, 3521, 3521, 
	3521, 3521, 3521, 3521, 3521, 3521, 3521, 1, 
	1, 1, 1, 1, 1, 3449, 3450, 3451, 
	3452, 3453, 3454, 3455, 3456, 3457, 3458, 1, 
	1, 3459, 3460, 3461, 1, 3462, 3463, 1, 
	3464, 1, 3465, 3466, 1, 3467, 1, 3468, 
	1, 1, 1, 1, 1, 1, 3469, 3470, 
	3471, 3453, 3472, 3455, 3473, 3474, 3475, 1, 
	1, 3476, 3477, 3478, 1, 3462, 3479, 1, 
	3480, 1, 3481, 3482, 3483, 3484, 1, 3522, 
	3523, 3524, 3525, 3526, 3527, 3528, 3529, 3530, 
	3531, 1, 1, 3532, 3533, 3534, 1, 3535, 
	3536, 1, 3537, 1, 3538, 3539, 1, 3540, 
	1, 3541, 1, 1, 1, 1, 1, 1, 
	3542, 3543, 3544, 3526, 3545, 3528, 3546, 3547, 
	3548, 1, 1, 3549, 3550, 3551, 1, 3535, 
	3552, 1, 3553, 1, 3554, 3555, 3556, 3557, 
	1, 3558, 3558, 3558, 3558, 3558, 3558, 3558, 
	3558, 3558, 3558, 1, 1, 1, 1, 1, 
	1, 665, 666, 667, 668, 669, 670, 671, 
	672, 673, 674, 1, 1, 675, 676, 677, 
	1, 678, 679, 1, 680, 1, 681, 682, 
	1, 683, 1, 684, 1, 1, 1, 1, 
	1, 1, 685, 686, 687, 669, 688, 671, 
	689, 690, 691, 1, 1, 692, 693, 694, 
	1, 678, 695, 1, 696, 1, 697, 698, 
	699, 700, 1, 3559, 3560, 3561, 3562, 3563, 
	3564, 3565, 3566, 3567, 3568, 1, 1, 3569, 
	3570, 3571, 1, 3572, 3573, 1, 3574, 1, 
	3575, 3576, 1, 3577, 1, 3578, 1, 1, 
	1, 1, 1, 1, 3579, 3580, 3581, 3563, 
	3582, 3565, 3583, 3584, 3585, 1, 1, 3586, 
	3587, 3588, 1, 3572, 3589, 1, 3590, 1, 
	3591, 3592, 3593, 3594, 1, 3595, 3595, 3595, 
	3595, 3595, 3595, 3595, 3595, 3595, 3595, 1, 
	1, 1, 1, 1, 1, 626, 627, 628, 
	629, 630, 631, 632, 633, 634, 635, 1, 
	1, 636, 637, 638, 1, 639, 640, 1, 
	641, 1, 642, 643, 1, 644, 1, 645, 
	1, 1, 1, 1, 1, 1, 646, 647, 
	648, 630, 649, 632, 650, 651, 652, 1, 
	1, 653, 654, 655, 1, 639, 656, 1, 
	657, 1, 658, 659, 660, 661, 1, 3596, 
	3597, 3598, 3599, 3600, 3601, 3602, 3603, 3604, 
	3605, 1, 1, 3606, 3607, 3608, 1, 3609, 
	3610, 1, 3611, 1, 3612, 3613, 1, 3614, 
	1, 3615, 1, 1, 1, 1, 1, 1, 
	3616, 3617, 3618, 3600, 3619, 3602, 3620, 3621, 
	3622, 1, 1, 3623, 3624, 3625, 1, 3609, 
	3626, 1, 3627, 1, 3628, 3629, 3630, 3631, 
	1, 3632, 3632, 3632, 3632, 3632, 3632, 3632, 
	3632, 3632, 3632, 1, 1, 1, 1, 1, 
	1, 587, 588, 589, 590, 591, 592, 593, 
	594, 595, 596, 1, 1, 597, 598, 599, 
	1, 600, 601, 1, 602, 1, 603, 604, 
	1, 605, 1, 606, 1, 1, 1, 1, 
	1, 1, 607, 608, 609, 591, 610, 593, 
	611, 612, 613, 1, 1, 614, 615, 616, 
	1, 600, 617, 1, 618, 1, 619, 620, 
	621, 622, 1, 3633, 3633, 3633, 3633, 3633, 
	3633, 3633, 3633, 3633, 3633, 1, 1, 1, 
	1, 1, 1, 512, 513, 514, 515, 516, 
	517, 518, 519, 520, 521, 1, 1, 522, 
	523, 524, 1, 525, 526, 1, 527, 1, 
	528, 529, 1, 530, 1, 531, 1, 1, 
	1, 1, 1, 1, 532, 533, 534, 516, 
	535, 518, 536, 537, 538, 1, 1, 539, 
	540, 541, 1, 525, 542, 1, 543, 1, 
	544, 545, 546, 547, 1, 3634, 1, 1, 
	1, 1, 1, 3635, 3635, 3635, 3635, 3635, 
	3635, 3635, 3635, 3635, 3635, 1, 1, 1, 
	1, 1, 1, 3636, 3637, 3638, 3639, 3640, 
	3641, 3642, 3643, 3644, 3645, 1, 1, 3646, 
	3647, 3648, 1, 3649, 3650, 1, 3651, 1, 
	3652, 3653, 1, 3654, 1, 3655, 1, 1, 
	1, 1, 1, 1, 3656, 3657, 3658, 3640, 
	3659, 3642, 3660, 3661, 3662, 1, 1, 3663, 
	3664, 3665, 1, 3649, 3666, 1, 3667, 1, 
	3668, 3669, 3670, 3671, 1, 3672, 3673, 3674, 
	3675, 3676, 3677, 3678, 3679, 3680, 3681, 1, 
	1, 3682, 3683, 3684, 1, 3685, 3686, 1, 
	3687, 1, 3688, 3689, 1, 3690, 1, 3691, 
	1, 1, 1, 1, 1, 1, 3692, 3693, 
	3694, 3676, 3695, 3678, 3696, 3697, 3698, 1, 
	1, 3699, 3700, 3701, 1, 3685, 3702, 1, 
	3703, 1, 3704, 3705, 3706, 3707, 1, 3708, 
	3708, 3708, 3708, 3708, 3708, 3708, 3708, 3708, 
	3708, 1, 1, 1, 1, 1, 1, 3636, 
	3637, 3638, 3639, 3640, 3641, 3642, 3643, 3644, 
	3645, 1, 1, 3646, 3647, 3648, 1, 3649, 
	3650, 1, 3651, 1, 3652, 3653, 1, 3654, 
	1, 3655, 1, 1, 1, 1, 1, 1, 
	3656, 3657, 3658, 3640, 3659, 3642, 3660, 3661, 
	3662, 1, 1, 3663, 3664, 3665, 1, 3649, 
	3666, 1, 3667, 1, 3668, 3669, 3670, 3671, 
	1, 3709, 1, 1, 1, 1, 1, 3710, 
	3710, 3710, 3710, 3710, 3710, 3710, 3710, 3710, 
	3710, 1, 1, 1, 1, 1, 1, 3711, 
	3712, 3713, 3714, 3715, 3716, 3717, 3718, 3719, 
	3720, 1, 1, 3721, 3722, 3723, 1, 3724, 
	3725, 1, 3726, 1, 3727, 3728, 1, 3729, 
	1, 3730, 1, 1, 1, 1, 1, 1, 
	3731, 3732, 3733, 3715, 3734, 3717, 3735, 3736, 
	3737, 1, 1, 3738, 3739, 3740, 1, 3724, 
	3741, 1, 3742, 1, 3743, 3744, 3745, 3746, 
	1, 3747, 3748, 3749, 3750, 3751, 3752, 3753, 
	3754, 3755, 3756, 1, 1, 3757, 3758, 3759, 
	1, 3760, 3761, 1, 3762, 1, 3763, 3764, 
	1, 3765, 1, 3766, 1, 1, 1, 1, 
	1, 1, 3767, 3768, 3769, 3751, 3770, 3753, 
	3771, 3772, 3773, 1, 1, 3774, 3775, 3776, 
	1, 3760, 3777, 1, 3778, 1, 3779, 3780, 
	3781, 3782, 1, 3783, 3783, 3783, 3783, 3783, 
	3783, 3783, 3783, 3783, 3783, 1, 1, 1, 
	1, 1, 1, 3711, 3712, 3713, 3714, 3715, 
	3716, 3717, 3718, 3719, 3720, 1, 1, 3721, 
	3722, 3723, 1, 3724, 3725, 1, 3726, 1, 
	3727, 3728, 1, 3729, 1, 3730, 1, 1, 
	1, 1, 1, 1, 3731, 3732, 3733, 3715, 
	3734, 3717, 3735, 3736, 3737, 1, 1, 3738, 
	3739, 3740, 1, 3724, 3741, 1, 3742, 1, 
	3743, 3744, 3745, 3746, 1, 3784, 3785, 3786, 
	3787, 3788, 3789, 3790, 3791, 3792, 3793, 1, 
	1, 3794, 3795, 3796, 1, 3797, 3798, 1, 
	3799, 1, 3800, 3801, 1, 3802, 1, 3803, 
	1, 1, 1, 1, 1, 1, 3804, 3805, 
	3806, 3788, 3807, 3790, 3808, 3809, 3810, 1, 
	1, 3811, 3812, 3813, 1, 3797, 3814, 1, 
	3815, 1, 3816, 3817, 3818, 3819, 1, 3820, 
	3820, 3820, 3820, 3820, 3820, 3820, 3820, 3820, 
	3820, 1, 1, 1, 1, 1, 1, 472, 
	473, 474, 475, 476, 477, 478, 479, 480, 
	481, 1, 1, 482, 483, 484, 1, 485, 
	486, 1, 487, 1, 488, 489, 1, 490, 
	1, 491, 1, 1, 1, 1, 1, 1, 
	492, 493, 494, 476, 495, 478, 496, 497, 
	498, 1, 1, 499, 500, 501, 1, 485, 
	502, 1, 503, 1, 504, 505, 506, 507, 
	1, 510, 1, 1, 1, 1, 1, 1, 
	1, 1, 3821, 1, 1, 1, 1, 1, 
	3822, 3822, 3822, 3822, 3822, 3822, 3822, 3822, 
	3822, 3822, 1, 1, 1, 1, 1, 1, 
	3823, 3824, 3825, 3826, 3827, 3828, 3829, 3830, 
	3831, 3832, 1, 1, 3833, 3834, 3835, 1, 
	3836, 3837, 1, 3838, 1, 3839, 3840, 1, 
	3841, 1, 3842, 1, 1, 1, 1, 510, 
	1, 3843, 3844, 3845, 3827, 3846, 3829, 3847, 
	3848, 3849, 1, 1, 3850, 3851, 3852, 1, 
	3836, 3853, 1, 3854, 1, 3855, 3856, 3857, 
	3858, 1, 3859, 3860, 3861, 3862, 3863, 3864, 
	3865, 3866, 3867, 3868, 1, 1, 3869, 3870, 
	3871, 1, 3872, 3873, 1, 3874, 1, 3875, 
	3876, 1, 3877, 1, 3878, 1, 1, 1, 
	1, 1, 1, 3879, 3880, 3881, 3863, 3882, 
	3865, 3883, 3884, 3885, 1, 1, 3886, 3887, 
	3888, 1, 3872, 3889, 1, 3890, 1, 3891, 
	3892, 3893, 3894, 1, 3895, 3895, 3895, 3895, 
	3895, 3895, 3895, 3895, 3895, 3895, 1, 1, 
	1, 1, 1, 1, 3823, 3824, 3825, 3826, 
	3827, 3828, 3829, 3830, 3831, 3832, 1, 1, 
	3833, 3834, 3835, 1, 3836, 3837, 1, 3838, 
	1, 3839, 3840, 1, 3841, 1, 3842, 1, 
	1, 1, 1, 1, 1, 3843, 3844, 3845, 
	3827, 3846, 3829, 3847, 3848, 3849, 1, 1, 
	3850, 3851, 3852, 1, 3836, 3853, 1, 3854, 
	1, 3855, 3856, 3857, 3858, 1, 511, 1, 
	1, 1, 1, 1, 1, 1, 1, 3896, 
	1, 1, 1, 1, 1, 3897, 3897, 3897, 
	3897, 3897, 3897, 3897, 3897, 3897, 3897, 1, 
	1, 1, 1, 1, 1, 3898, 3899, 3900, 
	3901, 3902, 3903, 3904, 3905, 3906, 3907, 1, 
	1, 3908, 3909, 3910, 1, 3911, 3912, 1, 
	3913, 1, 3914, 3915, 1, 3916, 1, 3917, 
	1, 1, 1, 1, 511, 1, 3918, 3919, 
	3920, 3902, 3921, 3904, 3922, 3923, 3924, 1, 
	1, 3925, 3926, 3927, 1, 3911, 3928, 1, 
	3929, 1, 3930, 3931, 3932, 3933, 1, 3934, 
	3935, 3936, 3937, 3938, 3939, 3940, 3941, 3942, 
	3943, 1, 1, 3944, 3945, 3946, 1, 3947, 
	3948, 1, 3949, 1, 3950, 3951, 1, 3952, 
	1, 3953, 1, 1, 1, 1, 1, 1, 
	3954, 3955, 3956, 3938, 3957, 3940, 3958, 3959, 
	3960, 1, 1, 3961, 3962, 3963, 1, 3947, 
	3964, 1, 3965, 1, 3966, 3967, 3968, 3969, 
	1, 3970, 3970, 3970, 3970, 3970, 3970, 3970, 
	3970, 3970, 3970, 1, 1, 1, 1, 1, 
	1, 3898, 3899, 3900, 3901, 3902, 3903, 3904, 
	3905, 3906, 3907, 1, 1, 3908, 3909, 3910, 
	1, 3911, 3912, 1, 3913, 1, 3914, 3915, 
	1, 3916, 1, 3917, 1, 1, 1, 1, 
	1, 1, 3918, 3919, 3920, 3902, 3921, 3904, 
	3922, 3923, 3924, 1, 1, 3925, 3926, 3927, 
	1, 3911, 3928, 1, 3929, 1, 3930, 3931, 
	3932, 3933, 1, 3971, 3971, 3971, 3971, 3971, 
	3971, 3971, 3971, 3971, 3971, 1, 1, 1, 
	1, 1, 1, 393, 394, 395, 396, 397, 
	398, 399, 400, 401, 402, 1, 1, 403, 
	404, 405, 1, 406, 407, 1, 408, 1, 
	409, 410, 1, 411, 1, 412, 1, 1, 
	1, 1, 1, 1, 413, 414, 415, 397, 
	416, 399, 417, 418, 419, 1, 1, 420, 
	421, 422, 1, 406, 423, 1, 424, 1, 
	425, 426, 427, 428, 1, 3972, 1, 1, 
	1, 1, 1, 3973, 3973, 3973, 3973, 3973, 
	3973, 3973, 3973, 3973, 3973, 1, 1, 1, 
	1, 1, 1, 3974, 3975, 3976, 3977, 3978, 
	3979, 3980, 3981, 3982, 3983, 1, 1, 3984, 
	3985, 3986, 1, 3987, 3988, 1, 3989, 1, 
	3990, 3991, 1, 3992, 1, 3993, 1, 1, 
	1, 1, 1, 1, 3994, 3995, 3996, 3978, 
	3997, 3980, 3998, 3999, 4000, 1, 1, 4001, 
	4002, 4003, 1, 3987, 4004, 1, 4005, 1, 
	4006, 4007, 4008, 4009, 1, 4010, 4011, 4012, 
	4013, 4014, 4015, 4016, 4017, 4018, 4019, 1, 
	1, 4020, 4021, 4022, 1, 4023, 4024, 1, 
	4025, 1, 4026, 4027, 1, 4028, 1, 4029, 
	1, 1, 1, 1, 1, 1, 4030, 4031, 
	4032, 4014, 4033, 4016, 4034, 4035, 4036, 1, 
	1, 4037, 4038, 4039, 1, 4023, 4040, 1, 
	4041, 1, 4042, 4043, 4044, 4045, 1, 4046, 
	4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046, 
	4046, 1, 1, 1, 1, 1, 1, 3974, 
	3975, 3976, 3977, 3978, 3979, 3980, 3981, 3982, 
	3983, 1, 1, 3984, 3985, 3986, 1, 3987, 
	3988, 1, 3989, 1, 3990, 3991, 1, 3992, 
	1, 3993, 1, 1, 1, 1, 1, 1, 
	3994, 3995, 3996, 3978, 3997, 3980, 3998, 3999, 
	4000, 1, 1, 4001, 4002, 4003, 1, 3987, 
	4004, 1, 4005, 1, 4006, 4007, 4008, 4009, 
	1, 4047, 1, 1, 1, 1, 1, 4048, 
	4048, 4048, 4048, 4048, 4048, 4048, 4048, 4048, 
	4048, 1, 1, 1, 1, 1, 1, 4049, 
	4050, 4051, 4052, 4053, 4054, 4055, 4056, 4057, 
	4058, 1, 1, 4059, 4060, 4061, 1, 4062, 
	4063, 1, 4064, 1, 4065, 4066, 1, 4067, 
	1, 4068, 1, 1, 1, 1, 1, 1, 
	4069, 4070, 4071, 4053, 4072, 4055, 4073, 4074, 
	4075, 1, 1, 4076, 4077, 4078, 1, 4062, 
	4079, 1, 4080, 1, 4081, 4082, 4083, 4084, 
	1, 4085, 4086, 4087, 4088, 4089, 4090, 4091, 
	4092, 4093, 4094, 1, 1, 4095, 4096, 4097, 
	1, 4098, 4099, 1, 4100, 1, 4101, 4102, 
	1, 4103, 1, 4104, 1, 1, 1, 1, 
	1, 1, 4105, 4106, 4107, 4089, 4108, 4091, 
	4109, 4110, 4111, 1, 1, 4112, 4113, 4114, 
	1, 4098, 4115, 1, 4116, 1, 4117, 4118, 
	4119, 4120, 1, 4121, 4121, 4121, 4121, 4121, 
	4121, 4121, 4121, 4121, 4121, 1, 1, 1, 
	1, 1, 1, 4049, 4050, 4051, 4052, 4053, 
	4054, 4055, 4056, 4057, 4058, 1, 1, 4059, 
	4060, 4061, 1, 4062, 4063, 1, 4064, 1, 
	4065, 4066, 1, 4067, 1, 4068, 1, 1, 
	1, 1, 1, 1, 4069, 4070, 4071, 4053, 
	4072, 4055, 4073, 4074, 4075, 1, 1, 4076, 
	4077, 4078, 1, 4062, 4079, 1, 4080, 1, 
	4081, 4082, 4083, 4084, 1, 429, 1, 1, 
	1, 1, 1, 1, 1, 1, 3972, 1, 
	1, 1, 1, 1, 3973, 3973, 3973, 3973, 
	3973, 3973, 3973, 3973, 3973, 3973, 1, 1, 
	1, 1, 1, 1, 3974, 3975, 3976, 3977, 
	3978, 3979, 3980, 3981, 3982, 3983, 1, 1, 
	3984, 3985, 3986, 1, 3987, 3988, 1, 3989, 
	1, 3990, 3991, 1, 3992, 1, 3993, 1, 
	1, 1, 1, 429, 1, 3994, 3995, 3996, 
	3978, 3997, 3980, 3998, 3999, 4000, 1, 1, 
	4001, 4002, 4003, 1, 3987, 4004, 1, 4005, 
	1, 4006, 4007, 4008, 4009, 1, 430, 1, 
	1, 1, 1, 1, 1, 1, 1, 4047, 
	1, 1, 1, 1, 1, 4048, 4048, 4048, 
	4048, 4048, 4048, 4048, 4048, 4048, 4048, 1, 
	1, 1, 1, 1, 1, 4049, 4050, 4051, 
	4052, 4053, 4054, 4055, 4056, 4057, 4058, 1, 
	1, 4059, 4060, 4061, 1, 4062, 4063, 1, 
	4064, 1, 4065, 4066, 1, 4067, 1, 4068, 
	1, 1, 1, 1, 430, 1, 4069, 4070, 
	4071, 4053, 4072, 4055, 4073, 4074, 4075, 1, 
	1, 4076, 4077, 4078, 1, 4062, 4079, 1, 
	4080, 1, 4081, 4082, 4083, 4084, 1, 4122, 
	4123, 4124, 4125, 4126, 4127, 4128, 4129, 4130, 
	4131, 1, 1, 4132, 4133, 4134, 1, 4135, 
	4136, 1, 4137, 1, 4138, 4139, 1, 4140, 
	1, 4141, 1, 1, 1, 1, 1, 1, 
	4142, 4143, 4144, 4126, 4145, 4128, 4146, 4147, 
	4148, 1, 1, 4149, 4150, 4151, 1, 4135, 
	4152, 1, 4153, 1, 4154, 4155, 4156, 4157, 
	1, 4158, 4158, 4158, 4158, 4158, 4158, 4158, 
	4158, 4158, 4158, 1, 1, 1, 1, 1, 
	1, 352, 353, 354, 355, 356, 357, 358, 
	359, 360, 361, 1, 1, 362, 363, 364, 
	1, 365, 366, 1, 367, 1, 368, 369, 
	1, 370, 1, 371, 1, 1, 1, 1, 
	1, 1, 372, 373, 374, 356, 375, 358, 
	376, 377, 378, 1, 1, 379, 380, 381, 
	1, 365, 382, 1, 383, 1, 384, 385, 
	386, 387, 1, 4159, 4160, 4161, 4162, 4163, 
	4164, 4165, 4166, 4167, 4168, 1, 1, 4169, 
	4170, 4171, 1, 4172, 4173, 1, 4174, 1, 
	4175, 4176, 1, 4177, 1, 4178, 1, 1, 
	1, 1, 1, 1, 4179, 4180, 4181, 4163, 
	4182, 4165, 4183, 4184, 4185, 1, 1, 4186, 
	4187, 4188, 1, 4172, 4189, 1, 4190, 1, 
	4191, 4192, 4193, 4194, 1, 4195, 4195, 4195, 
	4195, 4195, 4195, 4195, 4195, 4195, 4195, 1, 
	1, 1, 1, 1, 1, 313, 314, 315, 
	316, 317, 318, 319, 320, 321, 322, 1, 
	1, 323, 324, 325, 1, 326, 327, 1, 
	328, 1, 329, 330, 1, 331, 1, 332, 
	1, 1, 1, 1, 1, 1, 333, 334, 
	335, 317, 336, 319, 337, 338, 339, 1, 
	1, 340, 341, 342, 1, 326, 343, 1, 
	344, 1, 345, 346, 347, 348, 1, 4196, 
	4197, 4198, 4199, 4200, 4201, 4202, 4203, 4204, 
	4205, 1, 1, 4206, 4207, 4208, 1, 4209, 
	4210, 1, 4211, 1, 4212, 4213, 1, 4214, 
	1, 4215, 1, 1, 1, 1, 1, 1, 
	4216, 4217, 4218, 4200, 4219, 4202, 4220, 4221, 
	4222, 1, 1, 4223, 4224, 4225, 1, 4209, 
	4226, 1, 4227, 1, 4228, 4229, 4230, 4231, 
	1, 4232, 4232, 4232, 4232, 4232, 4232, 4232, 
	4232, 4232, 4232, 1, 1, 1, 1, 1, 
	1, 274, 275, 276, 277, 278, 279, 280, 
	281, 282, 283, 1, 1, 284, 285, 286, 
	1, 287, 288, 1, 289, 1, 290, 291, 
	1, 292, 1, 293, 1, 1, 1, 1, 
	1, 1, 294, 295, 296, 278, 297, 280, 
	298, 299, 300, 1, 1, 301, 302, 303, 
	1, 287, 304, 1, 305, 1, 306, 307, 
	308, 309, 1, 4233, 4234, 4235, 4236, 4237, 
	4238, 4239, 4240, 4241, 4242, 1, 1, 4243, 
	4244, 4245, 1, 4246, 4247, 1, 4248, 1, 
	4249, 4250, 1, 4251, 1, 4252, 1, 1, 
	1, 1, 1, 1, 4253, 4254, 4255, 4237, 
	4256, 4239, 4257, 4258, 4259, 1, 1, 4260, 
	4261, 4262, 1, 4246, 4263, 1, 4264, 1, 
	4265, 4266, 4267, 4268, 1, 4269, 4269, 4269, 
	4269, 4269, 4269, 4269, 4269, 4269, 4269, 1, 
	1, 1, 1, 1, 1, 235, 236, 237, 
	238, 239, 240, 241, 242, 243, 244, 1, 
	1, 245, 246, 247, 1, 248, 249, 1, 
	250, 1, 251, 252, 1, 253, 1, 254, 
	1, 1, 1, 1, 1, 1, 255, 256, 
	257, 239, 258, 241, 259, 260, 261, 1, 
	1, 262, 263, 264, 1, 248, 265, 1, 
	266, 1, 267, 268, 269, 270, 1, 4270, 
	4271, 4272, 4273, 4274, 4275, 4276, 4277, 4278, 
	4279, 1, 1, 4280, 4281, 4282, 1, 4283, 
	4284, 1, 4285, 1, 4286, 4287, 1, 4288, 
	1, 4289, 1, 1, 1, 1, 1, 1, 
	4290, 4291, 4292, 4274, 4293, 4276, 4294, 4295, 
	4296, 1, 1, 4297, 4298, 4299, 1, 4283, 
	4300, 1, 4301, 1, 4302, 4303, 4304, 4305, 
	1, 4306, 4306, 4306, 4306, 4306, 4306, 4306, 
	4306, 4306, 4306, 1, 1, 1, 1, 1, 
	1, 196, 197, 198, 199, 200, 201, 202, 
	203, 204, 205, 1, 1, 206, 207, 208, 
	1, 209, 210, 1, 211, 1, 212, 213, 
	1, 214, 1, 215, 1, 1, 1, 1, 
	1, 1, 216, 217, 218, 200, 219, 202, 
	220, 221, 222, 1, 1, 223, 224, 225, 
	1, 209, 226, 1, 227, 1, 228, 229, 
	230, 231, 1, 4307, 4308, 4309, 4310, 4311, 
	4312, 4313, 4314, 4315, 4316, 1, 1, 4317, 
	4318, 4319, 1, 4320, 4321, 1, 4322, 1, 
	4323, 4324, 1, 4325, 1, 4326, 1, 1, 
	1, 1, 1, 1, 4327, 4328, 4329, 4311, 
	4330, 4313, 4331, 4332, 4333, 1, 1, 4334, 
	4335, 4336, 1, 4320, 4337, 1, 4338, 1, 
	4339, 4340, 4341, 4342, 1, 4343, 4343, 4343, 
	4343, 4343, 4343, 4343, 4343, 4343, 4343, 1, 
	1, 1, 1, 1, 1, 157, 158, 159, 
	160, 161, 162, 163, 164, 165, 166, 1, 
	1, 167, 168, 169, 1, 170, 171, 1, 
	172, 1, 173, 174, 1, 175, 1, 176, 
	1, 1, 1, 1, 1, 1, 177, 178, 
	179, 161, 180, 163, 181, 182, 183, 1, 
	1, 184, 185, 186, 1, 170, 187, 1, 
	188, 1, 189, 190, 191, 192, 1, 4344, 
	4345, 4346, 4347, 4348, 4349, 4350, 4351, 4352, 
	4353, 1, 1, 4354, 4355, 4356, 1, 4357, 
	4358, 1, 4359, 1, 4360, 4361, 1, 4362, 
	1, 4363, 1, 1, 1, 1, 1, 1, 
	4364, 4365, 4366, 4348, 4367, 4350, 4368, 4369, 
	4370, 1, 1, 4371, 4372, 4373, 1, 4357, 
	4374, 1, 4375, 1, 4376, 4377, 4378, 4379, 
	1, 4380, 4380, 4380, 4380, 4380, 4380, 4380, 
	4380, 4380, 4380, 1, 1, 1, 1, 1, 
	1, 118, 119, 120, 121, 122, 123, 124, 
	125, 126, 127, 1, 1, 128, 129, 130, 
	1, 131, 132, 1, 133, 1, 134, 135, 
	1, 136, 1, 137, 1, 1, 1, 1, 
	1, 1, 138, 139, 140, 122, 141, 124, 
	142, 143, 144, 1, 1, 145, 146, 147, 
	1, 131, 148, 1, 149, 1, 150, 151, 
	152, 153, 1, 4381, 4382, 4383, 4384, 4385, 
	4386, 4387, 4388, 4389, 4390, 1, 1, 4391, 
	4392, 4393, 1, 4394, 4395, 1, 4396, 1, 
	4397, 4398, 1, 4399, 1, 4400, 1, 1, 
	1, 1, 1, 1, 4401, 4402, 4403, 4385, 
	4404, 4387, 4405, 4406, 4407, 1, 1, 4408, 
	4409, 4410, 1, 4394, 4411, 1, 4412, 1, 
	4413, 4414, 4415, 4416, 1, 4417, 4417, 4417, 
	4417, 4417, 4417, 4417, 4417, 4417, 4417, 1, 
	1, 1, 1, 1, 1, 79, 80, 81, 
	82, 83, 84, 85, 86, 87, 88, 1, 
	1, 89, 90, 91, 1, 92, 93, 1, 
	94, 1, 95, 96, 1, 97, 1, 98, 
	1, 1, 1, 1, 1, 1, 99, 100, 
	101, 83, 102, 85, 103, 104, 105, 1, 
	1, 106, 107, 108, 1, 92, 109, 1, 
	110, 1, 111, 112, 113, 114, 1, 4418, 
	4419, 4420, 4421, 4422, 4423, 4424, 4425, 4426, 
	4427, 1, 1, 4428, 4429, 4430, 1, 4431, 
	4432, 1, 4433, 1, 4434, 4435, 1, 4436, 
	1, 4437, 1, 1, 1, 1, 1, 1, 
	4438, 4439, 4440, 4422, 4441, 4424, 4442, 4443, 
	4444, 1, 1, 4445, 4446, 4447, 1, 4431, 
	4448, 1, 4449, 1, 4450, 4451, 4452, 4453, 
	1, 4454, 4454, 4454, 4454, 4454, 4454, 4454, 
	4454, 4454, 4454, 1, 1, 1, 1, 1, 
	1, 40, 41, 42, 43, 44, 45, 46, 
	47, 48, 49, 1, 1, 50, 51, 52, 
	1, 53, 54, 1, 55, 1, 56, 57, 
	1, 58, 1, 59, 1, 1, 1, 1, 
	1, 1, 60, 61, 62, 44, 63, 46, 
	64, 65, 66, 1, 1, 67, 68, 69, 
	1, 53, 70, 1, 71, 1, 72, 73, 
	74, 75, 1, 0
};

static const unsigned char _trans_targs[] = {
	2, 0, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 3, 220, 221, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 5, 218, 219, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 7, 216, 217, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 9, 214, 215, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 11, 212, 213, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	13, 210, 211, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 15, 
	208, 209, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 17, 206, 
	207, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 19, 204, 205, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 21, 22, 195, 202, 
	203, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 196, 199, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 24, 187, 188, 189, 192, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 25, 180, 181, 184, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	27, 178, 179, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 29, 
	176, 177, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 31, 174, 
	175, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 33, 164, 165, 
	166, 170, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 35, 36, 
	155, 162, 163, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 156, 
	159, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 38, 153, 154, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 40, 151, 152, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 42, 149, 150, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 44, 147, 148, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 46, 145, 146, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	48, 143, 144, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 50, 
	141, 142, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 52, 139, 
	140, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 54, 137, 138, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 56, 135, 136, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 58, 59, 126, 133, 134, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 127, 130, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 61, 118, 119, 120, 123, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 62, 111, 112, 115, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 64, 
	109, 110, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 66, 107, 
	108, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 68, 97, 98, 
	99, 103, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 70, 71, 
	88, 95, 96, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 89, 
	92, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 73, 86, 87, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 75, 84, 85, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 77, 82, 83, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 79, 80, 81, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 81, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 83, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 85, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 87, 88, 90, 91, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	91, 93, 94, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 94, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	98, 100, 101, 102, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 102, 104, 105, 106, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	106, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 108, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 110, 111, 113, 114, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 114, 116, 
	117, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 117, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 119, 121, 
	122, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 122, 124, 125, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 125, 126, 128, 129, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	129, 131, 132, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 132, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	136, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 138, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 140, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 142, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 144, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 146, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 148, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 150, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	152, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 154, 155, 157, 
	158, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 158, 160, 161, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 161, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 165, 167, 168, 169, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 169, 171, 172, 
	173, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 173, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 175, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 177, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	179, 180, 182, 183, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 183, 185, 186, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 186, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 188, 190, 191, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 191, 
	193, 194, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 194, 195, 197, 198, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 198, 200, 
	201, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 201, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 205, 2, 
	4, 6, 8, 10, 12, 14, 16, 18, 
	20, 23, 26, 28, 30, 32, 34, 37, 
	39, 41, 43, 45, 47, 49, 51, 53, 
	55, 57, 60, 63, 65, 67, 69, 72, 
	74, 76, 78, 207, 2, 4, 6, 8, 
	10, 12, 14, 16, 18, 20, 23, 26, 
	28, 30, 32, 34, 37, 39, 41, 43, 
	45, 47, 49, 51, 53, 55, 57, 60, 
	63, 65, 67, 69, 72, 74, 76, 78, 
	209, 2, 4, 6, 8, 10, 12, 14, 
	16, 18, 20, 23, 26, 28, 30, 32, 
	34, 37, 39, 41, 43, 45, 47, 49, 
	51, 53, 55, 57, 60, 63, 65, 67, 
	69, 72, 74, 76, 78, 211, 2, 4, 
	6, 8, 10, 12, 14, 16, 18, 20, 
	23, 26, 28, 30, 32, 34, 37, 39, 
	41, 43, 45, 47, 49, 51, 53, 55, 
	57, 60, 63, 65, 67, 69, 72, 74, 
	76, 78, 213, 2, 4, 6, 8, 10, 
	12, 14, 16, 18, 20, 23, 26, 28, 
	30, 32, 34, 37, 39, 41, 43, 45, 
	47, 49, 51, 53, 55, 57, 60, 63, 
	65, 67, 69, 72, 74, 76, 78, 215, 
	2, 4, 6, 8, 10, 12, 14, 16, 
	18, 20, 23, 26, 28, 30, 32, 34, 
	37, 39, 41, 43, 45, 47, 49, 51, 
	53, 55, 57, 60, 63, 65, 67, 69, 
	72, 74, 76, 78, 217, 2, 4, 6, 
	8, 10, 12, 14, 16, 18, 20, 23, 
	26, 28, 30, 32, 34, 37, 39, 41, 
	43, 45, 47, 49, 51, 53, 55, 57, 
	60, 63, 65, 67, 69, 72, 74, 76, 
	78, 219, 2, 4, 6, 8, 10, 12, 
	14, 16, 18, 20, 23, 26, 28, 30, 
	32, 34, 37, 39, 41, 43, 45, 47, 
	49, 51, 53, 55, 57, 60, 63, 65, 
	67, 69, 72, 74, 76, 78, 221
};

static const short _trans_actions[] = {
	11, 0, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 1, 1, 1, 
	1, 1, 1, 1, 1, 7, 0, 3, 
	78, 30, 30, 30, 30, 30, 30, 30, 
	30, 30, 30, 30, 30, 30, 30, 30, 
	30, 30, 30, 30, 30, 30, 30, 30, 
	30, 30, 30, 30, 30, 30, 30, 30, 
	30, 30, 30, 30, 7, 0, 3, 2144, 
	1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 
	1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 
	1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 
	1590, 1590, 1590, 1590, 1590, 1590, 1590, 1590, 
	1590, 1590, 1590, 7, 0, 3, 2376, 2168, 
	2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 
	2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 
	2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 
	2168, 2168, 2168, 2168, 2168, 2168, 2168, 2168, 
	2168, 2168, 7, 0, 3, 1219, 101, 101, 
	101, 101, 101, 101, 101, 101, 101, 101, 
	101, 101, 101, 101, 101, 101, 101, 101, 
	101, 101, 101, 101, 101, 101, 101, 101, 
	101, 101, 101, 101, 101, 101, 101, 101, 
	101, 7, 0, 3, 1450, 497, 497, 497, 
	497, 497, 497, 497, 497, 497, 497, 497, 
	497, 497, 497, 497, 497, 497, 497, 497, 
	497, 497, 497, 497, 497, 497, 497, 497, 
	497, 497, 497, 497, 497, 497, 497, 497, 
	7, 0, 3, 1457, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 509, 
	509, 509, 509, 509, 509, 509, 509, 7, 
	0, 3, 1394, 401, 401, 401, 401, 401, 
	401, 401, 401, 401, 401, 401, 401, 401, 
	401, 401, 401, 401, 401, 401, 401, 401, 
	401, 401, 401, 401, 401, 401, 401, 401, 
	401, 401, 401, 401, 401, 401, 7, 0, 
	3, 1464, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 521, 521, 521, 
	521, 521, 521, 521, 521, 7, 0, 3, 
	2394, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 
	2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 
	2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 
	2200, 2200, 2200, 2200, 2200, 2200, 2200, 2200, 
	2200, 2200, 2200, 2200, 0, 0, 3, 0, 
	0, 1289, 221, 221, 221, 221, 221, 221, 
	221, 221, 221, 221, 221, 221, 221, 221, 
	221, 221, 221, 221, 221, 221, 221, 221, 
	221, 221, 221, 221, 221, 221, 221, 221, 
	221, 221, 221, 221, 221, 0, 0, 1712, 
	757, 757, 757, 757, 757, 757, 757, 757, 
	757, 757, 757, 757, 757, 757, 757, 757, 
	757, 757, 757, 757, 757, 757, 757, 757, 
	757, 757, 757, 757, 757, 757, 757, 757, 
	757, 757, 757, 0, 0, 3, 0, 0, 
	1331, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 293, 293, 293, 293, 
	293, 293, 293, 293, 0, 3, 0, 0, 
	1471, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 533, 533, 533, 533, 
	533, 533, 533, 533, 1920, 1121, 1121, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 
	1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 
	7, 0, 3, 2120, 1548, 1548, 1548, 1548, 
	1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 
	1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 
	1548, 1548, 1548, 1548, 1548, 1548, 1548, 1548, 
	1548, 1548, 1548, 1548, 1548, 1548, 1548, 7, 
	0, 3, 1373, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 365, 365, 
	365, 365, 365, 365, 365, 365, 7, 0, 
	3, 1513, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 605, 605, 605, 
	605, 605, 605, 605, 605, 7, 0, 3, 
	0, 0, 1408, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 425, 425, 
	425, 425, 425, 425, 425, 425, 0, 0, 
	3, 0, 0, 1233, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 125, 
	125, 125, 125, 125, 125, 125, 125, 0, 
	0, 1648, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 645, 645, 645, 
	645, 645, 645, 645, 645, 7, 0, 3, 
	2104, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 
	1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 
	1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 
	1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 
	1520, 1520, 1520, 1520, 7, 0, 3, 1380, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 377, 377, 377, 377, 377, 
	377, 377, 377, 7, 0, 3, 68, 14, 
	14, 14, 14, 14, 14, 14, 14, 14, 
	14, 14, 14, 14, 14, 14, 14, 14, 
	14, 14, 14, 14, 14, 14, 14, 14, 
	14, 14, 14, 14, 14, 14, 14, 14, 
	14, 14, 7, 0, 3, 2160, 1618, 1618, 
	1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 
	1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 
	1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 
	1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 
	1618, 7, 0, 3, 2152, 1604, 1604, 1604, 
	1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 
	1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 
	1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 
	1604, 1604, 1604, 1604, 1604, 1604, 1604, 1604, 
	7, 0, 3, 2385, 2184, 2184, 2184, 2184, 
	2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 
	2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 
	2184, 2184, 2184, 2184, 2184, 2184, 2184, 2184, 
	2184, 2184, 2184, 2184, 2184, 2184, 2184, 7, 
	0, 3, 1226, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 113, 113, 
	113, 113, 113, 113, 113, 113, 7, 0, 
	3, 1387, 389, 389, 389, 389, 389, 389, 
	389, 389, 389, 389, 389, 389, 389, 389, 
	389, 389, 389, 389, 389, 389, 389, 389, 
	389, 389, 389, 389, 389, 389, 389, 389, 
	389, 389, 389, 389, 389, 7, 0, 3, 
	1401, 413, 413, 413, 413, 413, 413, 413, 
	413, 413, 413, 413, 413, 413, 413, 413, 
	413, 413, 413, 413, 413, 413, 413, 413, 
	413, 413, 413, 413, 413, 413, 413, 413, 
	413, 413, 413, 413, 7, 0, 3, 2403, 
	2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 
	2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 
	2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 
	2216, 2216, 2216, 2216, 2216, 2216, 2216, 2216, 
	2216, 2216, 2216, 0, 0, 3, 0, 0, 
	1310, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 257, 257, 257, 257, 
	257, 257, 257, 257, 0, 0, 1736, 799, 
	799, 799, 799, 799, 799, 799, 799, 799, 
	799, 799, 799, 799, 799, 799, 799, 799, 
	799, 799, 799, 799, 799, 799, 799, 799, 
	799, 799, 799, 799, 799, 799, 799, 799, 
	799, 799, 0, 0, 3, 0, 0, 1352, 
	329, 329, 329, 329, 329, 329, 329, 329, 
	329, 329, 329, 329, 329, 329, 329, 329, 
	329, 329, 329, 329, 329, 329, 329, 329, 
	329, 329, 329, 329, 329, 329, 329, 329, 
	329, 329, 329, 0, 3, 0, 0, 1492, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 569, 569, 569, 569, 569, 
	569, 569, 569, 1944, 1163, 1163, 1163, 1163, 
	1163, 1163, 1163, 1163, 1163, 1163, 1163, 1163, 
	1163, 1163, 1163, 1163, 1163, 1163, 1163, 1163, 
	1163, 1163, 1163, 1163, 1163, 1163, 1163, 1163, 
	1163, 1163, 1163, 1163, 1163, 1163, 1163, 7, 
	0, 3, 2128, 1562, 1562, 1562, 1562, 1562, 
	1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 
	1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 
	1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 
	1562, 1562, 1562, 1562, 1562, 1562, 7, 0, 
	3, 1275, 197, 197, 197, 197, 197, 197, 
	197, 197, 197, 197, 197, 197, 197, 197, 
	197, 197, 197, 197, 197, 197, 197, 197, 
	197, 197, 197, 197, 197, 197, 197, 197, 
	197, 197, 197, 197, 197, 7, 0, 3, 
	0, 0, 1429, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 461, 461, 
	461, 461, 461, 461, 461, 461, 0, 0, 
	3, 0, 0, 1254, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 161, 
	161, 161, 161, 161, 161, 161, 161, 0, 
	0, 1672, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 687, 687, 687, 
	687, 687, 687, 687, 687, 7, 0, 3, 
	2136, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 
	1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 
	1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 
	1576, 1576, 1576, 1576, 1576, 1576, 1576, 1576, 
	1576, 1576, 1576, 1576, 7, 0, 3, 1282, 
	209, 209, 209, 209, 209, 209, 209, 209, 
	209, 209, 209, 209, 209, 209, 209, 209, 
	209, 209, 209, 209, 209, 209, 209, 209, 
	209, 209, 209, 209, 209, 209, 209, 209, 
	209, 209, 209, 7, 0, 3, 2112, 1534, 
	1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 
	1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 
	1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 
	1534, 1534, 1534, 1534, 1534, 1534, 1534, 1534, 
	1534, 1534, 7, 0, 3, 73, 22, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 22, 22, 22, 22, 22, 22, 22, 
	22, 89, 48, 48, 48, 48, 48, 48, 
	48, 48, 48, 48, 48, 48, 48, 48, 
	48, 48, 48, 48, 48, 48, 48, 48, 
	48, 48, 48, 48, 48, 48, 48, 48, 
	48, 48, 48, 48, 48, 5, 2241, 1992, 
	1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 
	1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 
	1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 
	1992, 1992, 1992, 1992, 1992, 1992, 1992, 1992, 
	1992, 1992, 5, 1704, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 743, 
	743, 743, 743, 743, 743, 743, 743, 5, 
	2268, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 
	2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 
	2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 
	2040, 2040, 2040, 2040, 2040, 2040, 2040, 2040, 
	2040, 2040, 2040, 2040, 5, 5, 0, 3, 
	1261, 173, 173, 173, 173, 173, 173, 173, 
	173, 173, 173, 173, 173, 173, 173, 173, 
	173, 173, 173, 173, 173, 173, 173, 173, 
	173, 173, 173, 173, 173, 173, 173, 173, 
	173, 173, 173, 173, 1680, 701, 701, 701, 
	701, 701, 701, 701, 701, 701, 701, 701, 
	701, 701, 701, 701, 701, 701, 701, 701, 
	701, 701, 701, 701, 701, 701, 701, 701, 
	701, 701, 701, 701, 701, 701, 701, 701, 
	5, 0, 3, 1268, 185, 185, 185, 185, 
	185, 185, 185, 185, 185, 185, 185, 185, 
	185, 185, 185, 185, 185, 185, 185, 185, 
	185, 185, 185, 185, 185, 185, 185, 185, 
	185, 185, 185, 185, 185, 185, 185, 1688, 
	715, 715, 715, 715, 715, 715, 715, 715, 
	715, 715, 715, 715, 715, 715, 715, 715, 
	715, 715, 715, 715, 715, 715, 715, 715, 
	715, 715, 715, 715, 715, 715, 715, 715, 
	715, 715, 715, 5, 1872, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 
	5, 7, 0, 3, 1436, 473, 473, 473, 
	473, 473, 473, 473, 473, 473, 473, 473, 
	473, 473, 473, 473, 473, 473, 473, 473, 
	473, 473, 473, 473, 473, 473, 473, 473, 
	473, 473, 473, 473, 473, 473, 473, 473, 
	1880, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 1051, 1051, 1051, 1051, 
	1051, 1051, 1051, 1051, 5, 7, 0, 3, 
	1443, 485, 485, 485, 485, 485, 485, 485, 
	485, 485, 485, 485, 485, 485, 485, 485, 
	485, 485, 485, 485, 485, 485, 485, 485, 
	485, 485, 485, 485, 485, 485, 485, 485, 
	485, 485, 485, 485, 1888, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 
	5, 1696, 729, 729, 729, 729, 729, 729, 
	729, 729, 729, 729, 729, 729, 729, 729, 
	729, 729, 729, 729, 729, 729, 729, 729, 
	729, 729, 729, 729, 729, 729, 729, 729, 
	729, 729, 729, 729, 729, 5, 2259, 2024, 
	2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 
	2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 
	2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 
	2024, 2024, 2024, 2024, 2024, 2024, 2024, 2024, 
	2024, 2024, 5, 5, 0, 3, 1499, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 581, 581, 581, 581, 581, 581, 
	581, 581, 1952, 1177, 1177, 1177, 1177, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 1177, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 1177, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 1177, 1177, 
	1177, 1177, 1177, 1177, 1177, 1177, 5, 0, 
	3, 1506, 593, 593, 593, 593, 593, 593, 
	593, 593, 593, 593, 593, 593, 593, 593, 
	593, 593, 593, 593, 593, 593, 593, 593, 
	593, 593, 593, 593, 593, 593, 593, 593, 
	593, 593, 593, 593, 593, 1960, 1191, 1191, 
	1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 
	1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 
	1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 
	1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 
	1191, 5, 1784, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, 883, 883, 883, 
	883, 883, 883, 883, 883, 883, 5, 0, 
	3, 1359, 341, 341, 341, 341, 341, 341, 
	341, 341, 341, 341, 341, 341, 341, 341, 
	341, 341, 341, 341, 341, 341, 341, 341, 
	341, 341, 341, 341, 341, 341, 341, 341, 
	341, 341, 341, 341, 341, 1792, 897, 897, 
	897, 897, 897, 897, 897, 897, 897, 897, 
	897, 897, 897, 897, 897, 897, 897, 897, 
	897, 897, 897, 897, 897, 897, 897, 897, 
	897, 897, 897, 897, 897, 897, 897, 897, 
	897, 5, 0, 3, 1366, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	353, 353, 353, 353, 353, 353, 353, 353, 
	1800, 911, 911, 911, 911, 911, 911, 911, 
	911, 911, 911, 911, 911, 911, 911, 911, 
	911, 911, 911, 911, 911, 911, 911, 911, 
	911, 911, 911, 911, 911, 911, 911, 911, 
	911, 911, 911, 911, 5, 5, 0, 3, 
	1317, 269, 269, 269, 269, 269, 269, 269, 
	269, 269, 269, 269, 269, 269, 269, 269, 
	269, 269, 269, 269, 269, 269, 269, 269, 
	269, 269, 269, 269, 269, 269, 269, 269, 
	269, 269, 269, 269, 1744, 813, 813, 813, 
	813, 813, 813, 813, 813, 813, 813, 813, 
	813, 813, 813, 813, 813, 813, 813, 813, 
	813, 813, 813, 813, 813, 813, 813, 813, 
	813, 813, 813, 813, 813, 813, 813, 813, 
	5, 0, 3, 1324, 281, 281, 281, 281, 
	281, 281, 281, 281, 281, 281, 281, 281, 
	281, 281, 281, 281, 281, 281, 281, 281, 
	281, 281, 281, 281, 281, 281, 281, 281, 
	281, 281, 281, 281, 281, 281, 281, 1752, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 827, 827, 827, 827, 827, 
	827, 827, 827, 5, 2442, 2358, 2358, 2358, 
	2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 
	2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 
	2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 
	2358, 2358, 2358, 2358, 2358, 2358, 2358, 2358, 
	5, 1840, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 981, 981, 981, 
	981, 981, 981, 981, 981, 5, 1824, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 953, 953, 953, 953, 953, 953, 
	953, 953, 5, 1640, 631, 631, 631, 631, 
	631, 631, 631, 631, 631, 631, 631, 631, 
	631, 631, 631, 631, 631, 631, 631, 631, 
	631, 631, 631, 631, 631, 631, 631, 631, 
	631, 631, 631, 631, 631, 631, 631, 5, 
	2422, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 
	2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 
	2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 
	2322, 2322, 2322, 2322, 2322, 2322, 2322, 2322, 
	2322, 2322, 2322, 2322, 5, 2286, 2072, 2072, 
	2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 
	2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 
	2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 
	2072, 2072, 2072, 2072, 2072, 2072, 2072, 2072, 
	2072, 5, 2295, 2088, 2088, 2088, 2088, 2088, 
	2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 
	2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 
	2088, 2088, 2088, 2088, 2088, 2088, 2088, 2088, 
	2088, 2088, 2088, 2088, 2088, 2088, 5, 83, 
	38, 38, 38, 38, 38, 38, 38, 38, 
	38, 38, 38, 38, 38, 38, 38, 38, 
	38, 38, 38, 38, 38, 38, 38, 38, 
	38, 38, 38, 38, 38, 38, 38, 38, 
	38, 38, 38, 5, 1816, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	939, 939, 939, 939, 939, 939, 939, 939, 
	5, 2232, 1976, 1976, 1976, 1976, 1976, 1976, 
	1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 
	1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 
	1976, 1976, 1976, 1976, 1976, 1976, 1976, 1976, 
	1976, 1976, 1976, 1976, 1976, 5, 5, 0, 
	3, 1240, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 137, 137, 137, 
	137, 137, 137, 137, 137, 1656, 659, 659, 
	659, 659, 659, 659, 659, 659, 659, 659, 
	659, 659, 659, 659, 659, 659, 659, 659, 
	659, 659, 659, 659, 659, 659, 659, 659, 
	659, 659, 659, 659, 659, 659, 659, 659, 
	659, 5, 0, 3, 1247, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	149, 149, 149, 149, 149, 149, 149, 149, 
	1664, 673, 673, 673, 673, 673, 673, 673, 
	673, 673, 673, 673, 673, 673, 673, 673, 
	673, 673, 673, 673, 673, 673, 673, 673, 
	673, 673, 673, 673, 673, 673, 673, 673, 
	673, 673, 673, 673, 5, 1848, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 995, 995, 995, 995, 995, 995, 995, 
	995, 5, 7, 0, 3, 1415, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 437, 437, 437, 437, 437, 437, 437, 
	437, 1856, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 
	1009, 1009, 1009, 1009, 1009, 5, 7, 0, 
	3, 1422, 449, 449, 449, 449, 449, 449, 
	449, 449, 449, 449, 449, 449, 449, 449, 
	449, 449, 449, 449, 449, 449, 449, 449, 
	449, 449, 449, 449, 449, 449, 449, 449, 
	449, 449, 449, 449, 449, 1864, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 
	1023, 5, 1968, 1205, 1205, 1205, 1205, 1205, 
	1205, 1205, 1205, 1205, 1205, 1205, 1205, 1205, 
	1205, 1205, 1205, 1205, 1205, 1205, 1205, 1205, 
	1205, 1205, 1205, 1205, 1205, 1205, 1205, 1205, 
	1205, 1205, 1205, 1205, 1205, 1205, 5, 1808, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 925, 925, 925, 925, 925, 
	925, 925, 925, 5, 2250, 2008, 2008, 2008, 
	2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 
	2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 
	2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 
	2008, 2008, 2008, 2008, 2008, 2008, 2008, 2008, 
	5, 5, 0, 3, 1478, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	545, 545, 545, 545, 545, 545, 545, 545, 
	1928, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 
	1135, 1135, 1135, 1135, 5, 0, 3, 1485, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 557, 557, 557, 557, 557, 
	557, 557, 557, 1936, 1149, 1149, 1149, 1149, 
	1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 
	1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 
	1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 
	1149, 1149, 1149, 1149, 1149, 1149, 1149, 5, 
	1760, 841, 841, 841, 841, 841, 841, 841, 
	841, 841, 841, 841, 841, 841, 841, 841, 
	841, 841, 841, 841, 841, 841, 841, 841, 
	841, 841, 841, 841, 841, 841, 841, 841, 
	841, 841, 841, 841, 5, 0, 3, 1338, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 305, 305, 305, 305, 305, 
	305, 305, 305, 1768, 855, 855, 855, 855, 
	855, 855, 855, 855, 855, 855, 855, 855, 
	855, 855, 855, 855, 855, 855, 855, 855, 
	855, 855, 855, 855, 855, 855, 855, 855, 
	855, 855, 855, 855, 855, 855, 855, 5, 
	0, 3, 1345, 317, 317, 317, 317, 317, 
	317, 317, 317, 317, 317, 317, 317, 317, 
	317, 317, 317, 317, 317, 317, 317, 317, 
	317, 317, 317, 317, 317, 317, 317, 317, 
	317, 317, 317, 317, 317, 317, 1776, 869, 
	869, 869, 869, 869, 869, 869, 869, 869, 
	869, 869, 869, 869, 869, 869, 869, 869, 
	869, 869, 869, 869, 869, 869, 869, 869, 
	869, 869, 869, 869, 869, 869, 869, 869, 
	869, 869, 5, 5, 0, 3, 1296, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 233, 233, 233, 233, 233, 233, 
	233, 233, 1720, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 771, 771, 
	771, 771, 771, 771, 771, 771, 5, 0, 
	3, 1303, 245, 245, 245, 245, 245, 245, 
	245, 245, 245, 245, 245, 245, 245, 245, 
	245, 245, 245, 245, 245, 245, 245, 245, 
	245, 245, 245, 245, 245, 245, 245, 245, 
	245, 245, 245, 245, 245, 1728, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 785, 785, 785, 785, 785, 785, 785, 
	785, 5, 2432, 2340, 2340, 2340, 2340, 2340, 
	2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 
	2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 
	2340, 2340, 2340, 2340, 2340, 2340, 2340, 2340, 
	2340, 2340, 2340, 2340, 2340, 2340, 5, 1912, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 1107, 1107, 1107, 1107, 1107, 
	1107, 1107, 1107, 5, 1832, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	967, 967, 967, 967, 967, 967, 967, 967, 
	5, 1904, 1093, 1093, 1093, 1093, 1093, 1093, 
	1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 
	1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 
	1093, 1093, 1093, 1093, 1093, 1093, 1093, 1093, 
	1093, 1093, 1093, 1093, 1093, 5, 1896, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 1079, 1079, 1079, 1079, 1079, 1079, 
	1079, 1079, 5, 1632, 617, 617, 617, 617, 
	617, 617, 617, 617, 617, 617, 617, 617, 
	617, 617, 617, 617, 617, 617, 617, 617, 
	617, 617, 617, 617, 617, 617, 617, 617, 
	617, 617, 617, 617, 617, 617, 617, 5, 
	2412, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 
	2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 
	2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 
	2304, 2304, 2304, 2304, 2304, 2304, 2304, 2304, 
	2304, 2304, 2304, 2304, 5, 2277, 2056, 2056, 
	2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 
	2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 
	2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 
	2056, 2056, 2056, 2056, 2056, 2056, 2056, 2056, 
	2056, 5, 95, 58, 58, 58, 58, 58, 
	58, 58, 58, 58, 58, 58, 58, 58, 
	58, 58, 58, 58, 58, 58, 58, 58, 
	58, 58, 58, 58, 58, 58, 58, 58, 
	58, 58, 58, 58, 58, 58, 5
};

static const short _eof_actions[] = {
	0, 9, 34, 34, 1597, 1597, 2176, 2176, 
	107, 107, 503, 503, 515, 515, 407, 407, 
	527, 527, 2208, 2208, 227, 227, 764, 299, 
	539, 1128, 1555, 1555, 371, 371, 611, 611, 
	431, 431, 131, 131, 652, 1527, 1527, 383, 
	383, 18, 18, 1625, 1625, 1611, 1611, 2192, 
	2192, 119, 119, 395, 395, 419, 419, 2224, 
	2224, 263, 263, 806, 335, 575, 1170, 1569, 
	1569, 203, 203, 467, 467, 167, 167, 694, 
	1583, 1583, 215, 215, 1541, 1541, 26, 26, 
	53, 26, 2000, 1541, 750, 215, 2048, 1583, 
	167, 179, 708, 179, 191, 722, 191, 179, 
	191, 1044, 467, 479, 479, 1058, 479, 491, 
	491, 1072, 491, 736, 203, 2032, 1569, 575, 
	587, 1184, 587, 599, 1198, 599, 890, 335, 
	347, 904, 347, 359, 918, 359, 263, 275, 
	820, 275, 287, 834, 287, 275, 287, 2367, 
	2224, 988, 419, 960, 395, 638, 119, 2331, 
	2192, 2080, 1611, 2096, 1625, 43, 18, 946, 
	383, 1984, 1527, 131, 143, 666, 143, 155, 
	680, 155, 143, 155, 1002, 431, 443, 443, 
	1016, 443, 455, 455, 1030, 455, 1212, 611, 
	932, 371, 2016, 1555, 539, 551, 1142, 551, 
	563, 1156, 563, 848, 299, 311, 862, 311, 
	323, 876, 323, 227, 239, 778, 239, 251, 
	792, 251, 239, 251, 2349, 2208, 1114, 527, 
	974, 407, 1100, 515, 1086, 503, 624, 107, 
	2313, 2176, 2064, 1597, 63, 34
};

static const int start = 1;

static const int en_main = 1;


	{
	cs = start;
	}

	{
	int _slen;
	int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;
	const short *_inds;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _trans_keys + (cs<<1);
	_inds = _indicies + _index_offsets[cs];

	_slen = _key_spans[cs];
	_trans = _inds[ _slen > 0 && _keys[0] <=(*p) &&
		(*p) <= _keys[1] ?
		(*p) - _keys[0] : _slen ];

	cs = _trans_targs[_trans];

	if ( _trans_actions[_trans] == 0 )
		goto _again;

	_acts = _actions + _trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *(_acts++) )
		{
	case 0:
	{
    count = 1;
    rest = false;
  }
	break;
	case 1:
	{
    count = (*p) - '0';
  }
	break;
	case 2:
	{
    count = count * 10 + ((*p) - '0');
  }
	break;
	case 3:
	{
    count = 0;
    rest = true;
  }
	break;
	case 4:
	{
    count = 0;
  }
	break;
	case 5:
	{
    width = 1;
  }
	break;
	case 6:
	{
    width = 2;
  }
	break;
	case 7:
	{
    width = 4;
  }
	break;
	case 8:
	{
    width = 8;
  }
	break;
	case 9:
	{
#if RBX_SIZEOF_LONG == 4
    width = 4;
#else
    width = 8;
#endif
  }
	break;
	case 10:
	{
    if(!rest) {
      stop = index + width * count;
    }

    if(rest || stop > bytes_size) {
      assert(width);
      stop = index + ((bytes_size - index) / width) * width;
    }
  }
	break;
	case 11:
	{
    for(; count > 0; count--) {
      array->append(state, cNil);
    }
  }
	break;
	case 12:
	{
    unpack_integer(ubyte);
  }
	break;
	case 13:
	{
    unpack_integer(sbyte);
  }
	break;
	case 14:
	{
    unpack_integer(u2bytes);
  }
	break;
	case 15:
	{
    unpack_integer(u2bytes_le);
  }
	break;
	case 16:
	{
    unpack_integer(u2bytes_be);
  }
	break;
	case 17:
	{
    unpack_integer(s2bytes);
  }
	break;
	case 18:
	{
    unpack_integer(s2bytes_le);
  }
	break;
	case 19:
	{
    unpack_integer(s2bytes_be);
  }
	break;
	case 20:
	{
    unpack_integer(u4bytes);
  }
	break;
	case 21:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 22:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 23:
	{
    unpack_integer(s4bytes);
  }
	break;
	case 24:
	{
    unpack_integer(s4bytes_le);
  }
	break;
	case 25:
	{
    unpack_integer(s4bytes_be);
  }
	break;
	case 26:
	{
    unpack_integer(u4bytes);
  }
	break;
	case 27:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes);
#else
    unpack_integer(u8bytes);
#endif
  }
	break;
	case 28:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 29:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 30:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes_le);
#else
    unpack_integer(u8bytes_le);
#endif
  }
	break;
	case 31:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes_be);
#else
    unpack_integer(u8bytes_be);
#endif
  }
	break;
	case 32:
	{
    unpack_integer(s4bytes);
  }
	break;
	case 33:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes);
#else
    unpack_integer(s8bytes);
#endif
  }
	break;
	case 34:
	{
    unpack_integer(s4bytes_le);
  }
	break;
	case 35:
	{
    unpack_integer(s4bytes_be);
  }
	break;
	case 36:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes_le);
#else
    unpack_integer(s8bytes_le);
#endif
  }
	break;
	case 37:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes_be);
#else
    unpack_integer(s8bytes_be);
#endif
  }
	break;
	case 38:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 39:
	{
    unpack_integer(u2bytes_be);
  }
	break;
	case 40:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 41:
	{
    unpack_integer(u2bytes_le);
  }
	break;
	case 42:
	{
    unpack_integer(u8bytes);
  }
	break;
	case 43:
	{
    unpack_integer(u8bytes_le);
  }
	break;
	case 44:
	{
    unpack_integer(u8bytes_be);
  }
	break;
	case 45:
	{
    unpack_integer(s8bytes);
  }
	break;
	case 46:
	{
    unpack_integer(s8bytes_le);
  }
	break;
	case 47:
	{
    unpack_integer(s8bytes_be);
  }
	break;
	case 48:
	{
    unpack_double;
  }
	break;
	case 49:
	{
    unpack_double_le;
  }
	break;
	case 50:
	{
    unpack_float_le;
  }
	break;
	case 51:
	{
    unpack_float;
  }
	break;
	case 52:
	{
    unpack_double_be;
  }
	break;
	case 53:
	{
    unpack_float_be;
  }
	break;
	case 54:
	{
    if(rest) count = bytes_size - index;
    index -= count;
  }
	break;
	case 55:
	{
    if(rest) {
      index = bytes_size;
    } else {
      index += count;
    }
  }
	break;
	case 56:
	{
    if(!rest) {
      index = count;
    }
  }
	break;
	case 57:
	{
    if(index < 0 || index > bytes_size) {
      unpack::outside_of_string(state, *p);
    }
  }
	break;
	case 58:
	{
    bytes = (const char*)self->byte_address() + index;
  }
	break;
	case 59:
	{
    bytes_end = (const char*)self->byte_address() + bytes_size;
  }
	break;
	case 60:
	{
    width = 1;
  }
	break;
	case 61:
	{
    width = 8;
  }
	break;
	case 62:
	{
    width = 2;
  }
	break;
	case 63:
	{
    remainder = bytes_size - index;
  }
	break;
	case 64:
	{
    if(rest) {
      count = remainder;
    } else if(count > remainder) {
      count = remainder;
    }
  }
	break;
	case 65:
	{
    if(rest || count > remainder * width) {
      count = remainder * width;
    }
  }
	break;
	case 66:
	{
    String* string;

    if(count > 0) {
      native_int i;
      for(i = count; i > 0; i--) {
        uint8_t c = bytes[i-1];
        if(c != ' ' && c != '\0')
          break;
      }
      string = String::create(state, bytes, i);
    } else {
      string = String::create(state, 0, 0);
    }

    array->append(state, string);
    unpack::increment(index, count, bytes_size);
  }
	break;
	case 67:
	{
    array->append(state, String::create(state, bytes, count));

    unpack::increment(index, count, bytes_size);
  }
	break;
	case 68:
	{
    native_int c;
    for(c = 0; c < count; c++) {
      if(bytes[c] == '\0') break;
    }
    array->append(state, String::create(state, bytes, c));

    if(rest) {
      unpack::increment(index, c < count ? c + 1 : count, bytes_size);
    } else {
      unpack::increment(index, count, bytes_size);
    }
  }
	break;
	case 69:
	{
    for(; index < stop; index += RBX_SIZEOF_LONG) {
      array->append(state, cNil);
      if(count > 0) count--;
    }
  }
	break;
	case 70:
	{
    unpack::increment(index,
                      bytes - ((const char*)self->byte_address() + index),
                      bytes_size);
  }
	break;
	case 71:
	{
    array->append(state, unpack::bit_high(state, bytes, count));
  }
	break;
	case 72:
	{
    array->append(state, unpack::bit_low(state, bytes, count));
  }
	break;
	case 73:
	{
    array->append(state, unpack::hex_high(state, bytes, count));
  }
	break;
	case 74:
	{
    array->append(state, unpack::hex_low(state, bytes, count));
  }
	break;
	case 75:
	{
    array->append(state, unpack::quotable_printable(state, bytes, bytes_end, remainder));
  }
	break;
	case 76:
	{
    array->append(state, unpack::base64_decode(state, bytes, bytes_end, remainder));
  }
	break;
	case 77:
	{
    unpack::utf8_decode(state, array, bytes, bytes_end, count, index);
  }
	break;
	case 78:
	{
    array->append(state, unpack::uu_decode(state, bytes, bytes_end, remainder));
  }
	break;
	case 79:
	{
    unpack::ber_decode(state, array, bytes, bytes_end, count, index);
    index = bytes - (const char*)self->byte_address();
  }
	break;
	case 80:
	{
    unpack::non_native_error(state, *p);
  }
	break;
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	const char *__acts = _actions + _eof_actions[cs];
	unsigned int __nacts = (unsigned int) *__acts++;
	while ( __nacts-- > 0 ) {
		switch ( *__acts++ ) {
	case 3:
	{
    count = 0;
    rest = true;
  }
	break;
	case 5:
	{
    width = 1;
  }
	break;
	case 6:
	{
    width = 2;
  }
	break;
	case 7:
	{
    width = 4;
  }
	break;
	case 8:
	{
    width = 8;
  }
	break;
	case 9:
	{
#if RBX_SIZEOF_LONG == 4
    width = 4;
#else
    width = 8;
#endif
  }
	break;
	case 10:
	{
    if(!rest) {
      stop = index + width * count;
    }

    if(rest || stop > bytes_size) {
      assert(width);
      stop = index + ((bytes_size - index) / width) * width;
    }
  }
	break;
	case 11:
	{
    for(; count > 0; count--) {
      array->append(state, cNil);
    }
  }
	break;
	case 12:
	{
    unpack_integer(ubyte);
  }
	break;
	case 13:
	{
    unpack_integer(sbyte);
  }
	break;
	case 14:
	{
    unpack_integer(u2bytes);
  }
	break;
	case 15:
	{
    unpack_integer(u2bytes_le);
  }
	break;
	case 16:
	{
    unpack_integer(u2bytes_be);
  }
	break;
	case 17:
	{
    unpack_integer(s2bytes);
  }
	break;
	case 18:
	{
    unpack_integer(s2bytes_le);
  }
	break;
	case 19:
	{
    unpack_integer(s2bytes_be);
  }
	break;
	case 20:
	{
    unpack_integer(u4bytes);
  }
	break;
	case 21:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 22:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 23:
	{
    unpack_integer(s4bytes);
  }
	break;
	case 24:
	{
    unpack_integer(s4bytes_le);
  }
	break;
	case 25:
	{
    unpack_integer(s4bytes_be);
  }
	break;
	case 26:
	{
    unpack_integer(u4bytes);
  }
	break;
	case 27:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes);
#else
    unpack_integer(u8bytes);
#endif
  }
	break;
	case 28:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 29:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 30:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes_le);
#else
    unpack_integer(u8bytes_le);
#endif
  }
	break;
	case 31:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(u4bytes_be);
#else
    unpack_integer(u8bytes_be);
#endif
  }
	break;
	case 32:
	{
    unpack_integer(s4bytes);
  }
	break;
	case 33:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes);
#else
    unpack_integer(s8bytes);
#endif
  }
	break;
	case 34:
	{
    unpack_integer(s4bytes_le);
  }
	break;
	case 35:
	{
    unpack_integer(s4bytes_be);
  }
	break;
	case 36:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes_le);
#else
    unpack_integer(s8bytes_le);
#endif
  }
	break;
	case 37:
	{
#if RBX_SIZEOF_LONG == 4
    unpack_integer(s4bytes_be);
#else
    unpack_integer(s8bytes_be);
#endif
  }
	break;
	case 38:
	{
    unpack_integer(u4bytes_be);
  }
	break;
	case 39:
	{
    unpack_integer(u2bytes_be);
  }
	break;
	case 40:
	{
    unpack_integer(u4bytes_le);
  }
	break;
	case 41:
	{
    unpack_integer(u2bytes_le);
  }
	break;
	case 42:
	{
    unpack_integer(u8bytes);
  }
	break;
	case 43:
	{
    unpack_integer(u8bytes_le);
  }
	break;
	case 44:
	{
    unpack_integer(u8bytes_be);
  }
	break;
	case 45:
	{
    unpack_integer(s8bytes);
  }
	break;
	case 46:
	{
    unpack_integer(s8bytes_le);
  }
	break;
	case 47:
	{
    unpack_integer(s8bytes_be);
  }
	break;
	case 48:
	{
    unpack_double;
  }
	break;
	case 49:
	{
    unpack_double_le;
  }
	break;
	case 50:
	{
    unpack_float_le;
  }
	break;
	case 51:
	{
    unpack_float;
  }
	break;
	case 52:
	{
    unpack_double_be;
  }
	break;
	case 53:
	{
    unpack_float_be;
  }
	break;
	case 54:
	{
    if(rest) count = bytes_size - index;
    index -= count;
  }
	break;
	case 55:
	{
    if(rest) {
      index = bytes_size;
    } else {
      index += count;
    }
  }
	break;
	case 56:
	{
    if(!rest) {
      index = count;
    }
  }
	break;
	case 57:
	{
    if(index < 0 || index > bytes_size) {
      unpack::outside_of_string(state, *p);
    }
  }
	break;
	case 58:
	{
    bytes = (const char*)self->byte_address() + index;
  }
	break;
	case 59:
	{
    bytes_end = (const char*)self->byte_address() + bytes_size;
  }
	break;
	case 60:
	{
    width = 1;
  }
	break;
	case 61:
	{
    width = 8;
  }
	break;
	case 62:
	{
    width = 2;
  }
	break;
	case 63:
	{
    remainder = bytes_size - index;
  }
	break;
	case 64:
	{
    if(rest) {
      count = remainder;
    } else if(count > remainder) {
      count = remainder;
    }
  }
	break;
	case 65:
	{
    if(rest || count > remainder * width) {
      count = remainder * width;
    }
  }
	break;
	case 66:
	{
    String* string;

    if(count > 0) {
      native_int i;
      for(i = count; i > 0; i--) {
        uint8_t c = bytes[i-1];
        if(c != ' ' && c != '\0')
          break;
      }
      string = String::create(state, bytes, i);
    } else {
      string = String::create(state, 0, 0);
    }

    array->append(state, string);
    unpack::increment(index, count, bytes_size);
  }
	break;
	case 67:
	{
    array->append(state, String::create(state, bytes, count));

    unpack::increment(index, count, bytes_size);
  }
	break;
	case 68:
	{
    native_int c;
    for(c = 0; c < count; c++) {
      if(bytes[c] == '\0') break;
    }
    array->append(state, String::create(state, bytes, c));

    if(rest) {
      unpack::increment(index, c < count ? c + 1 : count, bytes_size);
    } else {
      unpack::increment(index, count, bytes_size);
    }
  }
	break;
	case 69:
	{
    for(; index < stop; index += RBX_SIZEOF_LONG) {
      array->append(state, cNil);
      if(count > 0) count--;
    }
  }
	break;
	case 70:
	{
    unpack::increment(index,
                      bytes - ((const char*)self->byte_address() + index),
                      bytes_size);
  }
	break;
	case 71:
	{
    array->append(state, unpack::bit_high(state, bytes, count));
  }
	break;
	case 72:
	{
    array->append(state, unpack::bit_low(state, bytes, count));
  }
	break;
	case 73:
	{
    array->append(state, unpack::hex_high(state, bytes, count));
  }
	break;
	case 74:
	{
    array->append(state, unpack::hex_low(state, bytes, count));
  }
	break;
	case 75:
	{
    array->append(state, unpack::quotable_printable(state, bytes, bytes_end, remainder));
  }
	break;
	case 76:
	{
    array->append(state, unpack::base64_decode(state, bytes, bytes_end, remainder));
  }
	break;
	case 77:
	{
    unpack::utf8_decode(state, array, bytes, bytes_end, count, index);
  }
	break;
	case 78:
	{
    array->append(state, unpack::uu_decode(state, bytes, bytes_end, remainder));
  }
	break;
	case 79:
	{
    unpack::ber_decode(state, array, bytes, bytes_end, count, index);
    index = bytes - (const char*)self->byte_address();
  }
	break;
	case 81:
	{
    return array;
  }
	break;
		}
	}
	}

	_out: {}
	}



    if(en_main) {
      // do nothing
    }

    return force_as<Array>(Primitives::failure());
  }
}
